dpkg (1.23.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-source: Do not error out on empty fields. Closes: #1125985
  * Perl modules:
    - Dpkg::Email::Address: Do not construct invalid objects.
    - Dpkg::Control::FieldsCore: Improve Maintainer and Uploader field parse
      errors.
  * Documentation:
    - man: Improve dpkg-buildpackage --sign-backend description.
  * Build system:
    - Move the dist artifacts to the release directory.
  * Test suite:
    - Add known exception sources for ProhibitCaptureWithoutTest.

 -- Guillem Jover <guillem@debian.org>  Fri, 23 Jan 2026 01:41:44 +0100

dpkg (1.23.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Revert "Dpkg::Vendor: Add branch hardening flags to LDFLAGS".
    Closes: #1125323, #1125715
  * start-stop-daemon: Check for invalid combinations of --notify-await
    options. Closes: #1124643
  * dpkg: Fix typo for «metadata» in error message. Closes: #1125128
  * scripts: Parse and validate Maintainer and Uploaders email addresses.
  * dpkg-source: Warn when the Uploaders field contains the Maintainer.
  * Perl modules:
    - Dpkg::BuildProfiles: Remove the parser workaround now that dh-exec is
      fixed.
    - Dpkg::Shlibs::Symbol: Emit a warning for the deprecated wildcard syntax.
      Closes: #1125722
    - Dpkg::Source::Package::V2: Switch generated patch to be git formatted.
    - Dpkg::Source::Package::V2: Print Bug-<Vendor> in patch template instead
      of vendor specific ones.
    - Dpkg::Email::Address: New module.
    - Dpkg::Control::FieldsCore: Add new email address field parsing functions.
    - Dpkg::Shlibs::SymbolFile: Refactor metavariable substitution into a
      function.
    - Dpkg::Shlibs::SymbolFile: Add support for #CURVER#. Closes: #615940
  * Documentation:
    - dpkg-buildflags(1): Clarify that LDFLAGS are not safe for direct ld(1)
      use. See #1125323.
    - start-stop-daemon(8): Clarify relationship between --notify-await and
      --background. See #1124643.
    - man: Refactor explanation about deb-symbols metavariables.
  * Code internals:
    - dselect: Mark keybindings methods only accessing static members as
      static.
    - dpkg-deb: Reduce pid variable scope.
    - libcompat: Define __has_attribute() if not already defined in gettext.h.
  * Packaging:
    - Bump Standards-Version to 4.7.3 (no changes needed).
  * Test suite:
    - Undefine _LIBC for cppcheck.
    - Update cppcheck suppressions for 2.19.0.
  * Localization:
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1125463, #1125465, #1125466
    - Update Portuguese translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.
      Closes: #1124138, #1124412, #1124439, #1124636

 -- Guillem Jover <guillem@debian.org>  Sun, 18 Jan 2026 18:29:23 +0100

dpkg (1.23.3) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Vendor::Debian: Mask PIE on m68k, sh4 and x32.
      Thanks to Adrian Bunk <bunk@debian.org>. Closes: #1100187
    - Dpkg::Version: Add new has_epoch() and has_revision() methods.
      Closes: #1123630
    - Dpkg::Source::Package::V1: Make debian/rules executable on extract if
      present. Closes: #1123652

 -- Guillem Jover <guillem@debian.org>  Sat, 20 Dec 2025 02:18:49 +0100

dpkg (1.23.2) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildProfiles: Add workaround for callers passing invalid formulas.
      Diagnosed by Chris Hofstaedtler <zeha@debian.org>.

 -- Guillem Jover <guillem@debian.org>  Thu, 18 Dec 2025 02:10:10 +0100

dpkg (1.23.1) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildProfiles: Add missing Dpkg::Gettext and Dpkg::ErrorHandling
      imports. Closes: #1123515
  * Test suite:
    - Add a test for negated build profiles.
      Prompted by Chris Hofstaedtler <zeha@debian.org> (on IRC).

 -- Guillem Jover <guillem@debian.org>  Wed, 17 Dec 2025 13:10:07 +0100

dpkg (1.23.0) unstable; urgency=medium

  [ Guillem Jover ]
  * Pass --format=xz explicitly to xz on decompression.
  * dpkg-divert: Clarify default behavior change timeline.
  * dpkg: Remove obsolete --forget-old-unavail from --help output.
  * Add vendor specific support for fuzzy source vs version nativeness.
    Closes: #737634
  * dpkg-deb: Fix cleanup for control member with restricted directories.
    Reported by zhutyra on HackerOne.
  * dpkg: Use maintscript name instead of untranslated description in error
    messages.
  * dpkg: Unify maintainer script error messages.
  * dpkg: Print maintscript fallback success message after finishing actions.
  * Improve subprocess exit message.
  * update-alternatives: Move debug message from call site into
    alternative_prepare_install().
  * Shallow pass at clarifying debug messages.
  * update-alternatives: Clarify in --help output that the «...» refers to
    --slave.
  * dpkg-query: Improve --list header ASCII art.
    Suggested by No Comment <mowglithemaniac@gmail.com>.
  * dselect, libdpkg: Use Ctrl+<name> instead of ^<name> in messages.
  * dpkg-split: Obsolete --msdos option which no longer does anything.
  * Remove support for MSDOS-Filename field.
  * dpkg-shlibdeps: Add a debug print when overriding file to package mappings.
    See #1115395.
  * Use invalid instead of illegal in symbol names and output messages.
  * dpkg: Improve commands acting on the available file from standard input.
    Closes: #1119906
  * Use «package metadata» instead of «control information».
  * dpkg: Use MAXCONTROLFILENAME instead of 50 or 250 in format string
    precision.
  * dpkg-split: Mark strings for translation.
  * start-stop-daemon: Update list of change contributors.
  * Do not use contractions in output messages.
  * Reword --help options descriptions to fit again in 80 columns.
  * dpkg-source: Use Dpkg::BuildProfiles to parse the Build-Profiles field.
  * dpkg-source: Add a new profile:v1 property in Package-List field.
    See https://lists.debian.org/debian-devel/2025/11/msg00333.html.
  * Use valid instead of legal in output messages and code comments.
  * dpkg-source: Add support for --signer-certs option. Closes: #1110172
  * dpkg-source: Add new --no-vendor-certs extract option.
  * dpkg: Do not run the postinst during cleanup if the previous state was bad.
    Based on a patch by Ian Jackson <ian@davenant.greenend.org.uk>.
    Closes: #432893
  * dpkg: Mark reinstreq during unpack as late as possible, not before prerm.
    Thanks to Ian Jackson <ian@davenant.greenend.org.uk>.
  * Architecture support:
    - Accept sparcv9 as an alias for GNU CPU name sparc64.
    - Remove kopensolaris-any support.
      See commit 602261f1f3e3143b0b668d3ae185fb600b4ed18c.
      See https://github.com/dtbartle/glibc-opensolaris (2009-04).
      See https://github.com/ip1981/kopensolaris-glibc (2015-01).
    - Remove kfreebsd-any support.
      See https://lists.debian.org/debian-devel/2023/05/msg00306.html.
    - Remove support for powerpcspe.
  * Portability:
    - Use portable POSIX «cp» options -RPp instead -a.
  * Perl modules:
    - Dpkg::Vendor: Parametrize vendor and field names in diagnostic messages.
    - Dpkg: Bump PROGVERSION to 1.23.x.
    - Dpkg::Build::Info: Remove deprecated module.
    - Dpkg::OpenPGP::Backend::Sequoia: Do not run sq/sqv to verify with no
      keyrings. Closes: #1106148
    - Dpkg::OpenPGP::Backend::Sequoia: Run sq in stateless mode for
      verification.
      Suggested by Neal H. Walfield <neal@sequoia-pgp.org>.
    - Dpkg::Compression: Uncomment compression_get_property() deprecation
      warning.
    - Dpkg::Control::FieldsCore: Remove implicit argument use in
      field_transfer_single().
    - Dpkg::Shlibs::SymbolFile: Remove deprecated ignore blacklist support.
    - Dpkg::Source::Package: Move non-native version build check from 3.0
      (quilt) to 2.0.
    - Dpkg::Source::Package: Add format vs version coherence warnings on
      extract.
    - Dpkg::Source::Package::V1: Remove redundant -r option for cp.
    - Test::Dpkg: Refactor all_shell_files() function.
    - Test::Dpkg: Add all maintscripts to all_shell_files().
    - Test::Dpkg: Refactor all_pod_modules() function.
    - Test::Dpkg: Optimize modules skipping in all_pod_modules().
    - Test::Dpkg: Do not export directory getters.
    - Test::Dpkg: Refactor test files scan function.
    - Test::Dpkg: Extend all_shell_files() to return all shell scripts.
    - Dpkg::BuildDriver::DebianRules: Fix uninitialized Perl variables.
      Closes: #1107971
    - Dpkg::BuildDriver::DebianRules: Fix R³ dpkg/target/<target> values
      handling.
    - Dpkg::BuildDriver::DebianRules: Improve R³ dpkg/<keyword> fallback
      matching.
    - Dpkg::BuildTree: Fix needs_root() for R³ with implementation specific
      keywords. See #1107971.
    - Dpkg::SysInfo: Refactor number of processes retrieval into new module.
    - Dpkg::Shlibs: Remove DEB_TARGET_ARCH handling from setup_library_paths().
      Reported by Helmut Grohne <helmutg@debian.org>.
    - Dpkg::OpenPGP::Backend: Do not mark hint command as translatable.
    - Dpkg::Source::Package: Print a notice when verifying .dsc signatures.
    - Dpkg::Source::Package: Print the keyrings used during verification.
      Closes: #703364
    - Dpkg::OpenPGP: Add own error for missing keyrings in verify functions.
    - Dpkg::BuildDriver::DebianRules: Use a default debian_rules value.
    - Dpkg::Source::Package::V3::Git: Use «git submodule» for its status.
      Suggested by Daniel Gröber <dxld@darkboxed.org>. Closes: #1100413
    - Dpkg::OpenPGP: Do not run verify with no keyrings. Closes: #1111617
    - Dpkg::BuildDriver::DebianRules: Unify debian/rules fixer with source
      extract.
    - Dpkg::Source::Package: Remove debian/rules fixer at extract time.
      Closes: #1078764
    - Dpkg::IPC: Deprecate nocheck option and rename it to no_check.
    - Dpkg::Source::Patch: Deprecate nofinish option and rename it to
      no_finish.
    - Dpkg::Deps::Simple: Move dependency regex into its own variable.
    - Dpkg::Compression: Move global regexes into
      compression_get_file_extension_regex.
    - Dpkg::OpenPGP::Backend::GnuPG: Use TEMPLATE instead of argument in
      newdir.
    - Dpkg::Source: Rename $tmp to $tmpdir.
    - Dpkg::OpenPGP::Backend::SOP: Switch _sop_exec to get all options in a
      hash.
    - Dpkg::Shlibs::SymbolFile: Switch wantarray from a ternary operator to
      if/else.
    - Dpkg::Shlibs::SymbolFile: Rename file option to filename.
    - Dpkg::Changelog::Parse: Deprecate file option and rename it to filename.
    - Dpkg::Lock: Restructure file_lock code to make it easier to add fallback.
    - Dpkg::Lock: Avoid using eval for the File::FcntlLock new and lock calls.
    - Dpkg::Lock: Fallback to use File::FcntlLock::Pure if File::FcntlLock
      fails.
    - Dselect::Method::Config: New module.
    - Dselect::Method::Media: New module to refactor get_disk_label().
    - Dpkg::Vendor: Add branch hardening flags to LDFLAGS.
      Thanks to Simon Chopin <schopin@ubuntu.com>. Closes: #1115292
    - Test::Dpkg: Rename test_needs_srcdir_switch() to test_chdir_srcdir().
    - Dpkg::Shlibs: Use a hash to track libdir repeats when parsing ld.so.conf.
    - Dpkg::Shlibs: Assign from s///r instead of via topic variable.
    - Dpkg::Shlibs::Objdump::Object: Do not assign readline to $_ on discard.
    - Dpkg::Vendor::Debian: Add comment about current state of -fcf-protection.
    - Dpkg::BuildInfo: Allow LFLAGS (lex/flex) and YFLAGS (yacc/bison)
      variables.
    - Dpkg::BuildInfo: Allow LANGUAGE variable.
    - Dpkg::BuildInfo: Allow LOCPATH, NLSPATH, I18NPATH and GCONV_PATH
      variables.
    - Dpkg::BuildInfo: Allow TZ, TZDIR and DATEMSK variables.
    - Dpkg::BuildInfo: Allow ld.so run-time variables.
    - Dpkg::BuildInfo: Allow resolver specific variables.
    - Dpkg::BuildInfo: Allow POSIXLY_CORRECT and GETCONF_DIR variables.
    - Dpkg::BuildProfiles: Add new build_profile_is_invalid function.
    - Dpkg::BuildProfiles: Make parser more strict. Closes: #1121657
    - Dpkg::Shlibs::Objdump::Object: Add support for "Version References"
      symbols. Closes: #1122107
    - Dpkg::Source::Package: Deprecate implicit trusted GnuPG keyrings.
    - Dpkg::OpenPGP::Backend::GnuPG: Deprecate KeyBox formatted keyrings.
    - Dpkg::Vendor::Debian: Use .pgp keyrings instead of .gpg ones.
    - Dpkg::Vendor::Devuan: Use .pgp keyrings instead of .gpg ones.
    - Dpkg::Control::FieldsCore: Deprecate SC field export rules in binary
      stanza. Prompted by Richard Hansen <rhansen@rhansen.org>.
      See https://bugs.debian.org/1117566.
    - Dpkg::Control::FieldsCore: Do not autovivify %FIELDS entries on getters.
    - Dpkg::Substvars: Add support for implicit substvars assigned with $=.
  * Make fragments:
    - Switch to use GNU make intcmp instead of relying on shell.
      Prompted by Sean Whitton <spwhitton@spwhitton.name>.
      See https://lists.debian.org/debian-devel/2025/12/msg00039.html.
  * Documentation:
    - doc: Make README.* files fully machine readable.
    - doc: Add space after comment and TODO/XXX marker.
    - man: Clarify when dpkg-maintscript-helpers might need Pre-Depends on
      dpkg. Closes: #1108386
    - man: Document DEB_BUILD_PROFILES in all tools honoring the env variable.
    - man: Add a reference to build profiles in dpkg-buildflags.
      Closes: #1026319
    - man: Itemize deb(5) and deb-split(5).
    - man: Fix DPKG_ROOT documentation in dpkg(1). Closes: #1110873
    - man: Document DPKG_ROOT also as an external environment variable for
      dpkg.
    - man: Switch from .orig-<component>.tar to .orig-<addon>.tar.
      Closes: #1095231
    - man: Clarify that the archive described is the ar archive in a .deb.
    - man: Update control examples in deb-control(5) and deb-src-control(5).
    - man: Add lost detail about parts of a deb-changelog(5) getting ignored.
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Use proper L<> markup for man page references.
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Use «directory» instead of «dir» for dpkg option arguments.
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Add missing dpkg in «supported since» sentence in deb(5).
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Match plural forms in parentheticals in dpkg-buildflags(1).
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Add Multi-Arch field to dpkg-query known fields.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>. Closes: #1115250
    - doc: Update references to mixed old and new C/C++ coding styles.
    - doc: Document test suite specific environment variables in README.
    - man: Use command instead of action for dpkg command options.
    - man: Clarify build profiles syntax.
    - man: Document accepted syntax for architecture names.
    - man: Improve architecture documentation.
      Prompted by Helmut Grohne <helmut@subdivi.de>.
    - man: Clarify binary stanza default field values and inheritance rules.
    - man: Itemize deb-substvars operators.
  * Code internals:
    - Quote variables in shell scripts.
    - Disable intentional or false-positive shellcheck checks.
    - perl: Switch to use 0o prefix for octal literals.
    - perl: Switch to «use v5.36» instead of «use strict» and «use
      warnings».
    - libdpkg: Do not segfault when adding triggers in no-act mode.
      Closes: #1108192
    - dpkg: Switch from m_asprintf() to str_fmt().
    - dpkg: Fix memory leak in maintscript_fallback().
    - dpkg: Rename maintscript description variable from buf to scriptdesc.
    - libdpkg: Enable meminfo_get_available() on GNU/Hurd.
      Prompted by Helmut Grohne <helmut@subdivi.de>.
      See https://lists.debian.org/debian-dpkg/2024/12/msg00004.html.
    - dpkg: Add a translator comment for the summarized pathname message.
    - libdpkg: Print () after function name in internerr message.
    - libdpkg: Add support for debug_at() to print debug messages at a
      function.
    - libdpkg, dpkg: Use debug_at() instead of debug() to print function name.
    - dpkg: Rename maintscript_exec() warn argument to subproc_opts.
    - dpkg: Pass cidir and cidirrest before scriptname to maintscript
      functions.
    - dpkg: Rename maintscript execution functions.
    - dpkg-gencontrol: Remove unused Dpkg::BuildProfiles import.
    - scripts: Replace some POSIX imports with Fcntl module.
    - libdpkg: Switch status abbreviations from char to strings.
    - perl: Rename regular expression variables from *_re to *_regex.
    - perl: Fix indentation.
    - perl: Remove unused File::Temp imports.
    - perl: Switch from tempfile()/tempdir() to OOP File::Temp interfaces.
    - perl: Move File::Find::find() options into an actual hashref variable.
    - perl: Fix indentation for list, listrefs and hashref variable
      definitions.
    - perl: Fix indentation for function calls with hash, hashref and listref
      arguments.
    - perl: Remove feature pragmas implied by «use VERSION».
    - Change TRANSLATORS comments style to get better extraction by gettext.
    - dselect: Remove unused __END__ markers in methods Perl modules.
    - dselect: Use Dpkg::Version in method scripts instead of calling dpkg.
    - dselect: Fix Perl syntax in methods scripts (duped parenthesis).
    - dselect: Fix Perl syntax in methods scripts (unbalanced quoting).
    - dselect: Use HERE document instead of multi-line string in method script.
    - dselect: Remove unnecessary trailing semicolon in method scripts.
    - dselect: Add missing Version field parsing to method scripts.
    - dselect: Fix variables declaration in «my» operator in media method
      script.
    - dselect: Fix open() calls in method scripts.
    - dselect: Close file descriptors in method scripts.
    - dselect: Use foreach loops instead of C-style loops in method scripts.
    - dselect: Declare Perl variables in method scripts with my.
    - dselect: Use chdir instead of non-existent cd function in method script.
    - dselect: Use {} for regex substitution operators in method scripts.
    - dselect: Remove useless topic variable use in split calls in method
      scripts.
    - dselect: Use foreach instead of map in void context in method script.
    - dselect: Use an array variable instead of reusing @_ in method script.
    - dselect: Do not mix high and low-precedence boolean operators.
    - dselect: Do not use mixed-case variable names in method scripts.
    - dselect: Rewrite all methods install scripts from shell to Perl.
    - dselect: Use intermediate variable for substr handling in method scripts.
    - dselect: Remove unused $iarch variable in method script.
    - dselect: Remove unnecessary intermediate variables in method script.
    - dselect: Use Oo as octal prefix in method scripts.
    - dselect: Do not use unusual delimiter for tr in method script.
    - dselect: Do not use boolean operators for code flow except for dying.
    - dpkg-architecture: Make architecture variables assignment more clear.
    - scripts: Remove unnecessary terminating 0 in scripts.
    - perl: Switch from hard tabs to spaces.
    - perl: Place label before loop keyword.
    - perl: Fix code indentation.
    - perl: Place each statement into its own line.
    - perl: Fix space style.
    - perl: Fix format and contents of code comments.
    - dpkg-shlibdeps: Rename global $i to $depstrength.
    - perl: Place each statement into its own line (round two).
    - perl: Fix format and contents of code comments (round two).
    - perl: Fix space style (round two).
    - perl: Fix code indentation (round two).
    - perl: Remove unnecessary parenthesis around single «my» variables.
    - dselect: Do not use boolean operators for code flow except for dying
      (round two).
    - dselect: Use named variables instead of topic variable in foreach loops.
    - libdpkg: Do an early continue in run_cleanups to reduce nesting level.
    - lib, src: Fix code formatting style of C code (round one).
    - dselect: Rework curses enable/disable functions to reduce nesting level.
    - dselect: Fix code formatting style of C++ code (round one).
    - start-stop-daemon: Change xmalloc() size argument type from int to
      size_t.
    - libcompat: Add support for __format_arg__ attribute.
    - libcompat: Mark gettext functions with __format_arg__ attribute.
    - dselect: Give a context string to keybinding translations.
    - Stop using length limited format strings (%.255s/%.250s/%.100s/%.50s).
    - libdpkg: Double the emergency error message buffer size.
  * Build system:
    - Bump minimal Perl version to 5.36.0.
    - Automatically set test parallelism from make parallelism.
    - Add new authordistcheck convenience rule.
    - Add a function definition to compile for the flags checks.
    - Add support for SHORT_TESTING to avoid running cppcheck.
    - Disable po4a warning that nags about switch to SimplePod.
    - Add an editorconfig file.
  * Packaging:
    - Use local keyword for function scoped variable in maintscript.
    - Add libselinux-dev in Build-Depends as alternative to libselinux1-dev.
    - Remove «Rules-Requires-Root: no», which is the current default.
  * Test suite:
    - Use $* instead of $@ when assigning into a string.
    - Use $() instead of legacy `` for shell command expansion.
    - Update dselect shell methods files list.
    - Check shell files pending fixes from shellcheck tests as TODO.
    - Move Perl version use pragmas as the first things to declare.
    - Pass soname as a scalar in Dpkg::Shlibs::Symbol->lookup_symbol calls.
    - Test that we do not allow «anyfoo» as an arch wildcard.
    - Remove unnecessary semicolon after loop block.
    - Hardcode number of invariant tests instead of dynamically computing them.
    - Move test plan to Test::More import.
    - Do not exit explicitly after a «plan skip_all».
    - Move update-alternatives test plan as early as possible in the test file.
    - Move use_ok() calls immediately after use imports.
    - Switch from «use_ok» to «use ok» for import checks.
    - Remove duplicate semicolon after statement.
  * Localization:
    - Add English UTF-8 translations.
    - Unfuzzy translations after contraction removal changes.
    - Unfuzzy translations after format string changes.
    - Update Catalan translations.
    - Update Portuguese scripts translation.
    - Update Swedish scripts translation.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 16 Dec 2025 22:21:13 +0100

dpkg (1.22.19) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Vendor::Debian: Add tag2upload OpenPGP keyring to package-keyrings.
    - Dpkg::Vendor::PureOS: Add new vendor module.
      Thanks to Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>.
    - Test::Dpkg: Fix OpenPGP backend commands detection.
    - Dpkg::OpenPGP::Backend::Sequoia: Add sqv support for verification.
  * Code internals:
    - libcompat: Handle allocation failures in fgetpwent() and fgetgrent().
      Based on a patch by Simon Richter <sjr@debian.org>.
  * Packaging:
    - Document OpenPGP implementation dependencies.
      Prompted by Paul Gevers <elbrus@debian.org>.
  * Localization:
    - Update Brazilian Portuguese programs translation.
      Thanks to Paulo Henrique de Lima Santana <phls@debian.org>.
      Closes: #1100999
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1101574, #1101582, #1101583
    - Update Portuguese translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.
      Closes: #1100064, #1105126
    - Update Romanian translations.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1101549, #1101550
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1100068

 -- Guillem Jover <guillem@debian.org>  Mon, 19 May 2025 00:00:44 +0200

dpkg (1.22.18) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Add missing Dpkg::Gettext import.
      Thanks to Yuri Konotopov <ykonotopov@gnome.org>. Closes: #1099866
  * Packaging:
    - Bump Standards-Version to 4.7.2 (no changes needed).

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 09 Mar 2025 19:00:01 +0100

dpkg (1.22.17) unstable; urgency=medium

  * Code internals:
    - libdpkg: Do not crash on missing sysuser or sysgroup system database
      files. Reported by Marc Haber <mh+debian-packages@zugschlus.de>.

 -- Guillem Jover <guillem@debian.org>  Fri, 07 Mar 2025 12:07:23 +0100

dpkg (1.22.16) unstable; urgency=medium

  [ Guillem Jover ]
  * Add support for native arch definition for chroots.
    Closes: #825385, #1020533
  * dpkg-db-keeper: Fix pathname in example dpkg.cfg snippet.
  * Portability:
    - start-stop-daemon: Move <compat.h> and <dpkg/macros.h> after OS and
      header setup macros.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::GnuPG: Do not require cmdstore for backend
      command.
    - Dpkg::OpenPGP::Backend: Generalize has_verify_cmd().
    - Dpkg::OpenPGP::Backend: Support disabling cmd and cmdv via 'none' value.
    - Dpkg::OpenPGP::Backend::SOP: Add sopv support.
    - Dpkg::OpenPGP::Backend::GnuPG: Refactor newline workaround into a
      function.
    - Dpkg::OpenPGP::Backend::GnuPG: Do not add the newline workaround for
      gpg-sq.
    - Dpkg::OpenPGP::Backend::Sequoia: Add a hint about authorizing own keys.
    - Dpkg::OpenPGP::Backend::Sequoia: Refactor cmd and cmdv handling.
  * Documentation:
    - man: Remove trailing space. Closes: #1095542
    - doc: Remove trailing angle bracket.
    - doc: Split and sort copyright statements.
  * Code internals:
    - libdpkg: Add new strvec module.
    - libdpkg: Add new path_canonicalize() function.
    - libdpkg: Add new file_realpath() function.
    - libdpkg: Add new file_canonicalize() function.
    - libdpkg: Normalize root dir setting.
    - libdpkg: Remove unused pwd.h and grp.h header includes.
    - libdpkg: Refactor passwd and group fetching into functions.
    - libdpkg: Cache root user/group to UID/GID mapping to speed up unpacking.
    - libdpkg: Update missing symbols to the version map.
    - start-stop-daemon: Move Solaris _FILE_OFFSET_BITS undef after other
      header setup macros.
    - dselect, test: Mark C++ destructors on derived classes as override.
    - start-stop-daemon: Reformat license/copyright comment header.
    - libcompat: Add compatibility functions for fgetpwent() and fgetgrent().
    - libdpkg: Add support for sysuser/sysgroup specific to each chroot.
      Closes: #1033051
  * Build system:
    - Avoid explicitly escaped hash characters in automake files.
  * Packaging:
    - Add OpenPGP tools to Build-Depends as pkg.dpkg.author-testing build
      profile.
    - Move gnupg and gpgv as the last alternatives.
    - Add a NEWS entry to dpkg-dev for Rules-Requires-Root default change.
  * Test suite:
    - Skip OpenPGP backend tests based on available cmd and cmdv programs.
    - Rework OpenPGP backend selection to prepare for cmdv support.
    - Add OpenPGP cmdv testing support.
    - Refactor database files creation into new DPKG_GEN_DB_FILE macro.
    - Update cppcheck to request C++14 to match expected baseline.
    - Pass --root-owner-group to dpkg-deb in functional tests.
  * Localization:
    - Update Brazilian Portuguese translations.
      Thanks to Paulo Henrique de Lima Santana <phls@debian.org>.
      Closes: #1098464, #1099687
    - Update Dutch man pages translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1095412

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 07 Mar 2025 03:03:55 +0100

dpkg (1.22.15) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildDriver::DebianRules: Remove unused Dpkg::BuildAPI import.
    - Dpkg::OpenPGP::Backend::GnuPG: Sign file with fixed up newline.
    - Dpkg::Substvars: Add new set_as_optional() and set_as_required() methods.
  * Documentation:
    - man: Change verb tense for Makefile fragment files descriptions.
    - man: Document that buildapi.mk sets a variable.
    - man: Add reference to buildtools and vendor make fragments to related
      tools.
    - man: Split architecture examples into their own paragraphs.
    - man: Clarify architecture terms and the architecture forms.
    - man: Clarify that build and target are not usual variables to use.
    - doc: Remove duplicate words across newlines.
      Thanks to Michael Biebl <biebl@debian.org>. Closes: #1093548
  * Build system:
    - Add array bounds warning.
    - Add new dialect checks for strict flex array behavior and warnings.
    - Add compiler hardening support.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Mon, 03 Feb 2025 12:01:24 +0100

dpkg (1.22.14) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Switch from info() to hint() for hint message.
  * Perl modules:
    - Dpkg::BuildDriver::DebianRules: Fix R³ namespace check to only refuse
      unknown dpkg keywords. Closes: #1092653
  * Make fragments:
    - Use flavor to avoid re-caching empty variables. See #1092051.
  * Shell library:
    - Abstract color clearing with a new variable.
    - Lowercase and namespace private variables with _dpkg_.
    - Fix debug output format to print debug in lowercase after progname.
    - Document library interface basics and the version when introduced.
    - Add support for notice(), info() and hint() functions.
  * Code internals:
    - libdpkg: Add support for hint printing.
  * Test suite:
    - Remove redundant <cstdbool> include deprecated in C++17.
  * Localization:
    - Update Brazilian Portuguese dselect translations.
      Thanks to Paulo Henrique de Lima Santana (phls) <phls@debian.org>.
      Closes: #1092593

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 16 Jan 2025 03:56:38 +0100

dpkg (1.22.13) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add support for filesystem metadata checks.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Handle all KeyHandle types in
      inline_sign(). See #1091915.
    - Dpkg::OpenPGP::Backend::Sequoia: Check whether we can use the key.
      Closes: #1091915
    - Dpkg::OpenPGP::Backend: Add missing imports. Closes: #1091990
    - Dpkg::BuildDriver::DebianRules: Change default R³ value to «no».
  * Documentation:
    - man: Document the version since the Section and Priority fields have
      defaults.
    - man: Clarify Priority values by mentioning known important and unknown
      ones.
    - man: Clarify Section and Priority values usage tied to distribution
      policies.
    - man: Refer to --sign-keyid instead of --sign-key in DEB_SIGN_KEYID
      description.
  * Code internals:
    - libdpkg: Add test cases for varbuf C++ operators.
    - libdpkg: Do not call varbuf_init() from operator=().
    - dselect: Make sure the search varbuf always has allocated space.
      See #1091898.
    - dselect: Update the search varbuf to account for the used size.
      Closes: #1091898
    - dselect: Fix logic inversion in repeat search keybinding.
    - dselect: Fix formatting for return in keybindings::find().
    - scripts: When printing a field value quote it with double quotes.
    - dpkg-gencontrol: Add missing field name to warning message. See #1091941.
    - dpkg-genchanges: Set Section and Priority defaults even with no fields.
      Closes: #1091941

 -- Guillem Jover <guillem@debian.org>  Fri, 03 Jan 2025 11:47:15 +0100

dpkg (1.22.12) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Check for pager presence and fallback to less, more and cat.
    Closes: #856216
  * dpkg-shlibdeps: Add symbolic name alternative to --warnings bits.
  * Update URLs.
  * dpkg-deb: Add --no-check option and keep --nocheck as an alias.
  * dpkg: Unify package and version printing format to «package (version)».
  * dpkg-buildtree: Add new command is-rootless.
    Suggested by Niels Thykier <niels@thykier.net>.
  * scripts: Switch messages to be hints.
  * dpkg-buildpackage: Reword hint on unsatisfied dependencies. Closes: #817955
  * dpkg-checkbuilddeps: Improve unmet dependency error messages.
  * dpkg-buildpackage: Switch unmet dependency abort message from warning to
    error.
  * scripts: Change and inject default value for Section and Priority fields.
  * Perl modules:
    - Dpkg::Deps::Multiple: Document that the constructor takes @deps not
      %opts.
    - Dpkg::Changelog::Parse: Use %opts instead of %opt in function POD.
    - Dpkg::Control: Deprecate the backwards compatibility type aliases.
    - Dpkg::OpenPGP::Backend::GnuPG: Ignore
      ValuesAndExpressions::ProhibitMagicNumbers.
    - Dpkg::Vendor: Simplify module loading logic.
    - Dpkg::OpenPGP::Backend::SOP: Add rsop as an alternative SOP
      implementation.
    - Dpkg::OpenPGP::Backend::SOP: Add gosop as an alternative SOP
      implementation.
    - Dpkg::OpenPGP::Backend::Sequoia: Adapt to new CLI 0.40.0 API.
    - Dpkg::OpenPGP::Backend::Sequoia: Add keystore support.
    - Dpkg::Shlibs: Improve code comments.
    - Dpkg::Archive::Ar: Copy only the number of bytes we have read.
    - Dpkg::Vendor: Remove backwards compatibility module and origin name
      mangling.
    - Dpkg::BuildInfo: Add GNUMAKEFLAGS as an allowed environment variable.
      Thanks to Santiago Vila <sanvila@debian.org>. Closes: #1090337
    - Dpkg::BuildDriver::DebianRules: Handle missing root_cmd option.
    - Dpkg::ErrorHandling: Add support for hint printing.
    - Dpkg::OpenPGP::Backend::GnuPG: Handle and warn on concatenated ASCII
      Armor blocks.
    - Revert "Dpkg::OpenPGP::Backend::GnuPG: Fallback to use «gpg dearmor» if
      present".
    - Dpkg::OpenPGP::Backend::GnuPG: Move armor/dearmor implementation to base
      class.
    - Dpkg::OpenPGP::Backend::SOP: Use the parent class armor/dearmor
      implementations.
    - Dpkg::Vendor::Debian: Remove merged-/usr taint logic.
    - Dpkg::Control::FieldsCore: Add new field_get_default_value() function.
  * Make fragments:
    - Document DPKG_BUILD_API in buildapi.mk.
    - Document public API and expected directory to include from.
      Prompted by Helmut Grohne <helmut@subdivi.de>.
    - Capitalize variable descriptions.
    - Clarify format for version variables from pkg-info.mk.
      See #1088244.
    - Add support for new DEB_VERSION_EPOCH and DEB_VERSION_REVISION.
      Closes: #1088244
  * Shell library:
    - Add a default PROGNAME to dpkg-error.sh.
    - Move setup_colors() contents into dpkg-error.sh script scope.
  * Documentation:
    - man: Update debian/control example in deb-src-control(5).
    - man: Use arch-bits in deb-src-symbols(5) example dependent on bitness.
    - man: Use modern architectures for manual page examples.
    - doc: Fix typos in ChangeLog.old.
    - man: Document purpose of origin files and how they tie to packages.
      See https://github.com/grml/grml-debian-keyring/issues/7.
    - man: Use «must» instead of «should» for mandatory behavior.
      Requested by Niels Thykier <niels@thykier.net>.
      See https://bugs.debian.org/1089794.
  * Code internals:
    - lib: Remove compatibility code for C++ earlier than C++11.
    - scripts: Use %opts instead of %options for constructor and function
      options.
    - scripts: Document when constructors take %opts.
    - scripts: Use %opts instead of %args for function and method options.
    - scripts: Rename changelog options in programs to %changelog_opts.
    - scripts: Unify constructor and function options documentation.
    - libdpkg: Remove const from execname.
    - libdpkg: Use size_t instead of unsigned int for nargs.
    - start-stop-daemon: Refactor closefrom() and use it only if the system
      lacks it.
    - start-stop-daemon: Try to use close_range() if present to implement
      closefrom().
    - scripts: Fix module loading.
      Prompted by Holger Levsen <holger@debian.org>.
      Prompted by Niels Thykier <niels@thykier.net>.
    - src: Do not name option variables as no<thing>.
    - dpkg-deb: Rename control area functions to check_ctrl_*().
    - dpkg-deb: Rename check_control_area() to check_build_files().
    - dpkg-deb: Fix doxygen comment to match function argument.
    - perl: Remove function prototypes.
    - libdpkg: Rename varbuf_rollback_start() to varbuf_rollback_end().
    - libdpkg: Rename varbuf_*printf() to varbuf_add_*fmt().
    - libdpkg: Add new varbuf_set_*fmt() functions.
    - dpkg: Switch from varbuf_reset()+varbuf_add_str() to varbuf_set_str().
    - Replace varbuf_reset()+varbuf_*printf() with varbuf_set_*fmt().
    - Replace varbuf_*printf() with varbuf_add_*fmt().
    - libdpkg: Rename varbuf C++ *fmt() methods to add_*fmt().
    - dpkg: Replace sprintf() usage with a varbuf in depisok().
    - Use snprintf() instead of sprintf().
    - libdpkg: Switch varbuf::reset() to use varbuf_reset().
    - libdpkg: Rename varbuf::string() to varbuf::str().
    - libdpkg: Add new varbuf C++ methods for all functions.
    - libdpkg: Add new varbuf_state C++ methods for all functions.
    - libdpkg: Add new varbuf C++ constructor initialized from a C string.
    - libdpkg: Add new varbuf C++ operator+= methods.
    - dselect: Switch from operator() to operator+=.
    - libdpkg: Remove varbuf C++ operator() methods.
    - libdpkg: Add new varbuf C++ len() method.
    - libdpkg: Add new varbuf_swap() function.
    - libdpkg: Add new varbuf C++ copy constructors.
    - libdpkg: Add new varbuf C++ move constructors.
    - libdpkg: Add new varbuf_array() and C++ operator[] methods.
    - dselect: Switch to use varbufs instead of sprintf in keybindings.
    - dselect: Switch to use varbufs instead of sprintf for searchstring.
    - dselect: Switch to use varbufs instead of sprintf for describemany().
    - dselect: Use file_slurp() instead of open-coding it.
    - dselect: Switch to use varbufs instead of sprintf for method parser.
    - dselect: Mark assignment inside baselist::kd_search() as a move
      assignment.
    - Cast char to unsigned char for ctype functions.
    - Remove dpkg-error.sh boilerplate.
    - scripts: Remove dpkg-fsys-usrunmess program.
    - dpkg-source: Generalize Package-List field attributes handling.
    - scripts: Unify handling of default Priority and Section values.
    - scripts: Switch to use the default per field value for Section and
      Priority.
  * Build system:
    - Make C++ baseline version a hard requirement.
    - Generalize C/C++ check macros to select the version as an argument.
    - Bump minimum required C++ standard to C++14.
    - Warn on C++17, C++20, C++23 and C++26 extensions usage.
    - Check for C++11 __func__ availability.
    - Undefine _TIME_BITS when checking for the base off_t size.
    - Do not use an obsolete x prefix for shell test checks.
    - Add a new changelog section for the shell library.
  * Packaging:
    - Bump Standards-Version to 4.7.0 (no changes needed).
    - Add a trailing comma to debian/tests/control dependency.
    - Inline sequoia-chameleon-gnupg dependencies depending on context.
    - Remove merged-/usr warning logic. Closes: #1061718
  * Test suite:
    - Enable ValuesAndExpressions::ProhibitMagicNumbers except for octals.
    - Mark variables around longjmp() as volatile.
    - Add tests for varbuf C++ API.
  * Localization:
    - Update Brazilian Portuguese programs translation.
      Thanks to Paulo Henrique de Lima Santana <phls@debian.org>.
      Closes: #1091450
    - Update Czech translations.
      Thanks to Miroslav Kure <kurem@upcase.inf.upol.cz>. Closes: #1087219
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1087459, #1087595
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1086160
    - Update Romanian programs translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1080212
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1083116

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

  [ Sven Joachim ]
  * Localization:
    - Update German dselect translation.
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 01 Jan 2025 23:27:27 +0100

dpkg (1.22.11) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Shlibs::Cppfilt: Do not normalize angle brackets for operators.
      Closes: #1076892
  * Documentation:
    - doc: Replace references to crypto-refresh and RFC4880 with RFC9580.
  * Build system:
    - Use 'command -v' instead of 'which'.
    - Remove generated spacesyms.o and spacesyms.c on clean.
    - Add declaration for funcs symbols in spacesyms.c.
  * Test suite:
    - Fix coding style in perl test cases.
    - Improve Dpkg::Changelog data test case message.
    - Refactor setup_changelog() in Dpkg::Changelog test.
    - Unroll Dpkg::Changelog file tests loop.
    - Refactor load_objdump_obj().

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 01 Aug 2024 12:39:16 +0200

dpkg (1.22.10) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Changelog::Entry::Debian: Remove obsolete /o modifier from regex.
    - Dpkg::Changelog: Remove useless escaping for -.
  * Make fragments:
    - Revert "scripts/mk: Reduce the number of subprocesses".
      Closes: #1076904, #1077005
  * Build system:
    - Do not define macros for C/C++ standard level.
    - Use pre-defined macros to check C/C++ conformance requirements.
    - Fix length for comment bar line after autoconf functions.
    - Fix dpkg_cv_c99 assignment in DPKG_C_C99 macro.
    - Simplify C standard check output.

 -- Guillem Jover <guillem@debian.org>  Sat, 27 Jul 2024 05:43:38 +0200

dpkg (1.22.9) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add long options for short-only compression ones.
  * dpkg-deb: Print pathname instead of filename and directory in error output.
  * start-stop-daemon: Use a stop context to track the current state.
  * Make fragments:
    - Fix pkg-info.mk evaluation by adding new DEB_TIMESTAMP variable.
      Closes: #1076863
  * Code internals:
    - dpkg-deb: Track maintscript information in a new struct.
  * Test suite:
    - Fix typos in Makefile comments.

 -- Guillem Jover <guillem@debian.org>  Wed, 24 Jul 2024 23:02:45 +0200

dpkg (1.22.8) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Archive::Ar: Rework _read_buf() error messages to make l10n easier.
  * Make fragments:
    - Ensure dpkg_datadir is computed once.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Fix make variable expansions passed to dpkg-buildflags.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>. Closes: #1076568
  * Documentation:
    - doc: Update Doxygen configuration from version 1.9.8.
  * Code internals:
    - libdpkg: Fix execname support on GNU/Hurd.
  * Build system:
    - Update lcov usage for version 2.0.
  * Localization:
    - Update Catalan translations.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 21 Jul 2024 20:18:23 +0200

dpkg (1.22.7) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-buildpackage: Remove fallback handling for missing required targets.
  * dpkg-buildpackage: Fix the debian/rules executable check to respect -R.
  * dpkg-realpath: Rewrite in C.
  * Revert "test: Pass -T+1 to xz to workaround spurious warning with xz
    5.6.0".
  * dpkg-genbuildinfo: Parse Provides as virtual packages.
  * dpkg: Do not run hooks or loggers with --dry-run or while unprivileged.
    Closes: #1071124
  * dpkg-shlibdeps: Add support for new --package option.
  * dpkg-buildpackage: Make newline injection during signing GnuPG specific.
    See https://dev.gnupg.org/T7106.
  * dpkg-realpath: Do not allow an empty pathname argument.
  * dpkg-buildpackage: Add support for building from a specified .dsc or dir.
  * dpkg-buildpackage: Reference the .dsc in .buildinfo if building from one.
    Closes: #882511
  * Perl modules:
    - Dpkg::BuildDriver: Refactor build driver out of dpkg-buildpackage.
    - Dpkg::Vendor::Ubuntu: Use -fcf-protection=none instead of
      -fno-cf-protection. Thanks to Matthias Klose <doko@ubuntu.com>.
    - Dpkg::Vendor::Debian: On native builds map *_FOR_BUILD flags to * flags.
      Closes: #1072332
    - Dpkg::OpenPGP::ErrorCodes: Update error codes from SOP draft version 10.
      See https://ietf.org/archive/id/draft-dkg-openpgp-stateless-cli-10.html.
    - Dpkg::Vendor::Debian: Set -Wno-error on qa=-bug-implicit-func.
      Closes: #1075769
    - Dpkg::Shlibs::Cppfilt: Normalize demangled symbols with llvm or C++11
      format.
    - Dpkg::Archive::Ar: New module.
    - Dpkg::Vendor::Debian: Guarantee UTF-8 locale codeset on sanitize-env.
    - Dpkg::Substvars: Add support for required substvars assigned with !=.
    - Dpkg::Source::Package: Document method additions with an object.
    - Dpkg::Source::Package::V3::Bzr: Remove unused variables.
    - Dpkg::Source::Package: Add a new get_basedirname() method.
  * Make fragments:
    - Protect files against double inclusion.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Use filter instead of findstring.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Use explicit test of $(origin) instead of ?=.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Search once for parallel= in DEB_BUILD_OPTIONS.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Generate the _FOR_BUILD variant of each variable automatically.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Reduce the number of subprocesses.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>. Closes: #872381
    - Stop hard-coding dpkg_datadir.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
  * Documentation:
    - doc: Add missing full stop to end of sentence.
    - man: Document DEB_BUILD_ARCH and DEB_HOST_ARCH usage in commands.
      Prompted by Thorsten Glaser <tg@mirbsd.de>.
    - man: Add new libdpkg(7) manual page.
    - man: Document DPKG_COLORS and DPKG_NLS for all perl scripts honoring
      them.
    - man: Document missing Packages front-end fields in dpkg-query(1).
    - man: Document weak checksum algorithms.
    - man: Update verify format example to also include M.
    - doc: Fix grammar for fallback.
    - doc: Fix casing after admonition.
  * Code internals:
    - libdpkg: Factor out filesystem database file loading into new function.
      Based on a patch by Simon Richter <sjr@debian.org>.
    - libcompat: Include missing <string.h> in strnlen module.
      Reported by Simon Richter <sjr@debian.org>.
    - dpkg-buildpackage: Refactor build target hook execution.
    - libdpkg: Handle readlink() failures in file_readlink().
    - libdpkg: Change varbuf_get_str() to return "" instead of initializing it.
    - libdpkg: Rename varbuf_get_str() to varbuf_str().
    - Use varbuf_str() instead of direct access.
    - libdpkg: Always NUL terminate varbufs.
    - libdpkg: Remove varbuf_end_str() function.
    - libdpkg: Add support for DPKG_NLS environment variable.
    - libdpkg: Add new varbuf prefix and suffix handling functions.
    - libdpkg: Add new file_getcwd() function.
    - dpkg: Use a variable for each conffile pathname type.
    - src: Fix timestamp parse error reporting. See #1069846.
    - src: Check whether SOURCE_DATE_EPOCH is set before parsing it.
      Based on a patch by Rainer Weikusat <rweikusat@cyberadapt.com>.
      Closes: #1069846
    - libdpkg: Add missing header includes.
    - libdpkg: Make file_slurp_fd() NUL-terminate the varbuf.
    - libdpkg: Refactor lax problem reporting into parse_lax_problem()
      function.
    - libdpkg: Turn the warning on Provides version relation into a lax error.
      See #930317.
    - libdpkg: Make varbuf_detach() always return a string.
    - libdpkg: Factor fsys_list_parse_buffer() out of
      ensure_packagefiles_available().
    - dpkg-shlibdeps: Refactor executable CLI parsing.
    - dpkg: Refactor conffile disappearing check into a new function.
    - Merge conffile obsolete and remove-on-upgrade into a single flags member.
    - lib, src: Include missing <stdbool.h>.
      Reported by Simon Richter <sjr@debian.org>.
    - dpkg-ar: New internal ar implementation script.
    - start-stop-daemon: Fix typos in code comments.
    - libcompat: Fix vasprintf() to error out if vsnprintf() returns >=
      INT_MAX.
    - libdpkg: Do not accept len >= INT_MAX in fd_read() and fd_write().
    - dpkg-realpath: Switch direct varbuf accesses to varbuf_str().
    - Revert "dpkg-realpath: Switch direct varbuf accesses to varbuf_str()".
      See https://bugs.debian.org/1076061.
    - dpkg-realpath: Guarantee varbufs have been allocated.
    - Check for < 0 instead of == -1 from syscall return values.
    - Check for >= 0 instead of != -1 for syscall return values.
    - dpkg: Check for < 0 instead of == -1 for conffderef() return values.
    - libdpkg: Check for limit >= 0 instead of != -1 in buffer_copy().
    - libdpkg: Check for updateslength < 0 instead of == -1 in ulist_select().
    - dselect: Use enum values instead of literal integers.
    - libdpkg: Add new execname module.
    - libdpkg: Try to print the executable name of the lock contending process.
      Closes: #1070027
    - perl: Use new Dpkg::Source::Package->get_basedirname() method.
  * Build system:
    - Re-enable the sanitizer for functional tests in CI.
    - Add missing space before backslash line continuation character.
    - Unconditionally include <stddef.h>.
    - Do not check for memcpy(). Reported by Simon Richter <sjr@debian.org>.
    - Do not check for functions used unconditionally.
    - Partially revert the sanitizer for some functional tests in CI.
    - Print the release version at the end of configure.
    - Add support to track release VCS commit id.
    - Pass abs_srcdir and abs_builddir to the TAP driver.
    - Rework subst handling for built or installed artifacts.
    - Workaround Tap::Harness verbose misbehavior on parallel mode.
      See https://github.com/Perl-Toolchain-Gang/Test-Harness/issues/105.
    - Fix test verbose and parallel option propagation.
    - Add missing files and sort POTFILES.in.
    - Check whether HAVE_* macros for headers are defined.
    - Include a .dist-vcs-url file in the distributed tarball.
    - Do not include VCS specific files in the distributed tarball.
  * Packaging:
    - Suppress start-stop-daemon compat symlink if /sbin is missing.
      Thanks to Johannes Schauer Marin Rodrigues <josch@debian.org>.
      Closes: #1071078
  * Test suite:
    - Do not fail the functional test suite due to memory leaks.
    - Pass --check-level=exhaustive to cppcheck.
    - Unset DEB_BUILD_MAINT_OPTIONS in build flags tests.
    - Simplify buildflags.mk test of _MAINT_APPEND when TEST_ is empty.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Use loops instead of repetitions in mk fragment tests.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Replace double quotes with single quote in shell recipes.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Test exported variables in addition to Make variables.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Test variable override.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Test DEB_CXXFLAGS_MAINT_SET.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Add missing test for CPP build tool.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Test override of a build tool.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Refactor real and virtual package setup.
      Based on a patch by Johannes Schauer Marin Rodrigues <josch@debian.org>.
    - Set CC to gcc in make fragments functional tests.
    - Parametrize all Makefile fragment functional tests.
    - Clarify the Makefile fragment variable being tested via comments.
    - Add new DPKG_CHECK_DIFF macro to abstract file comparisons.
    - Only execute Dpkg::Shlibs checks on ELF platforms.
    - Unify all ar invocations into create, extract and list.
    - Refactor ar handling into m4 macros.
    - Switch ar m4 macros to use internal dpkg-ar implementation.
  * Localization:
    - Update Dutch man pages translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1070144
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1070011

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 17 Jul 2024 01:10:42 +0200

dpkg (1.22.6) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix up compressor parameters for default legacy format.
  * Perl modules:
    - Dpkg::Vendor::Debian: Make it possible to disable qa=-bug-implicit-func.
      Closes: #1065371
    - Dpkg::Vendor::Debian: Unconditionally set qa bug-implicit-func.
      See #1065371.
  * Documentation:
    - man: Document dpkg versions supporting SOURCE_DATE_EPOCH for various
      tools.
  * Code internals:
    - libdpkg: Use array access instead of pointer arithmetic for meminfo
      parser.
    - libdpkg: Use a macro to define the zstd default compression level.
  * Build system:
    - Test with minimal library dependencies in CI.
    - Add gen-release script.
  * Packaging:
    - Fix typo in man page reference in changelog.
  * Test suite:
    - Refactor OpenPGP backend and commands list.
    - Refactor certfile and keyfile filenames for OpenPGP test.
    - Skip OpenPGP tests if the backend does not have a verify command.
      Closes: #1065648
  * Localization:
    - Fix typos in Swedish man pages translations.
      Thanks to Andreas Rönnquist <gusnan@debian.org>. Closes: #1065672
    - Fix typos in Swedish man pages translations. Closes: #1065575
    - Update Dutch man pages translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1065518
    - Update Portuguese man pages translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1065401

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 10 Mar 2024 20:21:24 +0100

dpkg (1.22.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-buildapi: Remove -v alias for --version.
  * dpkg-query: Fix exit codes for --show. Closes: #1064036
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Update to new CLI API changes.
    - Dpkg::OpenPGP::Backend::GnuPG: Add support for Sequoia gpg Chameleon.
    - Dpkg::Vendor::Debian: Only append branch compiler flags if $flag is set.
    - Dpkg::Vendor: Make the add_build_flags() a non-private method.
    - Dpkg::Vendor::Ubuntu: Pass compiler flags to disable features.
      Based on a patch by Matthias Klose <doko@ubuntu.com>.
    - Dpkg::Vendor::Debian: Enable time64 feature by default except on
      <some>-i386. Closes: #1037136
      Based on a patch by Steve Langasek <steve.langasek@ubuntu.com>.
    - Dpkg::Vendor::Debian: Enable qa=+bug-implicit-func for abi=+time64
      feature. Based on a patch by Steve Langasek <steve.langasek@ubuntu.com>.
  * Documentation:
    - man, doc: Fix dpkg-buildapi option and command grouping in descriptions.
    - man: Add spaces around make variable assignments.
    - man: Do not duplicate list of known feature areas in dpkg-buildflags.
    - man: Document known feature areas in DEB_BUILD_OPTIONS for
      dpkg-buildpackage.
    - man: Improve build flags feature specification in environment variables.
      Closes: #1063641
    - man: Use L</> markup for inter link reference.
    - man: Mention Build-Depends-Packages in dpkg-shlibdeps(1).
  * Code internals:
    - libdpkg: Add comment clarifying GNU long name tar format expectations.
    - libdpkg: Use an intermediate mode variable in secure_unlink_statted().
    - dpkg: Rename symlink_len to linksize.
    - dpkg: Rename r variable for readlink() return value to linksize.
    - dpkg: Reduce variable scope in conffderef().
    - libdpkg: Refactor file_readlink() function.
    - libdpkg: Deindent an else clause.
    - lib, src: Fold if with last previous else.
    - perl: Fold if into previous else.
    - dpkg-mergechangelogs: Refactor merge_tail() sub from anonymous sub.
    - dpkg-query: Rename rc variables tracking no matches to misses.
    - dpkg-query: Rename failures variables tracking no matches to misses.
  * Build system:
    - Rename pkexec variables to polkitactions.
    - Move directory definitions to configure.
    - Use PACKAGE_TARNAME for pathname components in directories.
    - Split each automake variable value into its own line.
    - Reorder automake variables.
    - Move update-alternatives rules within automake conditional.
    - Move MD_LIBS from LDFLAGS to LDADD for libdpkg.
    - Fix libdpkg library flags for static and dynamic linking.
    - Add infrastructure for bash-completions.
  * Test suite:
    - Pass -T+1 to xz to workaround spurious warning with xz 5.6.0.
      Closes: #1064856

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 27 Feb 2024 04:28:03 +0100

dpkg (1.22.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Code internals:
    - dpkg: Rename r variable for readlink() return value to symlink_len.
    - dpkg: Rename r variable for fd_read() return value to n.
    - dpkg-deb: Rename r variable for fd_read() return value to nread.
    - dpkg-deb: Rename r variables for fd_read() call chain return value to rc.
    - dpkg-split: Rename r variable for strtoimax() return value to ret.
    - libdpkg: Rename r variable for path_quote_filename() return to ret.
    - libdpkg: Rename r variable for fclose() return value to rc.
    - libdpkg: Rename r variables for printf()-like return values to n.
    - libdpkg: Handle tar long GNU names and links not being NUL terminated.
      Closes: #1061404
    - perl: Use qw() when importing symbols.
    - dpkg-gensymbols: Move foreach inlined array elements into a list.
    - dpkg-scansources: Fix newline breaks for ternary operators.
  * Packaging:
    - Update copyright years.

 -- Guillem Jover <guillem@debian.org>  Wed, 24 Jan 2024 13:12:31 +0100

dpkg (1.22.3) experimental; urgency=medium

  [ Guillem Jover ]
  * dpkg-buildtree: New program.
  * Perl modules:
    - Dpkg::Vendor::Debian: Parametrize fortify level.
    - Dpkg::Vendor::Ubuntu: Default to fortify level 3.
    - Dpkg::OpenPGP::Backend::SOP: Add reference to another gosop blocker.
    - Dpkg::OpenPGP::Backend::GnuPG: Accept keybox format keyrings as-is.
    - Dpkg::OpenPGP::Backend: Remove unused strict_verify option.
    - Dpkg::OpenPGP::Backend::GnuPG: Look harder for trustedkeys keyring.
    - Dpkg::Changelog::Debian: Remove wrong import arguments.
    - Dpkg::Vendor::Debian: Split bug-implicit-func from bug feature in qa
      area.
  * Documentation:
    - man: Use semantic line breaks (must requirements).
    - man: Remove trailing full stop before parenthetical.
    - man: Use «package maintainer script» instead of «Debian package
      scripts».
  * Code internals:
    - libcompat: Make long_options array const.
  * Packaging:
    - Make the logdir variable local to its function in postrm.
    - Install start-stop-daemon under /usr/sbin. Closes: #1059982
    - Make get_vendor honor DEB_VENDOR environment variable.
    - Check for usrmerge in bug-script on the same vendors as postinst.
    - Do not install dpkg-fsys-usrunmess on Debian and Ubuntu.
  * Localization:
    - Fix L<> markup.
    - Unfuzzy translations after semantic line break changes.
    - Update Dutch man pages translation.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1061085
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1059527

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 19 Jan 2024 12:10:52 +0100

dpkg (1.22.2) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-shlibdeps: Do not require debian/control when parsing CLI options.
    Closes: #1055536
  * Architecture support:
    - Remove arm64ilp32 support.
      See https://lists.debian.org/debian-dpkg/2023/11/msg00007.html.
    - Remove uclinux support.
      See https://lists.debian.org/debian-dpkg/2023/11/msg00012.html.
    - Remove knetbsd-any support.
    - Restrict kfreebsd ports to amd64 and i386.
    - Restrict kopensolaris ports to amd64 and i386.
    - Restrict hurd ports to amd64 and i386.
    - Restrict dragonflybsd ports to amd64.
    - Restrict aix ports to powerpc and ppc64.
    - Restrict solaris ports to amd64, i386, sparc and sparc64.
    - Restrict darwin ports to amd64, arm, arm64, i386, powerpc and ppc64.
    - Restrict freebsd ports to amd64, arm, arm64, i386, powerpc, ppc64, riscv.
    - Split tupletable header names description into two paragraphs.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Switch to use --signer-file.
    - Dpkg::Vendor::Debian: Mask PIE for alpha and ia64. Closes: #1040062
    - Dpkg::Control::Types: Add aliases for type enumerations.
  * Documentation:
    - man: Add dpkg-build-api behavior for Rules-Requires-Root field defaults.
    - man: Improve description for dpkg-build-api v1 items.
    - doc, man: Clarify terminology for Debian control files.
  * Code internals:
    - libcompat: Disable VLA usage for gettext.h.
    - libdpkg: Remove dead code after non-returning error function call.
    - libdpkg: Mark varbuf constructor as explicit.
    - Reduce variables scope.
    - update-alternatives: Wrap the bad_format() function pointer call into a
      new function.
    - start-stop-daemon: Rename local variables shadowing global info()
      function name.
    - libdpkg: Add underscore after NO to FHFF_NONEW and FHFF_NOCOPY enum
      values.
    - Use FHFF_NONE instead of a literal 0 in calls to fsys_hash_find_node().
      Reported by Alexandre Detiste <alexandre.detiste@gmail.com>.
    - dpkg-split: Change heading print logic to use a proper boolean.
    - dpkg-shlibdeps: Defer add_library_dir() calls after option parsing.
    - libdpkg: Remove unused DEFAULTSHELL and DEFAULTPAGER macros.
    - dpkg-buildapi: Do not include newline in Usage text to be translated.
  * Build system:
    - Check whether we need to linkg against libtinfo explicitly.
    - Add support for structured procfs via struct psinfo.
    - Replace action-if-found with : for extra libselinux check.
    - Check and print sizeof off_t and time_t on the configure summary.
  * Packaging:
    - Use installtest instead of test target in autopkgtests.
  * Test suite:
    - Reorder check on whether pkg is NULL.
    - Split and sort cppcheck arguments to be one per line.
    - Remove unused cppcheck suppressions.
    - Improve cppcheck coverage.
    - Pass -I<builddir> to cppcheck instead of «.» if <builddir> is defined.
  * Localization:
    - Update Catalan translations.
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1058631, #1058637

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Mon, 18 Dec 2023 03:37:08 +0100

dpkg (1.22.1) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Reject --no-uniform-compression with format 0.939000.
  * dpkg-deb: Force deb format 0.939000 to use gzip compression.
  * update-alternatives: Fix typo in comment.
  * update-alternatives: Unvendor documentation and --version output.
  * scripts: Remove unused GCJ and GCJFLAGS support.
  * scripts: Add basic support for _FOR_BUILD build flags.
  * Perl modules:
    - Dpkg::BuildAPI: Move DESCRIPTION before package declaration.
    - Dpkg::Source::Archive: Use $Dpkg::PROGTAR instead of tar in error
      message.
    - Dpkg::Source::Patch: Warn when patching hard linked files.
    - Dpkg::Vendor::Debian: Mark loong64 as having pie builtin.
      Thanks to yalingfang <fangyaling@loongson.cn>. Closes: #1053778
    - Dpkg::BuildFlags: Refactor flags initialization by using a single list.
    - Dpkg::Deps: Implicitly enable build_deps option on tests_deps.
      Closes: #1053481
    - Dpkg::Vendor::Debian: Fix stackclash condition to enable the feature
      on armhf and armel. Closes: #1054583
  * Make fragments:
    - Wrap DPKG_BUILDFLAGS_LIST into one entry per line.
  * Documentation:
    - man: Fix typo in stackclash feature name in dpkg-buildflags(1).
    - doc: Fix typos in code comments.
    - doc: Use macOS instead of Mac OS X in code comments.
    - man: Document the list of editors tried on dpkg-source --commit.
      Closes: #1051209
    - doc: Update R³ default values to take dpkg-build-api into account.
    - man: Clarify Maintainer field in dpkg-parsechangelog(1). See #1053705.
    - man: Document all dpkg-parsechangelog(1) output fields.
    - doc, man: Use manual page instead of manpage.
    - doc, man: Use field name or field-name instead of fieldname.
    - man: Use web interface instead of both terms concatenated.
    - man: Hyphenate 32-bit and 64-bit.
    - doc, man: Use L</> markup for inter link references.
    - doc: Use name() POD syntax instead of C<>, B<> or L<> for function names.
    - doc: Use name() POD syntax instead of a bare function name.
    - doc: Simplify references in CHANGES sections.
    - doc, man: Use L<> for manual page references.
    - doc, man: Use media discs instead of CD-ROM.
    - man: Use /media/bdrom instead of /media/cdrom.
    - man: Fix grammar in dpkg --force-confdef description.
    - man: Avoid redundant action list in dpkg invoke hook description.
    - man: Document the intermediary filenames used during unpack and
      configure. Prompted by Florian Weimer <fweimer@redhat.com>.
      See https://sourceware.org/pipermail/libc-alpha/2023-October/152245.html.
    - man: Update dpkg EXAMPLES section.
    - man: Recommend debsig-verify instead of debsums for additional
      functionality.
    - doc: Clarify compiler flag variables are for the host.
  * Code internals:
    - src: Use DEBEXT instead of hard-coding ".deb".
    - dpkg-deb: Initialize threads_max in no-uniform-compression mode.
    - dpkg-deb: Refactor legacy compress_params.
    - libdpkg: Refactor struct treewalk_funcs compound initializer into a
      macro.
    - libdpkg: Initialize TREEWALK_OBJECT with a 0.
    - libdpkg: Define DPKG_NULL to nullptr on C23 mode.
    - libcompat: Fix comparison of integers of different sign in
      obstack_blank().
    - libcompat: Declare exit_failure as an extern variable.
  * Build system:
    - Remove dpkg prefix from default deb compressor configure knobs.
    - Parametrize dpkg-deb default compressor in man page.
    - Use TAR variable from configure instead of hard-coded tar.
    - Split sanitizer CI unit tests from author checks.
    - Rename the shared library CI tests to shlib-tests.
    - Run make in parallel for autotest and TAP CI test jobs.
    - Make default shell and pager selectable at configure time.
    - Handle almost-POSIX shells that do not support -- after -c.
      See https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=274650.
    - Check for available pagers during configure.
    - Add comment for the system the DPKG_LIB_SOCKET m4 macro is needed.
  * Packaging:
    - Do not stop the dpkg-db-backup timer and service during upgrade.
      Closes: #1051085
    - Fix typos in debian/control comments.
  * Test suite:
    - Update cppcheck suppressions for 2.12.0.
    - Add installtest target and make test use the build tree programs.
    - Add new DPKG_CWD m4 macro.
    - Do not use -T for ln calls.
    - Generate the .deb from scratch instead of adapting them.
    - Update suppressions for codespell 2.2.6.
    - Use «\\n» after «a» and «c» sed commands.
    - Use perl instead of dd to create a zero-filled file.
    - Pass argument S to ar to avoid generating a symbol table.
    - Replace SED usage with PERL.
    - Include <sys/mkdev.h> on Solaris for major() and minor().
  * Localization:
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1053235, #1053236, #1053237
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1051634
    - Update Romanian dselect translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1053364
    - Update Romanian programs translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1054196
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1054510

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Mon, 30 Oct 2023 04:14:22 +0100

dpkg (1.22.0) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Do not reset the line number for each --command-fd parsed command.
  * dselect: Add non-free-firmware archive area support.
  * dselect: Relicense ftp method from GPL-2 to GPL-2+.
  * dpkg-deb: Do not print trailing spaces in --info output.
  * dpkg: Clarify that commands can take package-name or --pending in error
    message. Closes: #1034466
  * Remove avr32, m32r and tilegx obsolete architectures.
    See Linux commit 26202873bb51fafdaa51be3e8de7aab9beb49f70 (avr32).
    See Linux commit 553b085c2075f6a4a2591108554f830fa61e881f (m32r).
    See Linux commit bb9d812643d8a121df7d614a2b9c60193a92deb0 (tile).
  * dpkg-db-keeper: Add helper script to assist with tracking database changes.
  * dpkg-buildpackage: Add support for new preinit hook. Closes: #1023753
  * dselect: Remove handling of .GZ, .Z and .z compressed Package files.
  * dselect: Fix stdout+stderr discarding redirection in ftp method.
    Prompted by shellcheck.
  * dpkg-buildpackage: Fix build hook action substitution string handling.
  * dpkg-buildpackage: Set the hook options in an environment variable.
    Closes: #902856
  * dpkg-buildpackage: Set DPKG_BUILDPACKAGE_HOOK_NAME envvar for hooks.
  * dpkg-buildpackage: Handle missing information for hook substitutions.
  * dpkg-deb: Fix short lived memory leak after fork().
  * Switch from pkg-config to pkgconf.
  * dpkg: Handle non-existent .dpkg-tmp files on read-only filesystems.
    Closes: #1030149
  * dpkg-buildpackage: Fix R³ namespace check to only refuse unknown dpkg
    keywords. Closes: #1036865
  * dpkg-buildapi: New tool to fetch the dpkg-build-api level.
  * dpkg-shlibdeps: On dpkg-build-api >= 1 require -l instead of
    LD_LIBRARY_PATH.
  * dpkg-buildpackage: On dpkg-build-api >= 1 default R³ to no.
  * dpkg-buildpackage: On dpkg-build-api >= 1 avoid build target heuristics.
  * Mark dpkg-build-api level 1 as stable.
  * Architecture support:
    - Restore "arch: Add support for loong64 CPU". Closes: #1028654
  * Perl modules:
    - Dpkg::OpenPGP::ErrorCodes: Add new OPENPGP_CMD_CANNOT_SIGN error code.
    - Dpkg::OpenPGP::Backend::GnuPG: On signing failure use
      OPENPGP_CMD_CANNOT_SIGN. Closes: #1030271
    - Dpkg::Shlibs::Objdump::Object: Split from Dpkg::Shlibs::Objdump.
    - Dpkg::Control::HashCore::Tie: Split from Dpkg::Control::HashCore.
    - Dpkg::Vars: Fold into Dpkg::Package.
    - Dpkg::Package: Rename source_package symbols to source_name.
    - Dpkg::Changelog::Parse: Fix indentation of copyright and license notice.
    - Dpkg::Version: Update POD for removed semantic_change::overload::bool
      warning.
    - Dpkg::Gettext: Relicense from BSD-2 to GPL-2+.
    - Dpkg::Source::Archive: Fix file normalization for relative pathnames.
    - Dpkg::Source::Archive: Reflow regex match in _add_entry().
    - Dpkg::Control::FieldsCore: Deprecate implicit field_transfer_single()
      argument.
    - Dselect::Method::Ftp: Rename from Dselect::Ftp.
    - Dselect::Method::Ftp: Modify config and site subs towards method
      independence.
    - Dselect::Method: Move to be generic functions from Dselect::Ftp.
    - Dselect::Method::Ftp: Update package name.
    - Dpkg::Vendor::Debian: Add time64 feature in the future area.
      Based on a patch by Helge Deller <deller@gmx.de>. Closes: #1030159
    - Dpkg::Control::HashCore::Tie: Rename $last to $prev.
    - Dpkg::Substvars: Handle exponential expansion gracefully.
    - Dpkg::Shlibs::Objdump: Remove unsupported ELF machine types.
    - Dpkg::Shlibs::Objdump: Add ELF machine types for all supported arches.
    - Dpkg::Shlibs::Objdump: Add RISC-V ELF ABI tracking.
    - Dpkg::Shlibs::Objdump: Add OR1K ELF ABI tracking.
    - Dpkg::Shlibs::Objdump: Switch get_format() to return a colon-separated
      string.
    - Dpkg::Shlibs::Objdump: Add back the ARM ABI mismatch mask but commented
      out. See #853793.
    - Dpkg::Source::Quilt: Switch get_db_file() to be based off get_db_dir().
    - Dpkg::Vendor::Debian: Mark PIE as builtin on hurd-amd64.
    - Dpkg::Vendor::Debian: Only use ABI bits to suppress LFS or time64
      features.
    - Dpkg::Vendor::Debian: Only enable LFS when time64 is enabled for glibc.
    - Dpkg::Vendor::Debian: Invert time64 suppression list logic.
    - Dpkg::Vendor::Debian: Ignore musl libc systems for time64 suppression.
    - Dpkg::Vendor::Debian: Add fallback values for ABI attributes.
    - Dpkg::Source::Package::V2: Mark single-debian-patch as not needing
      forwarding. Closes: #1038121
    - Dpkg::Vendor::Debian: Sync builtin pie arches with gcc-13.
    - Dpkg::Vendor::Debian: Move time64 buildflags feature from future to abi.
      Suggested by Steve Langasek <vorlon@debian.org>.
    - Dpkg::Vendor::Debian: Move lfs from future to abi area and create an
      alias. Suggested by Steve Langasek <vorlon@debian.org>.
    - Dpkg::Vendor::Debian: Move builtin default setup before
      init_build_features().
    - Dpkg::Vendor::Debian: Handle abi feature flags as builtin.
    - Dpkg::Vendor::Debian: Add support for new hardening branch feature.
      Closes: #1021292
    - Dpkg::Vendor::Debian: Add support for new stackclash hardening feature.
      Closes: #918914
    - Dpkg::Source::Quilt: Switch get_patch_file() to be based off
      get_patch_dir().
    - Dpkg::BuildAPI: New module.
  * Make fragments:
    - Add new buildapi.mk support.
    - On dpkg-build-api >= 1 default to dpkg_vendor_derives_from_v1.
    - On dpkg-build-api >= 1 include buildtools.mk in default.mk.
  * Documentation:
    - man: Add notes about reproducibility properties for path fixing build
      features. Prompted by Sven Joachim <svenjoac@gmx.de>.
    - man: Itemize remaining lists.
    - man: Unify admonition markup and formatting.
    - man: Move shell redirection operator close to the redirected file.
    - man: Add versions where build flag features were added.
    - doc: Update triggers spec.
    - man: Fix OpenPGP backends list in dpkg-buildpackage(1).
    - doc: Use «honor» and «behavior» uniformly in documentation and output.
    - man: Clarify that dpkg-reconfigure is part of the debconf project.
    - doc: Add a Status field to frontend-api spec.
    - man: Clarify shared library name formats and their purpose.
    - man: Add SECURITY sections.
    - man: Spell out «manual page».
    - man: Clarify C.UTF-8 locale setting hint. Closes: #1028296
    - man: Update methods provided by dselect(1).
    - man: Turn buildinfo filename format selection into a list.
    - man: Itemize supported deb-changelog(5) keyword/value entries.
    - doc: Move Perl version baseline as the first perl coding style
      subsection.
    - doc: Clarify required C/C++ standards.
    - doc: Require POSIX.1-2008.
    - man: Mention .buildinfo in dpkg-buildpackage --sign-command description.
    - doc: Fix typo.
    - man: Document known DEB_BUILD_OPTIONS options. Closes: #1038888
    - man: Clarify the md5sums checks as integrity and not security checks.
      Prompted by Sebastian Andrzej Siewior <sebastian@breakpoint.cc>.
    - man: Clarify dpkg-architecture -c option.
      Prompted by Paul Wise <pabs@debian.org>.
    - man: Document version when new programs where introduced.
    - man: Fix typo in future lfs feature introduction version.
    - man: Open up dpkg-build-api level 1.
  * Code internals:
    - libdpkg: Move early return into the loop.
    - libdpkg: Remove impossible condition.
    - libdpkg: Turn bitmask parse_nv_flags into an actual enum parse_nv_mode.
    - libdpkg: Move parse_nv() next word check inside else block.
    - dpkg: Remove path_quote_filename() usage.
    - dselect: Reduce variables scope.
    - libcompat: Reduce variables scope.
    - libdpkg: Reduce variables scope.
    - update-alternatives: Reduce variables scope.
    - src: Reduce variables scope.
    - libdpkg: Rename mlib module to mustlib.
    - dselect: Remove unused trailing semicolons.
    - libdpkg: Surround macro within a do-while block.
    - perl: Add $VERSION to all embedded perl packages.
    - perl: Add POD to all private modules. Closes: #1030660
    - perl: Move POD sections before what they describe.
    - scripts: Unpack function arguments.
    - scripts: Remove duplicate variable declaration.
    - dselect: Reduce variable scope to avoid shadowing.
    - perl: Move $VERSION into package keyword.
    - perl: Remove unused Dpkg::Version semantic_change warning suppression.
    - scripts: Use «(undef) x N» to ignore tuples or function returns.
    - perl: Stop removing «.» from @INC before loading modules.
    - dpkg-scansources: Reorder captured variable and regex match.
    - perl: Use List::Util instead of fixed string matches within a regex.
    - perl: Pass $_ explicitly to field_transfer_single().
    - perl: Rename filename related variables to distinguish them from field
      ones.
    - dpkg-genchanges: Move comment describing %sourcedefault before
      declaration.
    - perl: Rename Dpkg::Control variables from $f to $c or $ctrl.
    - perl: Use an $f variable for fields instead of the topic variable.
    - perl: Use fixed string comparisons for field name matches.
    - scripts: Switch code to use chained comparisons.
    - dselect: Update Andy Guy email address.
    - dselect: Remove unused ismulti() function from media method actions.
    - dpkg-deb: Use intermediate variable for exec mark on --info output.
    - dpkg-deb: Refactor maintscript interpreter parser.
    - dpkg-deb, dpkg-query: Rename option flags to opt_NAME.
    - dpkg-trigger: Rename CLI option variables from f_ to opt_.
    - libcompat: Declare variables before definitions.
    - libdpkg: Make local variables static.
    - libdpkg: Rename FHFF_NONE to FHFF_NONEW.
    - libdpkg: Switch bitmasks enumerations into precise masks.
    - libdpkg: Add enumerations for the default, unset and max cases.
    - libdpkg: Add warning suppression macros.
    - lib: Add an enum flags attribute.
    - lib, src, utils: Use new enum flag C attributes.
    - libdpkg: Unconditionally initialize c variable in parse_stanza().
    - start-stop-daemon: Initialize variables in run_stop_schedule().
    - dpkg-genchanges: Refactor .changes file description formatting into a
      function.
    - dpkg-genchanges: Replace Encode usage with utf8 encode/decode functions.
    - dpkg-gensymbols: Use File::Compare instead of Digest::MD5.
    - dselect: Reword odd code comment.
    - dselect: Use «color» uniformly in variables and comments.
    - libdpkg: Handle missing Version when formatting source:Upstream-Version.
      Reported by John Scott <jscott@posteo.net>.
    - perl: Remove «1;» from end of script in programs.
    - libdpkg: Pass -- after sh -c to avoid bogus option parsing.
      Prompted by Joe Simmons-Talbott <josimmon@redhat.com> (on libc-alpha).
    - libdpkg: Mask the mode from the tar entry to only the file mode bits.
    - lib: Define __has_include fallback if the compiler does not support it.
    - libdpkg: Simplify progress output by using fputs() and putchar().
    - libdpkg: Mark the progress percentage for translation. See #1034378.
    - dpkg-buildpackage: Turn items into lists for easier extensibility.
    - libdpkg: Make headers self-contained.
      Thanks to Simon Richter <sjr@debian.org>.
    - libdpkg: Mark functions in headers as inline.
      Thanks to Simon Richter <sjr@debian.org>.
    - scripts: Do not set LANG unnecessarily.
    - dpkg: Move comment next to the code it is describing.
    - dpkg-buildpackage: Move hook invocation closer to artifact creation.
    - dpkg-buildpackage: Default the enabled run_hook() parameter to true.
    - dpkg-buildpackage: Turn the run_hook() enabled argument into a hash
      option.
    - libcompat: Use ptrdiff_t directly instead of using a macro.
    - libcompat: Update getopt code from gnulib.
    - libdpkg: Remove redundant check.
    - lib, src: Add const qualifiers to variables.
    - dselect: Add constVariableReference as a cppcheck suppression.
    - libdpkg: Fix varbuf memory leak in pkg_source_version().
    - dpkg-shlibdeps: Switch from exec() to Dpkg::IPC::spawn().
      Prompted by Paul Wise <pabs@debian.org>.
    - libdpkg: Fix coding style for varbuf module.
    - libdpkg: Reorder varbuf functions.
    - libdpkg: Add varbuf_add_varbuf() function.
    - libdpkg: Add varbuf_add_strn().
    - libdpkg: Add varbuf setter functions.
    - libdpkg: Switch ustar filename construction to use varbuf_add_strn().
    - dpkg-split: Use varbuf instead of ad-hoc allocation in read_info.
    - Use varbuf_add_varbuf() instead of varbuf_add_buf()/_str().
    - Use varbuf_set_*() instead of ad-hoc initialization.
    - libdpkg: Generalize command_in_path() from find_command().
  * Build system:
    - Fix version script linker support detection.
    - Enable -Wextra-semi compilation warning.
    - Explicitly set the date when generating perl module man pages.
    - Bump minimal Perl version to 5.32.1.
    - Enable more compiler warnings.
    - Remove unused AC_SIZEOF checks.
    - Check for the host architecture attributes during configure.
    - Detect whether we need librt for clock_gettime().
    - Use an export symbols file if there is no version script support.
    - Add -no-undefined libtool flag.
    - Add support for .git-blame-ignore-revs file.
    - Fix typo in .gitignore filename by renaming it.
      Thanks to Simon Richter <sjr@debian.org>.
    - Remove vim swap file entry from .gitignore.
    - Ignore tags files.
      Based on a patch by Simon Richter <sjr@debian.org>.
    - Add perl prefixes into the Code Internals changelog section.
    - Namespace COMPILER_*FLAGS with DPKG_.
    - Add support for compiler sanitizer flags.
    - Add support for compiler analyzer flags.
    - Add new gcc-13 warnings.
    - Warn on alloca() usage.
    - Remove distcleancheck_listfiles override for CPAN dist-cpan target.
    - Avoid Perl's exec() falling back to system().
      Thanks to Paul Wise <pabs@debian.org>.
      See https://perldoc.perl.org/functions/exec.html.
  * Packaging:
    - Merge copyright statements for the same holder.
    - Remove executable permissions from maintscripts in source.
    - Remove no longer needed alternatives fixup from postint.
    - Remove no longer needed maintscripts for method renames.
    - Fix removal of file method state directory on purge.
    - Wrap fields in debian/tests/control file.
    - Set Persistent=true for dpkg-db-backup systemd timer.
      Thanks to Teemu Likonen <tlikonen@iki.fi>. Closes: #1041730
    - Do not start the dpkg-db-backup timer during installation.
  * Test suite:
    - Update perlcritic checks and suppressions.
    - Disable perlcritic checks that are not relevant.
    - Reduce scope of variable to avoid shadowing others.
    - Do not use potentially bogus variable value.
    - Enable perlcritic RegularExpressions::ProhibitCaptureWithoutTest.
    - Disable -Wassign-enum for tests using out of range enum values.
    - Make some perlcritic checks more strict.
    - Update rationale for perlcritic check suppressions.
    - Use the TAR detected at configure time in autotests.
    - Use the SED detected at configure time in autotests.
    - Use m4 to implement seq instead of assuming GNU seq is present.
    - Add missing argument to DPKG_FILE_SIZE m4 function.
    - Add more substvar recursive replace cases.
    - Define lzma based on xz if missing.
    - Switch deb non-uniform members test to use uncompressed control.tar.
    - Use AT_DATA instead of touch to create empty files.
    - Refactor deb-format package template generation into a new macro.
    - Split deb-format tests per compressor.
    - Fix t-disappear-depended test.
    - Add cases for disappearing with diversions.
    - Add cases for disappearance on diverted overwrites and third parties.
      Suggested by Simon Richter <sjr@debian.org>.
    - Quote command variables in case these contain spaces.
    - Use the GREP/EGREP detected at configure time in autotests.
    - Pass -n to gzip for all invocations.
    - Generate the pkg-old.deb from controlled parts.
    - Compute the sizes for «dpkg-deb -I» output dynamically.
    - Add test cases for dpkg-buildpackage hook support.
    - Use dpkg-buildpackage --no-sign instead of each --unsigned-* option.
    - Add new stop words for codespell 2.2.5.
    - Update cppcheck suppressions for 2.11.
    - Define macros to help cppcheck analyze code.
    - Fix varbuf memory leak in t-pkg-format test.
    - Rename merge_changlogs test to match the command being tested.
    - Add new test case checking Conflicts with Replaces.
    - Fix t-conffile-divert-conffile case.
    - Use «ar qc» to create archives with duplicate members.
    - Move test_data_file() to test.h.
  * Localization:
    - Add Portuguese scripts translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1032562
    - Clarify license for translation files.
    - Fix Project-Id-Version to match the gettext domain.
    - Unify translation header description.
    - Update Dutch header boilerplate with an actual copyright line.
    - Update French scripts translation.
      Thanks to Sébastien Poher <sebastien@volted.net>.
    - Update Romanian dselect translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1040869
    - Use Dpkg Developers instead of listing them individually.

  [ Helge Kreutzmann ]
  * man: Remove a now superfluous character from dpkg(1).
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German dselect translation.
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 30 Aug 2023 05:39:24 +0200

dpkg (1.21.20) unstable; urgency=medium

  [ Guillem Jover ]
  * Documentation:
    - man: Remove duplicate word in dpkg-buildflags(1).
      Thanks to Peter Krefting <peter@softwolves.pp.se>.
  * Packaging:
    - Fix versioned Build-Depends on debhelper. Closes: #1030288
    - Update lintian overrides.
  * Test suite:
    - Update suppressions for cppcheck 2.10.
    - Skip auto-generated policykit policy file.
  * Localization:
    - Add Dutch scripts translation. Closes: #1030712
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Unfuzzy translations due to typo fix.
    - Update Czech translations. Closes: #1029706, #1030267
      Thanks to Miroslav Kure <kurem@upcase.inf.upol.cz>.
    - Update Dutch translations. Closes: #1030710, #1030711
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Update French man page translation. Closes: #1030618
      Thanks to Jean-Pierre Giraud <jenapierregiraud75@free.fr>.
    - Update French programs translations.
      Thanks to Sébastien Poher <sebastien@volted.net>.
    - Update Hungarian programs translation.
      Thanks to Nagy Elemér Károly <nagy.elemer.karoly@gmail.com>.
    - Update Korean dselect translation.
      Thanks to Sangdo Jun <sebuls@gmail.com>.
    - Update Occitan programs translation.
      Thanks to Quentin PAGÈS <quentinantonin@free.fr>.
    - Update Portuguese programs translation.
      Thanks to Miguel Figueiredo <elmig@debianpt.org>.
    - Update Romanian programs translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
    - Update Russian translations. Closes: #1030162, #1030378
      Thanks to Yuri Kozlov <yuray@komyakino.ru>.
    - Update Simplified Chinese translations.
      Thanks to Boyuan Yang <byang@debian.org>.
    - Update Spanish dselect translation.
      Thanks to jonatan porras <jonatanpc8@gmail.com>.
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>.
    - Update Thai programs translation.
      Thanks to Theppitak Karoonboonyanan <thep@debian.org>.
    - Update Traditional Chinese dselect translation.
      Thanks to Cheng-Chia Tseng <pswo10680@gmail.com>.
    - Workaround po4a formatting issue in French translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 07 Feb 2023 12:19:12 +0100

dpkg (1.21.19) unstable; urgency=medium

  [ Guillem Jover ]
  * Architecture support:
    - Revert "arch: Add support for loong64 CPU". See #1028654.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::GnuPG: Set secure signing preferred algorithms.
      Closes: #1028961
    - Dpkg::OpenPGP::Backend::GnuPG: Touch trustedkeys.gpg on temporary gpg
      home.
    - Dpkg::OpenPGP::Backend::GnuPG: Fallback to use «gpg dearmor» if
      present. Reported by Sven Joachim <svenjoac@gmx.de> (on IRC).
    - Dpkg::Vendor::Ubuntu: Fix lto feature to honor DEB_BUILD_OPTIONS.
  * Test suite:
    - Set the permissions explicitly for the copied ChangeLog.old file.
    - Add unit tests for lto build flags handling in Ubuntu.
      Thanks to Shengjing Zhu <shengjing.zhu@canonical.com>.
      See https://bugs.launchpad.net/bugs/2002582.
  * Localization:
    - Update Catalan translation.
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1028981

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 24 Jan 2023 23:39:50 +0100

dpkg (1.21.18) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildFlags: Fix strip method to always work with duplicates.
      Closes: #1028044
  * Documentation:
    - man: Add a note to dpkg-fsys-usrunmess(8) about Debian support.
      Closes: #1008486
  * Code internals:
    - libdpkg: Move compression level max bound check from dpkg-deb.
    - libdpkg: Switch dpkg_lzma_strerror() to use struct io_lzma.
    - libdpkg: Split compression filter operation tracking from its status.
    - libdpkg: Generalize compression stream action handling.
    - libdpkg: Abstract compression stream status tracking.
    - libdpkg: Add zstd support for .deb archives. Closes: #892664
  * Build system:
    - Update .mailmap mappings.
  * Packaging:
    - Update copyright years.
  * Test suite:
    - Add dpkg-deb build and extract tests.

 -- Guillem Jover <guillem@debian.org>  Tue, 10 Jan 2023 18:46:37 +0100

dpkg (1.21.17) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genbuildinfo: Do not fail if the cross-compiler cannot compile.
    Closes: #1027966
  * Code internals:
    - dpkg-buildinfo: Fix indentation.
  * Packaging:
    - Stop shipping the «git log» changelog in exchange for no trimming.
      Closes: #1027716

 -- Guillem Jover <guillem@debian.org>  Thu, 05 Jan 2023 12:34:05 +0100

dpkg (1.21.16) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix buffer overflow on long directory names with old deb formats.
    Reported by Georgy Yakovlev <gyakovlev@gentoo.org>.
  * Perl modules:
    - Dpkg::Compression: Pass --no-adjust to xz to force compression threaded
      mode.
    - Dpkg::Compression: Make xz not emit warnings nor exit non-zero on
      warnings.
    - Dpkg::OpenPGP::Backend::SOP: Add sqop as an alternative SOP
      implementation.
    - Dpkg::Source::Package::V3::Git: Move error() argument out of g_() call.
  * Code internals:
    - libdpkg: Make xz not emit warnings nor exit non-zero on warnings.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 04 Jan 2023 23:57:40 +0100

dpkg (1.21.15) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildFlags: Add new get_feature() method.
    - Dpkg::Vendor::Debian: Use get_feature() instead of use_feature() for PIE.
      Reported by Helmut Grohne <helmut@subdivi.de>.
    - Dpkg: Temporarily silence deprecation warnings.
  * Test suite:
    - Improve TAP descriptions to clarify we are testing patch(1).

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Mon, 02 Jan 2023 12:44:53 +0100

dpkg (1.21.14) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-source: Add new --threads-max option to control threaded compressors.
  * dpkg-buildflags: Add support for features handled as builtin defaults.
  * Perl modules:
    - Dpkg::Compression::Process: Unify and simplify cmdline handling.
    - Dpkg::Compression: Change $COMP hashref into a %COMP hash.
    - Dpkg::Compression: Add new compression_get_file_extension() and switch to
      it.
    - Dpkg::Compression: Move the POD for each function immediately before it.
    - Dpkg::Compression: Clarify the compression_get/set_default_level() are
      global.
    - Dpkg::Compression: Use %COMP directly in functions when it is safe.
    - Dpkg::Compression: Add new compression_get/set_level() and switch to it.
    - Dpkg::Compression: Add new compression_get/set_cmdline_de/compress().
    - Dpkg::Compression: Deprecate compression_get_property().
    - Dpkg::Compression: Add multi-threaded xz support.
    - Dpkg::Vendor::Devuan: Add new vendor module.
      Requested by Ivan J. <parazyd@dyne.org>.
    - Dpkg::BuildFlags: Make it possible to not load the vendor defaults on
      new().
    - Dpkg::BuildFlags: Add a new use_feature() method.
    - Dpkg::BuildFlags: Add a new set/get_option_value() private methods.
    - Dpkg::BuildFlags: Add missing feature area to is_maintainer_modified()
      POD.
    - Dpkg::BuildFlags: Add support for builtin build flags.
    - Dpkg::Vendor::Debian: Track option values state as a build flag options.
    - Dpkg::Vendor::Debian: Generalize feature areas defaults.
    - Dpkg::Vendor::Ubuntu: Use a string comparison instead of debarch_eq().
    - Dpkg::Vendor::Ubuntu: Use new build flag option override support to set
      -O3.
    - Dpkg::Vendor::Ubuntu: Handle LTO by default using new feature overrides.
    - Dpkg::BuildEnv: Rename from Dpkg::Build::Env.
    - Dpkg::BuildTypes: Rename from Dpkg::Build::Types.
    - Dpkg::BuildInfo: New module to deprecate the Dpkg::Build::Info module.
  * Documentation:
    - man: Document dpkg-source -q option.
    - doc: Update TODO.
    - man: Document start-stop-daemon options that might be no-ops on some
      systems.
    - man: Turn spaces followed by tabs into spaces in start-stop-daemon(8).
    - man: Use stanza instead of paragraph, block or record for deb822 parts.
  * Code internals:
    - libdpkg: Use correct return type in meminfo functions definitions.
    - libdpkg: Split DPKG_ATTR_ declarations.
    - lib: Refactor format attributes into a common *_ATTR_FMT.
    - lib: Use __name__ format for attributes.
    - lib: Use __has_attribute() to check for attribute availability.
    - libdpkg: Mark tar on-disk members with attribute nonstring.
    - scripts: Use stanza instead of entry or block.
    - libdpkg: Rename functions with names containing record to stanza.
    - dselect: Rename functions with names containing block to stanza.
    - perl: Add missing space around equal-based operators.
    - scripts: Fix indentation.
    - perl: Fix list and hash literals indentation.
    - scripts: Cuddle else and elsif.
    - perl: Remove excess blank lines.
    - dselect, src, utils: Remove excess blank lines.
    - dpkg-scansources: Turn spaces followed by tabs into spaces.
  * Packaging:
    - Clarify new xz multi-threaded support is for decompression.
    - Bump Standards-Version to 4.6.2.
  * Test suite:
    - Add unit tests for most of Dpkg::Compression.
  * Localization:
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1027312, #1027313

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 01 Jan 2023 23:48:16 +0100

dpkg (1.21.13) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Test::Dpkg: Refactor OpenPGP requisite into test_needs_openpgp_backend().
    - Dpkg::Backend::GnuPG: Ensure future signing interop with gpg --openpgp.
  * Documentation:
    - man: Move parallel-safe note from dpkg-buildpackage -j option to
      --jobs-force.
  * Code internals:
    - start-stop-daemon: Cast struct sockaddr_un to struct sockaddr on bind()
      call.
    - lib: Stop using register keyword.
    - libcompat: Remove unused arguments from ngettext() fallback macro.
    - libcompat: Switch manual copying to memcpy() in obstack module.
    - libcompat: Switch obstack to use size_t.
    - libcompat: Use an union to track chunkfun and freefun.
    - dpkg-architecture: Fix indentation.
    - libdpkg: Fix pdb_lax_stanza_parser and pdb_allow_empty aliased values.
    - libcompat: Add noreturn and sentinel C attributes.
    - utils: Switch to use libcompat attributes.
    - libdpkg: Add new multi-threaded xz decompression support. Closes: #956452
    - libdpkg: Pass -T+1 instead of -T1 to xz when compressing.
    - libdpkg: On threads-max > 0 pass --no-adjust to xz to force threaded
      mode.
    - Use hyphenated multi-threaded in text.
  * Build system:
    - Consider lib and utils prefixes as internal in gen-changelog.
    - Fix m4 files coding style.
    - Include <stdio.h> for printf() usage in __progname check.
  * Packaging:
    - Require liblzma >= 5.4.0 for multi-threaded decompressor support.
    - Clarify versioned dependency rationale comments.
    - Add pkgconf as main Build-Depends alternative to pkg-config.
  * Test suite:
    - Skip deb-format tests if required compressors are not present.
    - Use a custom dpkg database directory for dpkg-buildpackage tests.
    - Switch Dpkg::Source::Package test to use test_needs_openpgp_backend().
    - Skip deb-format tests if gzip is not present.
    - Skip dpkg-source tests if xz is not present.
    - Use the PERL detected at configure time in autotests.
    - Use perl instead of yes+dd to generate a data-file for deb-split.
  * Localization:
    - Update Simplified Chinese programs translation.
      Thanks to Boyuan Yang <byang@debian.org>. Closes: #1025625

 -- Guillem Jover <guillem@debian.org>  Mon, 19 Dec 2022 02:07:45 +0100

dpkg (1.21.12) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-architecture: Properly compute required information to gather.
    Reported by Sören Tempel <soeren@soeren-tempel.net>.
  * Code internals:
    - dpkg-architecture: Rename information tracking constants and variables.
  * Packaging:
    - Set paths for configure in autopkgtests to match installed ones.
    - Add libmd-dev to libdpkg-dev Depends.
      Reported by Alexandre Detiste <alexandre.detiste@gmail.com>.

 -- Guillem Jover <guillem@debian.org>  Tue, 06 Dec 2022 04:27:57 +0100

dpkg (1.21.11) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genbuildinfo: Do not fail if there is no cross-compiler.
    Closes: #1025273
  * Documentation:
    - doc: Update Doxyfile after code reorganization.
    - doc: Update Doxygen configuration from version 1.9.4.
    - man: Remove B<> or replace with S< >.
  * Code internals:
    - libdpkg: Document str_end parameter for str_strip_quotes().
  * Packaging:
    - Add libmd-dev to the test-root and test-not-root autopkgtests.
    - Add source lintian-overrides.
    - Remove obsolete libncursesw5-dev alternative from Build-Depends.
    - Update copyright years.
  * Localization:
    - Unfuzzy translations after markup fixes.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sat, 03 Dec 2022 00:18:29 +0100

dpkg (1.21.10) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Avoid setgid(2) call if not needed.
    Thanks to Christian Göttsche <cgzones@googlemail.com>. Closes: #1014332
  * dpkg-architecture: Do not compute values that are not required.
  * dpkg-buildpackage: Fix swapped long options for -m/-e.
  * dpkg-buildpackage: Add --source-by and --changed-by aliases for -m/-e.
  * dpkg-deb: Add support for DPKG_DEB_COMPRESSOR_TYPE/LEVEL. Closes: #550475
  * dpkg-genbuildinfo: Refactor build-tainted-by gathering into a function.
  * dpkg-genbuildinfo: Add new can-execute-cross-built-programs tainted flag.
    Thanks to Johannes Schauer Marin Rodrigues <josch@mister-muffin.de>.
    Closes: #1011191
  * dpkg: Make -E also take into account the architecture.
    Thanks to Ian Jackson <ijackson@chiark.greenend.org.uk>. Closes: #1014476
  * dpkg-source: Fix confusing regex match for option arguments.
  * dpkg-buildpackage: Fix --jobs and --jobs-try parsing with no «=».
  * dpkg-buildpackage: Rename --jobs/--jobs-try argument in --help output.
  * dpkg-buildpackage: Add new --jobs-force option.
  * dpkg-buildpackage: Change -j, --jobs semantics to non-force mode.
    Closes: #905835
  * dpkg, dpkg-statoverride: Install SELinux log callback to filter messages.
    Thanks to Christian Göttsche <cgzones@googlemail.com>.
  * dselect: Clarify non-free section as optional not free software component.
    Closes: #30972
  * dselect: Require the Dpkg modules for the ftp access method.
  * dpkg-buildpackage: Remove blank line around signfile output lines.
  * dpkg-buildpackage: Add new --sign-keyid and alias --sign-key to it.
  * dpkg-buildpackage: Add --sign-keyfile and DEB_SIGN_KEYFILE support.
  * dpkg-buildpackage: Add --sign-backend to specify the OpenPGP backend.
  * dpkg-source: Translate source format specific --help option descriptions.
  * dpkg-shlibdeps: Cache soname check against shlibs files. Closes: #1022766
  * libdpkg, dpkg: Switch triggers database to use reproducible package names.
    Closes: #990712
  * update-alternatives: Switch point at which we increment alternative
    refcount.
  * dpkg: Fix setting admindir when root is set.
  * dpkg-split: Add support for --root and --admindir.
  * Architecture support:
    - Move i386 and ia64 in an alphabetical-ish order in the cputable.
    - Add support for loong64 CPU.
      Based on a patch by 张丹丹 <zhangdandan@loongson.cn>. Closes: #1023486
  * Perl modules:
    - Dpkg::Source::Package::V1: Remove redundant exit handler for erasedir().
    - Dpkg::Source::Package::V2: Update and clarify patch header metadata
      template.
    - Dpkg::Deps: Merge dependency string into a single line when parsing.
      Closes: #1019565
    - Dselect::Ftp: Switch to current mirror list for ftp method output.
    - Dpkg::Source::Package: Use File::Spec instead of ad-hoc concatenation.
    - Dpkg::Source::Package: Verify signatures before printing source files
      addition.
    - Dpkg::Source::Package: Print verifying signature for all source formats.
    - Dpkg::Vendor: Rename @tries variable to @names.
    - Dpkg::Vendor: Fix get_vendor_file() to return on first match.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Avoid duplicate file loading attempts.
    - Dpkg::Vendor: Prefer loading lowercase vendor file first as documented.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Prefer loading capitalized vendor modules.
    - Dpkg::Vendor: Use a normalized key to access the cached objects.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Fix vendor file loading for vendors with special
      characters.
    - Dpkg::Vendor: Fix module loading for vendors with special characters.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Deprecate loading vendor files with no special character
      mapping.
    - Dpkg::Vendor: Deprecate loading vendor module names starting lower-cased.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Test::Dpkg: Refactor test files search into _test_get_files function().
    - Dselect::Ftp: Declare %CONFIG with «our» instead of «my».
    - Dselect::Ftp: Conditionally load perl modules shipped in the perl
      package.
    - Test::Dpkg: Make test_get_temp_path() remove the path before creating it.
    - Dpkg::File: Add new file_dump() function.
    - Dpkg::File: Add new file_touch() function.
    - Dpkg::OpenPGP: Remove unused $exec_opts argument from _exec_openpgp().
    - Dpkg::OpenPGP: Pass opts as a hash ref on the first argument.
    - Dpkg::OpenPGP: Refactor _gpg_import_keys() out of import_key().
    - Dpkg::OpenPGP: Refactor GnuPG common options into functions.
    - Dpkg::OpenPGP: Require gpgv and do not fallback to gpg to verify
      signatures.
    - Dpkg::OpenPGP: Refactor _gpg_verify() out from verify_signature().
    - Dpkg::OpenPGP: Split verify_signature() into verify() and
      inline_verify().
    - Dpkg::OpenPGP: Rename keyrings option to certs.
    - Dpkg::OpenPGP: Rename and namespace GnuPG specific symbols.
    - Dpkg::OpenPGP: Refactor is_armored() out from openpgp_sig_to_asc().
    - Dpkg::OpenPGP: Refactor armoring code into an armor() function.
    - Dpkg::Source::Package: Add armor_original_tarball_signature() member.
    - Dpkg::OpenPGP: Merge ASCII armored key import into signature
      verification.
    - Dpkg::OpenPGP: Add native helpers for ASCII Armor.
      Thanks to Daniel Kahn Gillmor <dkg@fifthhorseman.net>.
      See https://salsa.debian.org/debian/devscripts/-/merge_requests/286.
    - Dpkg::OpenPGP: Switch armor() to use native OpenPGP armor functions.
    - Dpkg::OpenPGP: Add new dearmor() function.
    - Dpkg::OpenPGP: Use dearmor() instead of _gpg_import_keys() in
      _gpg_verify().
    - Dpkg::OpenPGP: Move status check from _gpg_exec() to _gpg_verify().
    - Dpkg::OpenPGP: Make it a class.
    - Dpkg::OpenPGP::KeyHandle: Refactor new key handle from dpkg-buildpackage.
    - Dpkg::OpenPGP: Pass an array instead of an arrayref to _gpg_exec().
    - Dpkg::OpenPGP::ErrorCodes: Add new module.
    - Dpkg::OpenPGP: Switch functions to return Dpkg::OpenPGP::ErrorCodes.
    - Dpkg::OpenPGP: Change inline_verify to take an output file.
      Requested by Daniel Kahn Gillmor <dkg@fifthhorseman.net>.
    - Dpkg::OpenPGP: Make armor idempotent.
    - Dpkg::Source::Package: Call armor() unconditionally for signature
      conversion.
    - Dpkg::OpenPGP: Remove now unnecessary is_armored() method.
      Prompted by Daniel Kahn Gillmor <dkg@fifthhorseman.net>.
    - Dpkg::OpenPGP: Call dearmor() unconditionally for GnuPG certificate
      imports.
    - Dpkg::OpenPGP: Reintroduce gpg fallback for signature verification.
    - Dpkg::OpenPGP: Automatically detect both cmd and cmdv.
    - Dpkg::OpenPGP: Refactor trusted keyrings from Dpkg::Source::Package.
    - Dpkg::OpenPGP: Refactor signing code from dpkg-buildpackage.
    - Dpkg::OpenPGP::KeyHandle: Add new needs_keystore() method.
    - Dpkg::OpenPGP::Backend: Refactor GnuPG functions from Dpkg::OpenPGP.
    - Dpkg::OpenPGP::Backend: Add new has_verify_cmd() method.
    - Dpkg::OpenPGP: Add multi-backend loading support.
    - Dpkg::OpenPGP: Add Sequoia backend support.
    - Dpkg::OpenPGP: Handle backend requiring a keystore daemon for signing.
    - Dpkg::Gettext: Fix typo in POD.
    - Dpkg::Changelog: Rename __sanity_check_range method to _sanitize_range.
    - Dpkg: Rename _sanity_check and _sanity_check_opts to _check_opts.
    - Dpkg::Source::Package: Rename _sanity_check to _check_workdir.
    - Dpkg::Shlibs::Objdump: Rename ELF constants to match more closely the
      spec.
    - Dpkg::Gettext: Add new gettext compatibility stub.
    - Dpkg::Shlibs: Handle unknown executable file formats.
      Reported by Helmut Grohne <helmut@subdivi.de> (on IRC).
    - Dpkg::OpenPGP: Add Stateless OpenPGP (SOP) backend support.
  * Make fragments:
    - Switch Fortran compiler variables to use gfortran.
      Spotted by Enrico Zini <enrico@debian.org>. Closes: #1024421
  * Documentation:
    - doc: Spell SELinux correctly.
    - man: Clarify how --build-by and --release-by get passed to
      dpkg-genchanges.
    - doc: Use https:// URLs instead of http:// when possible (round four).
    - doc: Switch releases download link from ftp.debian.org to deb.debian.org.
    - doc: Update git repo URL and mention it being the primary one.
    - doc: Fix typos.
    - man: Fix typo in markup.
    - man: Add description of bug closure Perl regex in deb-changelog(5).
      Based on a patch by Daniel Shahaf <danielsh@apache.org>.
      See #953911.
    - man: Clarify when package names get arch-qualified in dpkg-query output.
      Reported by Jakub Wilk <jwilk@jwilk.net> (on IRC).
    - doc: Do not use UTF-8 quotes in POD.
    - doc: Remove __END__ marker for ending POD documentation.
    - doc: Fix typos in coding-style.txt.
    - doc: Do not use «e.g.» outside parenthesis.
    - doc: Use US English spelling.
    - man: Switch debian-installer modules.txt reference to a git URL.
    - man: Clarify that dpkg-buildpackage --build components imply a single
      type. Closes: #927265
    - man: Clarify «hold» behavior with explicit actions in --force-hold
      text.
      See #985749.
    - man: Add references to deb-src-symbols(5) from deb-symbols(5).
    - doc: Fix «i.e.» usage.
    - man: Clarify dpkg-maintscript-helper switched symlinks/dirs need be
      shipped. Closes: #974053
    - man: Clarify Build-Profiles syntax in deb-src-control(5).
      Thanks to Christoph Berg <myon@debian.org>. Closes: #1022237
    - man: Clarify dpkg-buildpackage --sign-key description.
    - man: Mark «lto» as bold in list title in dpkg-buildflags(1).
    - man: Clarify PIE and ASLR acronyms and grammar in dpkg-buildflags(1).
    - man: Fix --depotdir default pathname in dpkg-split(1).
  * Code internals:
    - dpkg-genbuildinfo: Use Dpkg::Version to parse source version.
    - libdpkg: Fix type name for AIX dpkg_get_progname() implementation.
    - dpkg-deb: Move DPKG_DEB_THREADS_MAX parsing from libdpkg.
    - dpkg-deb: Refactor parse_compress_type() from set_compress_type().
    - dpkg: Remove redundant «continue» keyword at the end of a loop.
    - dpkg-fsys-usrunmess: Do not pass to print a ref to *STDERR.
    - update-alternatives: Call tzset() explicitly now that we use
      localtime_r().
    - dpkg-name: Use none() instead of ad-hoc comparisons.
    - dpkg: Rename struct relationinfo string member to op.
    - dpkg: Rewrite relationinfos array variable definition.
    - dpkg: Use explicit EXIT_SUCCESS/EXIT_FAILURE instead of 0/1 in
      relationinfos.
    - libdpkg, dselect: Reformat enum declarations.
    - libdpkg: Add new varbuf_add_dir() function.
    - libdpkg, dpkg: Use varbuf_add_dir() instead of _add_str() + _add_char().
    - libdpkg: Use updatesdir when using the updates directory.
    - libdpkg: Use pkg_infodb_get_dir() on opendir() instead of oldname.
    - libdpkg: Associate each varbuf_state to a varbuf.
    - libdpkg: Add new varbuf_rollback_len() and varbuf_rollback_start()
      functions.
    - libdpkg: Switch updatefn handling to use varbuf snapshots.
    - libdpkg: Rewrite fnis array variable definition.
    - libdpkg: Remove trailing «/» from UPDATESDIR definition.
    - dpkg-genchanges: Use intermediate variables to access fields.
    - dpkg-genchanges: Refactor $is_backport check into a boolean.
    - dselect: Unconditionally load perl modules included in perl-base.
    - dselect: Remove unused Net::FTP import from ftp method scripts.
    - scripts: Switch to use file_slurp() instead of open coding it.
    - scripts: Switch to use file_dump() instead of open coding it.
    - scripts: Switch to use file_touch() instead of open coding it.
    - dpkg-buildpackage: Rename $signkey to $signkeyid.
    - dpkg-buildpackage: Move error report into singfile().
    - dselect: Use %zd instead of %jd for pointer difference in format string.
    - libdpkg: Refactor system meminfo gathering into its own module.
    - libdpkg: Refactor meminfo gathering into a filename generic function.
    - libdpkg: Use an enum for meminfo return error codes.
    - libdpkg: Fix available memory computation for xz thread scaling.
      Closes: #1023870
    - dselect: Declare constructor with one argument as explicit.
    - libdpkg: Fix doxygen comment to match function argument.
    - libdpkg: Refactor database trigger await option parse/dump.
    - libdpkg: Parse and dump the explicit trigger await option on interest
      changes.
    - libdpkg: Switch trk_explicit_interest_change() to use
      pkg_spec_parse_pkg().
    - libdpkg: Add a new pnaw_same package name printing mode.
    - libdpkg: Remove unneeded intermediate variable in dpkg_fsys_set_dir().
    - dpkg-trigger: Refactor trigger activation into a new function.
    - dpkg-trigger: Turn do_check() into a cipaction function.
    - dpkg-trigger: Use ACTION macros and cipaction for CLI action selection.
    - dpkg-divert: Load database only from within relevant actions.
    - dpkg-statoverride: Load database only from within relevant actions.
    - src: Handle --help and --version as proper actions.
    - libdpkg: Refactor debug_parse_mask().
    - libdpkg: Add support for a new DPKG_DEBUG environment variable.
    - src: Make instdir static.
    - src: Avoid using instdir directly except for initialization.
    - libdpkg: Add new options-dirs module to handle directory option parsing.
    - libdpkg: Automatically initialize fsys and db dirs on demand.
      Reported by stackomatiker (on stackoverflow).
      See https://stackoverflow.com/questions/73529576.
  * Build system:
    - Add the author testing dependencies to Build-Depends under a profile.
    - Fully switch to libmd for MD5 implementation.
    - Simplify author testing.
    - Consider Dselect prefixes as perl modules too in gen-changelog.
    - Move authorcheck target to tap.am.
    - Sort test_data variables.
    - Use long options for lcov invocations.
    - Fix coverage reports after code restructuring.
    - Use long options for autotools commands.
    - Do not ignore Makefile under the functional test suite.
    - Consider src and scripts prefixes as internal in gen-changelog.
    - Consider scripts/mk prefixes as new «Make fragments» in gen-changelog.
  * Packaging:
    - Bump Standards-Version to 4.6.1 (no changes needed).
    - Properly install specs under /usr/share/doc/dpkg/spec/.
    - Do not compress spec files.
    - Update bogus lintian tag format.
    - Update debbugs usertags.
    - Switch from gpg to gnupg for author testing Build-Depends.
    - Add build dependencies for release process.
  * Test suite:
    - Do not use unportable -a option to cp.
    - Use «perl» instead of «stat -c '%s'».
    - Redirect dd stderr to /dev/null instead of using status=none argument.
    - Remove stray backslash before comma.
    - Add Dpkg::File unit tests.
    - Improve OpenPGP unit tests and check verification and signing.
    - Add unit tests for meminfo module.
    - Refactor total number of expected known architectures into a variable.
    - Use long options for aspell invocation.
    - Use --quiet instead of -q on cppcheck invocations.
    - Move active line-based cppcheck suppressions into inline comments.
    - Make cppcheck unknownMacro suppression more specific.
    - Tell cppcheck the C/C++ standards the code intends to comply with.
    - Remove unused cppcheck suppressions.
    - Use pkginstance in a new unit test.
    - Switch NULL to DPKG_NULL in header file.
    - Add functional tests for triggers database handling.
    - Fix typo in update-alternatives test comment.
    - Fix typo in DPKG_GEN_FSYS_LINK m4 macro.
    - Rename m4 variables that matched environment variable names.
    - Add functional tests for --root, --instdir and --admindir options.
  * Localization:
    - Fix typo in Japanese translation.
      Thanks to Kisaragi Marine <kisaragi.effective@gmail.com>.
      Closes: #1023376
    - Update Catalan translations.
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1021442, #1021443
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1018682
    - Update Simplified Chinese programs translation.
      Thanks to Boyuan Yang <byang@debian.org>. Closes: #1021281
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1021091

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 01 Dec 2022 12:12:14 +0100

dpkg (1.21.9) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add support for --threads-max and DPKG_DEB_THREADS_MAX.
    Prompted by vv221 on IRC.
  * Perl modules:
    - Dpkg::Source::Package::V2: Always fix the permissions for upstream
      tarballs. Closes: #1012195
    - Dpkg::BuildFlags: Document optimize feature area.
  * Documentation:
    - man: Clarify that statoverrides do not need to be known to dpkg.
      Closes: #1011510
    - man: Expand Protected and Essential field use cases. Closes: #1008780
    - doc: Rename frontend.txt to frontend-api.txt.
    - doc: Move specifications under doc/spec.
    - man: Add references to rootless-builds.txt spec.
  * Code internals:
    - libdpkg: Refactor command actions for compression.
  * Build system:
    - Split the test-runner into its own script.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Jul 2022 11:25:58 +0200

dpkg (1.21.8) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-statoverride: Add support for --force-not-root. Closes: #1009069
    Based on a patch by John Spencer <maillist-dpkg@barfooze.de>.
  * dpkg: Fix «De-configuring» message to allow configuration to use new
    version.
  * Perl modules:
    - Dpkg::Source::Archive: Prevent directory traversal for in-place extracts.
      Reported by Max Justicz <max@justi.cz>. Fixes CVE-2022-1664.
    - Dpkg::Substvars: Add support for optional substvars assigned with ?=.
  * Documentation:
    - man: Reference deb-substvar(5) from dpkg-source(1) and dpkg-shlibdeps(1).
    - man: Structure and clarify deb-substvars(5).
      Prompted by Niels Thykier <niels@thykier.net>.
  * Build system:
    - Unhook dist-cpan from make dist target.
  * Packaging:
    - Silence warning about merged-usr-via-aliased-dirs on Ubuntu.
    - Remove useless [] around tr sets.
  * Localization:
    - Update Dutch translations. Closes: #1010031, #1010032, #1010033
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Update Portuguese man pages translations. Closes: #1011095
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 25 May 2022 10:39:29 +0200

dpkg (1.21.7) unstable; urgency=medium

  - The “Social Contract §3: We will not hide problems”
    and “Persuasion through bullying and abuse” release. -

  [ Guillem Jover ]
  * dpkg-fsys-usrunmess: Handle /lib/modules itself also being untracked.
    Closes: #1008764
  * Documentation:
    - man: Fix typo. Thanks to Peter Krefting <peter@softwolves.pp.se>.
      See #1008706.
  * Packaging:
    - Silence warning about merged-usr-via-aliased-dirs on Debian.
  * Localization:
    - Fix gettext parameter reordering syntax for German translation.
      Closes: #1008671
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1008706

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Apr 2022 02:27:33 +0200

dpkg (1.21.6) unstable; urgency=medium

  - This also clears a bullying NMU. -

  [ Guillem Jover ]
  * Documentation:
    - man: Document untracked kernel module files handling in
      dpkg-fsys-usrunmess(8).

 -- Guillem Jover <guillem@debian.org>  Tue, 29 Mar 2022 11:56:58 +0200

dpkg (1.21.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-fsys-usrunmess: Explicitly set user/group and mode for created dirs.
    Closes: #1008478
  * dpkg-fsys-usrunmess: Set a known umask before starting. See #1008478.
  * dpkg-fsys-usrunmess: Special case untracked kernel module files.
    Closes: #1008316
  * Perl modules:
    - Dpkg::Control::Types: Use bit shifts instead of literals in enum.
    - Dpkg::Control::Fields: Fix field_register() to return nothing.
    - Dpkg::Control::Fields: Refactor manifest types into new
      ALL_FILE_MANIFEST.
    - Dpkg::Control::Fields: Fix POD to end sentences with a dot.
    - Dpkg::Control::Fields: Fix POD to add missing spaces and blank lines.
    - Dpkg::Control::Fields: Document and clarify return types and values in
      POD.
  * Code internals:
    - libdpkg: Rename f_revision() to f_obs_revision().
    - libdpkg: Warn when parsing obsolete Recommended/Optional/Class fields.
      Prompted by David Kalnischkies <donkult@debian.org>.
    - libdpkg: Add missing dependency type to obsolete dependency fields.
    - libdpkg: Update code comment for obsolete fields.
  * Test suite:
    - Add test cases for obsolete fields.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 29 Mar 2022 02:52:14 +0200

dpkg (1.21.4) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-shlibdeps: Require non-empty name and version in SONAME formats.
  * Perl modules:
    - Dpkg::Control::Fields: Remove duplicate *Built-Using from field order
      lists. Reported by David Kalnischkies <donkult@debian.org>.
  * Documentation:
    - man: Clarify uses cases for Static-Built-Using.
      Prompted by Shengjing Zhu <zhsj@debian.org>.
  * Test suite:
    - Use actual octal numbers for chmod() calls.
    - Do not use non-POSIX shell syntax for arithmetic expressions.
      Based on a patch by Sören Tempel <soeren@soeren-tempel.net>.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sat, 26 Mar 2022 13:38:44 +0100

dpkg (1.21.3) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Guillem Jover ]
  * dpkg-db-backup: Check for required commands before starting.
  * dpkg: Allow absolute pathnames for configurable external run-time tools.
    Based on a patch by Adrian Ho <the.gromgit@gmail.com>. Closes: #1007816
  * dpkg-fsys-usrunmess: Add options and prompt about regression prevention
    package. Prompted by Paul Wise <pabs@debian.org>.
  * dpkg-deb: Move duped control member check inside the detection conditional.
  * dpkg-deb: Fix movecontrol() to take a directory argument.
  * dselect: Remove non-multi-cd code from multi_cd method.
  * dselect: Rename multicd method to media.
  * dselect: Remove left overs for mount support from disk method.
  * dselect: Remove bogus quote escaping from method setup scripts.
  * dselect: Rename disk method to file.
  * scripts: Use backport-version-regex vendor hook instead of hardcoding the
    marker.
  * Perl modules:
    - Dpkg::Source::Package::V3::Git: Name bundle remote as bundle.
    - Dpkg::Source::Package::V3::Git: Set origin remote to Vcs-Git if present.
    - Dpkg::Path: Resolve /dev/null before comparing canonicalized pathnames.
    - Dpkg::Compression: Conditionally use the gzip --rsyncable option.
    - Dpkg::Compression: Use gzip -n instead of --no-name.
    - Dpkg::Vendor: Add a new backport-version-regex hook.
    - Dpkg::Control::Fields: Add Static-Built-Using field support.
  * Documentation:
    - man: Clarify Built-Using field purpose and format.
  * Code internals:
    - libdpkg: Refactor file_is_exec().
    - libdpkg: Check that executables are regular files.
    - dpkg-fsys-usrunmess: Refactor prompting into a new function.
    - dpkg: Rename r variable to remainder.
  * Packaging:
    - Clarify the merged-usr-via-aliased-dirs warning.
      Prompted by Paul Wise <pabs@debian.org>.
    - Sync original bug-script merged-usr warning with postinst updates.
  * Test suite:
    - Check deb format with duplicate debian-binary and control.tar members.
    - Add further deb-split format checks.
    - Place deb-old and deb checks on their own test groups.
    - Check all currently supported deb-old formats.
  * Localization:
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1001915

 -- Guillem Jover <guillem@debian.org>  Thu, 24 Mar 2022 21:00:24 +0100

dpkg (1.21.2) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Fix memory leak in remove-on-upgrade handling.
  * dpkg-deb: Fix unexpected end of file conditions on .deb extract.
  * Use anchor links for the dpkg FAQ URLs.
  * update-alternatives: Do not skip --config with a single entry.
    Reported by David Kalnischkies <donkult@debian.org>.
  * update-alternatives: Refactor alternative_install().
  * update-alternatives: Use intermediate variables when parsing actions.
  * update-alternatives: Clarify option parse errors by printing the wrong
    values.
  * update-alternatives: Clarify bad usage message by enclosing in angles and
    quoting arguments.
  * dpkg-buildpackage: Switch terse make from -s to --no-print-directory.
    Closes: #1003164
  * scripts: Unify deprecated command-line option warnings.
  * dpkg-source: Fix alternate changelog file usage with 2.0 and 3.0 formats.
    Reported by Umut <ue16@gmx.de> (on IRC).
  * update-alternatives: Use the target timestamp when the symlink does not
    exist. Closes: #1004557
  * dselect: Handle window resizes in help and menu screens. Closes: #382307
  * dselect: Do not beep on key press errors in method and package list
    windows. Closes: #533639
  * dselect: Add support for --instdir.
  * Perl modules:
    - Dpkg::Control::FieldsCore: Sort control type entries in %FIELD_ORDER.
    - Dpkg::Control::FieldsCore: Refactor Vcs fields into a common variable.
    - Dpkg::Control::FieldsCore: Refactor testsuite fields into a common
      variable.
    - Dpkg::Control::FieldsCore: Accept Architecture as a debian/tests/control
      field.
    - Dpkg::Control::FieldsCore: Add missing allowed fields for (In)Release
      files.
    - Dpkg::Control::FieldsCore: Add field order for all control types.
    - Dpkg::Index: Switch key function for control tests to be a stanza index.
      Reported by Paul Gevers <elbrus@debian.org>.
    - Dpkg::Source::Package: Only generate the patch header if needed.
      Prompted by Umut <ue16@gmx.de> (on IRC).
    - Dpkg::Source::Package: Use File::Spec instead of ad-hoc concatenation.
  * Documentation:
    - man: Mention on what actions triggers get processed in dpkg(1).
      Closes: #1001010
    - man: Clarify that dpkg-divert --list pattern is optional.
      Thanks to наб <nabijaczleweli@nabijaczleweli.xyz>. Closes: #1001761
    - man: Use «main» git branch in examples.
    - man: Markup each individual element independently.
    - man: Refer to the relevant maintscript actions explicitly.
    - man: Add a missing preposition to deb-preinst(5).
    - man: Do not hardcode DPKG_ADMINDIR in update-alternatives.
    - man: Document that update-alternatives honors DPKG_ROOT.
    - man: Clarify --admindir and --instdir default values.
      Reported by Johannes Schauer Marin Rodrigues <josch@debian.org>.
  * Code internals:
    - libdpkg: Check that cip is not NULL before dereferencing it.
    - libdpkg: Add missing symbols to the version map.
    - libdpkg: Use the amount of available memory instead phys_mem/2.
      Thanks to Sebastian Andrzej Siewior <sebastian@breakpoint.cc>.
    - libdpkg: Refactor liblzma memlimit and cputhreads getters.
    - libdpkg: Dynamically allocate the buffers for de/compression I/O.
    - libdpkg: Increase I/O memory buffers from 4 to 32 KiB.
    - libdpkg: Pass struct compress_params as the first argument.
    - libdpkg: Pass struct compress_params to decompressors.
    - libdpkg: Refactor pkg_format_print() out from pkg_format_show().
    - libdpkg: Do not restrict source:* virtual fields to installed packages.
      Closes: #1004372
    - libdpkg: Do not allow argv with no arguments.
    - update-alternatives: Refactor alternative_has_broken_symlink().
    - update-alternatives: Move symlink removal inside fsys_symlink().
    - update-alternatives: Move filename generation outside alternative setup.
    - dselect: Rework windows resize to be signal safe.
    - scripts: Expand long word list into one entry per line.
    - scripts/mk: Remove unneeded conditionals.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - scripts/mk: Indent code in Makefile fragments.
      Thanks to Nicolas Boulenguez <nicolas.boulenguez@free.fr>.
  * Build system:
    - Terminate lists in variables with «# EOL».
    - Move build helper tools into build-aux/.
    - Reorganize dpkg programs source code under src/.
    - Move autotest suite under src/.
    - Move C test suite machinery into lib/dpkg/.
    - Fix relocated autotest test suite runner.
    - Fix gitignore for build-aux/ directory.
    - Namespace Config variable usage.
      Reported by Павловец Сергей Николаевич
      <s.pavlovets@ivcmf.by>.
    - Add gitlab CI test for shared library building.
    - Link all programs against libcompat.
      Prompted by Jörg Sonnenberger <joerg@NetBSD.org>.
    - Remove unused TESTDATA variable from autotest suite.
    - Rework TAP check hooking into the autotools machinery.
    - Move EXTRA_DIST close to the files it is acting on.
    - Refactor autotest dependencies into a new variable.
    - Refactor autotest machinery into an automake include file.
    - Fold autotest test suite machinery into src/ from src/at/.
    - Rename do_path_subst to do_make_subst.
    - Factor out installation variable substitution into a new subst.am file.
    - Move shell scripts into src/.
    - Make AS_TR_* calls more clear.
    - Support compression library names with dashes.
    - Add zlib-ng support.
    - Rename HAVE_LZMA_MT to HAVE_LZMA_MT_ENCODER.
    - Move zsh completion under a subdirectory.
    - Switch sed pseudo-in-place replace invocations with copy then move.
    - Add comment about «sed -i» not being portable.
      Prompted by Nicolas Boulenguez <nicolas@debian.org>.
    - Mark libcompat and libdpkg as internal components in changelog.
    - Support specifying previous and next tags to gen-changelog.
    - Use non-capturing groups in regex in gen-changelog.
    - Do not hardcode «main» section for title check in gen-changelog.
    - Use sort flag instead of hardcoding the section in gen-changelog.
    - Do not put localization entries on their own changelog group.
  * Packaging:
    - Ignore directories for the alternatives state fixup. Closes: #1001695
    - Update bug-script to clarify usrmerge systems are unsupported.
    - Install aclocal m4 files into libdpkg-dev.
    - Install optional localized man pages with dh_installman.
    - Add a new not-installed file.
    - Switch to use the dh sequencer.
    - Make TESTSUITEFLAGS extensible.
    - Pass -jN to autotools autotest test suite via TESTSUITEFLAGS.
    - Update lintian overrides.
    - Use dpkg-error.sh in postinst.
    - Warn in postinst about merged-/usr-via-aliased-dirs breakage.
  * Test suite:
    - Move AT_TESTED to testsuite.at.
    - Run the tools with --version.
    - Rename DPKG_GEN_FILE to DPKG_GEN_CTRL_FILE.
    - Refactor control file template generation.
    - Rewrite dpkg-realpath test from TAP to autotest.
    - Rewrite dpkg-divert test from TAP to autotest.
    - Remove now unused TAP tests support from src/.
    - Print field type name instead of id in test case description.
    - Add new pkg-format unit tests.
    - Fix test_command_exec program invocation.
      Thanks to Sören Tempel <soeren+git@soeren-tempel.net>.
    - Use a temporary file instead of unportable «sed -i».
      Prompted by Nicolas Boulenguez <nicolas@debian.org>.
    - Add test case for SOURCE_DATE_EPOCH.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Use «each» instead of «keys» and value fetching.
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
  * Localization:
    - Remove previous msgid for non-fuzzy translations.
    - Update Catalan translations.
    - Update Dutch translation. Closes: #1003671, #1003672, #1003673
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Update Swedish translations. Closes: #1003799, #1007116
      Thanks to Peter Krefting <peter@softwolves.pp.se>.

  [ Sven Joachim ]
  * Localization:
    - Update German dselect translation.
    - Update German programs translation.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 13 Mar 2022 20:17:35 +0100

dpkg (1.21.1) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-buildpackage: Remove duplicate command print for dpkg-genchanges.
  * dpkg-buildpackage: Fix build description due to improper multiline match.
  * dpkg-realpath: Remove spurious heading space from --help output.
  * update-alternatives: When initializing admindir from DPKG_ADMINDIR append
    "/alternatives". Closes: #1001198
  * Code internals:
    - Remove <ar.h> inclusions.
  * Packaging:
    - Install deb-md5sums(5) into dpkg-dev package.

 -- Guillem Jover <guillem@debian.org>  Mon, 06 Dec 2021 21:04:18 +0100

dpkg (1.21.0) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genchanges: Include orig tarball on source package renames.
    Closes: #980066
  * scripts: Consider SHA-1 and RIPEMD-160 weak algorithms in OpenPGP
    signatures.
  * dpkg: During unpack print a removal message due to Conflicts.
    Closes: #985401
  * scripts: Add zsh completions for dpkg-parsechangelog.
    Thanks to Daniel Shahaf <danielsh@apache.org>. Closes: #986103
  * dpkg-buildpackage: When printing build type match the extension exactly.
    Closes: #989824
  * dpkg-maintscript-helper: Use xargs -I argument instead of deprecated -i.
  * dpkg-maintscript-helper: Quote variable inside ${} to avoid pattern match.
  * libdpkg: Fix dpkg_fsys_get_path() to always strip leading / and ./.
  * libdpkg: Set the default database directory relative to the system root.
  * dpkg-divert, dpkg-statoverride: Set admindir after instdir.
  * update-alternatives: Fix admindir setting.
    Prompted by Johannes Schauer Marin Rodrigues <josch@debian.org>.
  * dselect: Honor DPKG_ADMINDIR environment variable.
  * dpkg-query, dpkg-trigger, dselect: Add support for setting the root
    directory.
  * dpkg-fsys-usrunmess: Move forced reconfiguration to the last step.
    See #991190.
  * dpkg-fsys-usrunmess: Install a local policy-rc.d to ignore service
    restarts. Closes: #991190
  * dpkg-fsys-usrunmess: Do not fail when removing lingering directories.
  * dpkg-fsys-usrunmess: Generate a regression prevention package.
  * dpkg-fsys-usrunmess: Fix typo in debug message.
  * dpkg: Distinguish deconfiguration message for installation and multi-arch
    syncs.
  * dpkg-buildpackage: Add new --changes-file option.
    Prompted by Niels Thykier <niels@thykier.net>.
  * dpkg-buildpackage: Add new --buildinfo-file option.
  * dpkg: Rework --assert-<feature> logic to be more robust.
    Prompted by Helmut Grohne <helmut@subdivi.de>.
    Prompted by David Kalnischkies <donkult@debian.org>.
  * dpkg: Improve --assert-<feature> descriptions.
  * dpkg: Add a new --assert-help option.
  * scripts/mk: Pass DEB_BUILD_PATH to dpkg-buildflags. See #985553.
  * dpkg-db-backup: New program factored out from Debian-specific daily cron.
  * dpkg-db-backup: Accept an option to override the number of rotation cycles.
  * dpkg-db-backup: Honor the admindir set at configure time.
  * update-alternatives: Fix --auto and --set-selections output progress.
  * update-alternatives: Print defaults for configuration and database
    pathnames.
  * scripts: Replace shebang in dpkg-error shell library with shellcheck
    directive.
  * dpkg-buildpackage: Add support for terse DEB_BUILD_OPTIONS.
  * dpkg-mergechangelogs: Add new --merge-unreleased option. Closes: #582921
  * dpkg: Restore fallback to "new-prerm failed-upgrade" for downgrades.
    Analysis by Ian Jackson <ijackson@chiark.greenend.org.uk>. Closes: #996959
  * dselect: Use safe temporary file creation in methods setup.
  * dselect: Remove bashism from update script in multicd method.
  * dpkg: Fix --verify to handle missing or inaccessible pathnames.
    Closes: #963087
  * dpkg: Add partial --verify support for mode checks.
  * Use «digest» instead of «hash» in output messages.
    Reported by Sven Joachim <svenjoac@gmx.de>.
  * dselect: use `grep -E` instead of `egrep`.
    Thanks to Ville Skyttä <ville.skytta@iki.fi>. Closes: #999600
  * libdpkg: Fix memory leak on End Of Tape condition in tar parser.
  * dpkg: Fix short lived memory leak with --recursive.
  * dpkg: Fix conffile removal-on-upgrade handling. Closes: #995387
  * dpkg-deb: Fix conffile name length tracking on remove-on-upgrade parsing.
    Reported by uau on IRC.
  * Architecture support:
    - Clarify that the regex columns need to be ordered to match first.
    - Add support for ARCv2 CPU. Closes: #980963
      Based on a patch by Alexey Brodkin <Alexey.Brodkin@synopsys.com>.
  * Portability:
    - start-stop-daemon: Define SOCK_NONBLOCK to 0 if not defined.
    - libdpkg: Add support for AIX to dpkg_get_progname().
  * Perl modules:
    - Dpkg::Source::Quilt: Add hint to check missing files on patch apply
      failures.
      Reported by Joseph Nahmias <jello@debian.org>.
    - Dpkg::Changelog::Parse: Require format plugins to inherit from
      Dpkg::Changelog.
    - Dpkg::OpenPGP: Refactor openpgp implementation execution into a new
      function.
    - Dpkg::Vendor::Debian: Refactor compiler flag names into an array.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area.
      Closes: #940571
    - Test::Dpkg: Print actual error messages in test_neutralize_checksums().
    - Dpkg::Deps: Use current_sub feature for __SUB__.
    - Dpkg::BuildFlags: Add support for ASFLAGS.
      See https://salsa.debian.org/debian/debhelper/-/merge_requests/50.
    - Dpkg::Compression: Use gzip --rsyncable unconditionally.
    - Dpkg::Changelog::Entry::Debian: Fix full month misuse warning.
    - Dpkg::Shlibs::Symbol: Emit a warning on fully qualified symver patterns.
      Closes: #993991
    - Dpkg::Control::HashCore: Add new keep_duplicate option.
    - Dpkg::Control::FieldsCore: Add new field_parse_binary_source().
      Closes: #980527
    - Dpkg::Control::FieldsCore: Fix types allowed for
      field_parse_binary_source().
      Reported by Johannes Schauer Marin Rodrigues <josch@debian.org>.
    - Dpkg::Shlibs::Objdump: Fix apply_relocations to work with versioned
      symbols. Closes: #1000421
    - Dpkg::Vendor::Ubuntu: Update Maintainer field logic to include
      “canonical”. Based on a patch by
      William 'jawn-smith' Wilson <william.wilson@canonical.com>.
      Closes: #1000557
    - Dpkg::Source::Package::V2: Add hint about version matching source tree.
      Based on a patch by Samuel Henrique <samueloph@debian.org>.
      Closes: #996044
  * Documentation:
    - man: Itemize dpkg-gensymbols -c levels.
    - man: Add man page for deb-md5sums(5).
      Reported by Maxim Cournoyer (on IRC).
    - man: Switch the Architecture field in deb-control(5) to required.
      Reported by Maxim Cournoyer (on IRC).
    - man: Make clear that dpkg-query arguments accept multiple values.
      Prompted by Rémi Rampin <remirampin@gmail.com>. See #913781.
    - man: Document dpkg-query --search and --listfiles output formats.
    - doc: Fix incorrect use of ‘an’ article.
    - doc: Update coding style to document POD instead of troff.
    - doc: Update THANKS file.
    - doc: Annotate current maintainer start year.
    - doc: Sort maintenance information chronologically.
    - man: Add versions since features where introduced.
    - man: Further clarify when re-inclusions of excluded pathnames happen.
      Closes: #871420
    - doc: Update Doxygen configuration from version 1.9.1.
    - doc: Improve description of dpkg suite.
      Prompted by Fabrice Bauzac-Stehly <noon@mykolab.com>.
    - man: Add a reference to where the Installed-Size algorithm is described.
    - man: Improve dpkg --verify-format rpm format documentation.
    - man: Document in deb-substvars(5) what ${} is good for.
      Prompted by Paul Wise <pabs@debian.org>.
    - man: Document in dpkg-architecture(1) target being useful for emulators
      too. Prompted by Helmut Grohne <helmut@subdivi.de>.
    - man: Document in dpkg-query(1) full --search and --listfiles output
      format. Prompted by Johannes Schauer Marin Rodrigues <josch@debian.org>.
  * Code internals:
    - Remove irrelevant or obsolete FIXME markers.
    - Turn FIXME markers denoting pending actions into TODO markers.
    - Turn FIXME markers giving historic information into simple Notes.
    - update-alternatives: Turn FIXME for explicit behavior choice into an XXX.
    - Use localtime_r() instead of localtime().
    - libdpkg: Remove MDEBUG support from m_malloc() implementation.
    - libdpkg: Mark dpkg_arch_unmark() arch_remove argument as const.
    - libdpkg: Mark treewalk_open() func argument as const.
    - dpkg: Mark ignore_depends() pkg argument as const.
    - dpkg: Mark deb_parse_conffiles() pkg argument as const.
    - libcompat: Remove local setexecfilecon() and require libselinux 2.3.
    - libdpkg: Add missing DPKG_{BEGIN,END}_DECLS in header files.
    - dpkg: Move SELinux function declarations into its own header file.
    - dpkg: Move the command action enum to its own header file.
    - dpkg: Switch from including "main.h" to "force.h".
    - dselect: Rename dme() to display_menu_entry().
    - dpkg: Split function handling deconfiguration due to install and removal.
    - libdpkg: Add new ACTION_MUX macro for continued options.
    - dpkg: Refactor --assert-<feature> handling to be data driven.
    - dpkg-fsys-usrunmess: Do not use interpolated strings for literals.
    - dpkg-db-backup: Add a license header comment.
  * Build system:
    - Fallback to $^X and 'perl' if $Config{perlpath} is unset or empty.
    - Bump minimal Perl version to 5.28.1.
    - Remove redundant localedir and pkgconfdir initializations.
    - Check for libsocket.
    - Do not set have_libmd on the found branch in AC_SEARCH_LIBS.
    - Switch DPKG_FUNC_C99_SNPRINTF from AC_LANG_SOURCE to AC_LANG_PROGRAM.
    - Check whether fsync(3) works on directories.
    - Remove obsolete AC_HEADER_STDC.
    - Detect appropriate sed program at configure time.
    - Rename DPKG_DEB_PROG_TAR to DPKG_PROG_TAR.
    - Parametrize the backups directory with a configure option.
    - Add a check for symlinks in the git repository.
    - Rename shell scripts to .sh.
    - Switch from hardcoded /run to parametrized runstatedir.
    - Use new Dpkg::Control keep_duplicate option in gen-changelog.
    - Use title-case for field in gen-changelog.
    - Execute run-script via CONFIG_SHELL.
      Reported by Larkin Nickle <me@larbob.org>.
    - Quote variables containing pathnames in m4 macros.
    - Add support for commit message fix up machinery in gen-changelog.
  * Packaging:
    - Use absolute pathnames in .install debhelper fragments.
    - Remove unused dh_installcron call for arch-indep targets.
    - Add support for a native systemd timer. Closes: #985444
    - Create auotpkgtest installation directory.
    - Bump Standards-Version to 4.6.0 (no changes needed).
  * Test suite:
    - Pass --ignore-builtin-builddeps to dpkg-buildpackage.
    - Use can_run() instead of find_command().
    - Add descriptions to makefile test runners.
    - Add unit tests for architecture bijective mapping property.
    - Suppress cppcheck constParameter check.
    - Suppress bogus cppcheck for nullPointerRedundantCheck.
    - Mark external sourced shell files for checking.
    - Ignore new shellcheck checks.
    - Remove shipped dpkg database.
    - Add re-inclusion of symlink case to t-filtering. See #871420.
    - Generate symlink during test build time.
    - Remove superfluous long filename.
    - Refactor parse_ctrl() from parse_dsc().
    - Update codespell stopwords.

  [ Helge Kreutzmann ]
  * deb-md5sums.pod: Fix typo.

  [ Add programs translations ]
  * Occitan (Quentin PAGÈS).

  [ Update dselect translations ]
  * German (Sven Joachim).

  [ Update man pages translations ]
  * German (Helge Kreutzmann).

  [ Update programs translations ]
  * German (Sven Joachim).
  * Polish (Marcin Owsiany, Łukasz Dulny).

  [ Update scripts translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sun, 05 Dec 2021 16:32:45 +0100

dpkg (1.20.8) unstable; urgency=medium

  [ Guillem Jover ]
  * start-stop-daemon: Open the --output file in append mode.
  * dpkg: Fix --auto-deconfigure for essential and protected during
    installation. Reported by Julian Andres Klode <jak@debian.org>.
    See #983014.
  * dpkg-realpath: Fix resolution for absolute symlinks on «/».
    Closes: #983855
  * dpkg-realpath: Fix symlink loop tracker.
  * Perl modules:
    - Test::Dpkg: Fix test data path fetching on CPAN.
    - Dpkg::Exit: Preserve exit code in END block.
  * Build system:
    - Group Test::Dpkg changelog entries into “Perl modules” section.
  * Packaging:
    - Run autopkgtest test suites in verbose mode.
  * Test suite:
    - Set PERL in the perl test suite.
    - Use gunzip instead of zcat and assume it might not be present.
    - Mock dpkg and gcc for architecture detection code.
    - Initialize DEB_BUILD_ARCH and DEB_HOST_ARCH to avoid computing them.
    - Update suppressions for cppcheck 2.4.

  [ Update man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #981884
  * German (Helge Kreutzmann).
  * Portuguese (Américo Monteiro). Closes: #980018

  [ Update programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #981882

  [ Update scripts translations ]
  * German (Helge Kreutzmann). Closes: #983865

 -- Guillem Jover <guillem@debian.org>  Tue, 13 Apr 2021 22:17:05 +0200

dpkg (1.20.7) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Do not consider the database locked with a missing lock file.
    Reported by David Kalnischkies <donkult@debian.org>.
  * Documentation:
    - man: Clarify and expand information on dpkg-realpath(1) man page.
      Closes: #979564
  * Packaging:
    - Update copyright notices in debian/copyright.
    - Bump Standards-Version to 4.5.1 (no changes required).
  * Test suite:
    - On as-root mode do not use sudo if already running as root.
    - Print WARN instead of FAIL for maintscript fd leaks.

  [ Update man pages translations ]
  * German (Helge Kreutzmann).

  [ Update programs translations ]
  * German (Sven Joachim).

 -- Guillem Jover <guillem@debian.org>  Sat, 09 Jan 2021 00:59:45 +0100

dpkg (1.20.6) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Fix undefined behavior in varbuf functions.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * libdpkg: Fix memory leaks in tar_extractor().
  * libdpkg: Fix memory leak in trigger deferred processing.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * libdpkg: Fix memory leak in filesystem treewalk node free function.
  * libdpkg: Fix memory leak in filesystem treewalk iterator.
  * libdpkg: Fix single-instance memory leak with fsys dir.
  * libdpkg: Fix short-lived memory leaks.
  * libdpkg: Reset error context errmsg after free().
  * dpkg: Fix memory leak for cidir.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * dpkg: Fix short-lived memory leak in --force-help output.
    Based on a patch by KOLANICH <kolan_n@mail.ru>.
  * dpkg-deb: Fix single-instance memory leak on missing conffiles control
    file.
  * dpkg-divert: Fix short-lived memory leaks.
  * dpkg-realpath: Add new -z, --zero option.
    Requested by Johannes Schauer <josch@debian.org>.
  * dpkg-deb: Make decompression error message more descriptive.
    Closes: #968442
  * dpkg-architecture: Add a --print-format option.
    Prompted by #968963.
  * dpkg-buildpackage: Warn on known R³ values in uppercase.
    Reported by Niels Thykier <niels@thykier.net>.
  * dpkg-buildpackage: Error out on R³ "yes" value.
    Requested by Niels Thykier <niels@thykier.net>.
  * dpkg-buildpackage: Clarify R³ keyword diagnostic messages.
  * dpkg-deb, dpkg-split: Fix time handling to support 64-bit time.
  * libdpkg: Check that the ar archive time is within bounds.
  * libdpkg: Ignore not-installed packages for source related virtual fields.
    Closes: #972580
  * libdpkg: Make source version parsing more robust on missing data.
    See #972580.
  * libdpkg: Do not forget not-installed packages that are set on hold.
    Reported by David Kalnischkies <donkult@debian.org>.
  * update-alternatives: Fix memory leaks for alternative database context on
    load errors.
  * update-alternatives: Fix short-lived memory leaks for alternative structs.
  * update-alternatives: Fix memory leaks with new_choice.
  * update-alternatives: Fix short-lived memory leaks for log_file and admdir.
  * dpkg-buildflags: Add support for DFLAGS. Closes: #975896
  * dpkg-parsechanaglog: Document --file in --help output.
  * libdpkg: Fix allocation size wrap around when growing a varbuf.
  * dpkg-query: Do not print database loading progress. Closes: #977240
  * Rename taint tag to merged-usr-via-aliased-dirs.
  * dpkg-buildflags: Enable reproducible=fixfilepath by default.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>.
    See https://lists.debian.org/debian-devel/2020/10/msg00222.html.
    Closes: #974087
  * start-stop-daemon: Move umask setup before any file has been created.
  * start-stop-daemon: Add a new --output option to redirect stderr and stdout.
  * dpkg-maintscript-helper: Do not pass DPKG_ROOT prefixed pathmames to
    dpkg-realpath.
  * dpkg: When removing old files check the pathname with diversion and
    instdir.
  * dpkg-realpath: Make 'link includes root prefix' error more verbose.
  * libdpkg: Make sure we do not walk on rootless trees.
  * dpkg: Fix incorrect logic around printing dependency warnings.
    Thanks to Jessica Clarke <jrtc27@debian.org>.
    Reported by Helmut Grohne <helmut@subdivi.de>.
  * Support remove-on-upgrade conffile flag via DEBIAN/conffiles.
    Based on a patch by Niels Thykier <niels@thykier.net>. Closes: #822462
  * dpkg-fsys-usrunmess: New program.
  * Perl modules:
    - Dpkg::Index: Add new item_opts option.
    - Dpkg::Exit: Fix exit handler on program termination. Closes: #966083
    - Dpkg::Changelog::Entry::Debian: Fix format string.
      Prompted by #967911.
    - Dpkg::Changelog::Parse: Add new verbose option.
      Prompted by #967911.
    - Dpkg::Changelog::Parse: Document 'label' option.
    - Dpkg::Source::Package::V1: Print a message when verifying tarball
      signatures.
    - Dpkg::Path: Fix pathname traversal check for symlinks. Closes: #971203
    - Dpkg::Source::Package: Honor no_check for directory traversal checks.
      See #971203.
    - Dpkg::Source::Package: Call syserr() instead of syserror().
      Reported by Drew Parsons <dparsons@debian.org>.
      See #849752. Closes: #976249
    - Dpkg::Path: Check first whether the files are the same by comparing
      string-wise. Closes: #849752
    - Dpkg::OpenPGP: Refactor gpg armor code into its own function.
  * Documentation:
    - man: Fix typo in --print-unset option reference.
      Reported by Ferenc Wágner <wferi@debian.org>. Closes: #966110
    - man: Clarify that dpkg-architecture uses some of its own variables.
      Closes: #966111
    - man: Fix casing and namespacing in VARIABLES definitions.
    - man: Fix typo in dpkg-source(1).
      Thanks to Paul Wise <pabs@debian.org>.
    - man: Add a reference to deb-symbols(5) in deb-src-symbols(5) DESCRIPTION.
      Prompted by #970083.
    - man: Specify that symbol, version and id are separated by a single
      whitespace. Closes: #970083
    - man: Clarify day-of-month format in deb-changelog(5).
      Reported by Axel Beckert <abe@debian.org>.
      See #971977.
    - man: Update update-alternatives maintainer script usage information.
      Prompted by Niels Thykier <niels@thykier.net>.
    - man: Switch to use L<> markup for URLs instead of B<>.
    - doc, man: Clarify that R³ values are case sensitive.
      Prompted by Niels Thykier <niels@thykier.net>.
    - man: Add references to deb822(5) to file formats based on it.
      Prompted by Niels Thykier <niels@thykier.net>.
    - man: Clarify config-files state in dpkg(1).
      Prompted by Stuart Prescott <stuart@debian.org>.
    - man: Fix typos.
    - man: Hyphenate multiple words in deb-override(5) format description.
    - man: Uppercase acronyms and logic operators.
    - man: Empty or whitespace-only lines in deb-conffiles(5) are not accepted.
  * Code internals:
    - libcompat, dpkg: Stop using deprecated security_context_t data type.
    - update-alternatives: Refactor alternative database context freeing into a
      new function.
    - libdpkg: Do not define the clamp macro when compiling C++ code.
      Reported by Helmut Grohne <helmut@subdivi.de>.
    - libdpkg: Replace FSF address by pointing to the gnu.org URL.
    - libdpkg: Initialize pkgbin's newhash to NULL.
      Prompted by Steinar H. Gunderson <sesse@debian.org>.
    - libdpkg: Use memset() instead of open-coding struct blanking.
      Prompted by Steinar H. Gunderson <sesse@debian.org>.
    - Do not call fsys_hash_init() before command actions.
      Prompted by Steinar H. Gunderson <sesse@debian.org>.
    - libdpkg: Fix m_pipe() function definition prototype to match declaration.
    - libdpkg: Refactor new str_rtrim_spaces().
      Based on a patch by Niels Thykier <niels@thykier.net>.
    - dpkg: Call fsys_hash_find_node() outside tar_fsys_namenode_queue_push().
    - Use a conffilename variable to track the actual conffile name in the
      buffer.
      Thanks to Niels Thykier <niels@thykier.net>.
  * Build system:
    - Add new gen-changelog tool.
    - Pre-process the curses header before parsing it. Closes: #970545
    - Fix variable substitution in man pages.
      Reported by Niels Thykier <niels@thykier.net>. Closes: #978983
    - Add a README.cpan to be installed as README in the CPAN distribution.
    - Do not try to use <sys/sysctl.h> on GNU/Linux.
    - Fix «make distcheck» for man pages.
    - Update GitLab CI configuration to use built-in functional test suite.
    - Make it possible to override PKGDATADIR on built scripts too.
    - Disable umask to 0 for Docker executor in GitLab CI.
    - Disable functional test suite debug mode on GitLab CI.
    - Sort po4a entries in po4a.cfg.
  * Packaging:
    - Do not fail the bug-script if readlink fails. Closes: #968397
    - Improve cron file robustness on missing or empty backup files.
      Closes: #969472
    - Use AUTOPKGTEST_TMP instead of writing into the source tree.
    - Hook the functional test suite into autopkgtest.
    - Remove trailing comma from lintian profile file.
    - Do not hardcode libdpkg-perl dependency on perl:any.
      Thanks to Sven Joachim <svenjoac@gmx.de>.
  * Test suite:
    - Fix short lived memory leaks in unit tests.
    - Print the ehandle unit test error output on verbose mode.
    - Improve dpkg-divert test to output stdout and stderr.
    - Use intermediate variable for directory traversal item iteration.
    - Refactor root handling in Dpkg::Path unit tests.
    - Refactor test verbose check into an inline function.
    - Make it possible to include test.h from benchmarks.
    - Disable hash reports in benchmark tests unless verbose.
    - Add support for basic test try/catch/finally keywords.
    - Merge the dpkg-tests.git repository into tests/.
    - Update merged functional test suite assumptions.
    - Remove redundant test cases from the functional test suite.
    - Remove source package building support from functional test suite.
    - When using DPKG_BUILDTREE add scripts/ to DPKG_PATH.

  [ Add man pages translations ]
  * Portuguese (Américo Monteiro). Closes: #964751

  [ Update dselect translations ]
  * Dutch (Frans Spiesschaert). Closes: #968294
  * French (Didier Vidal). Closes: #964749

  [ Update man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #968743
  * German (Helge Kreutzmann).

  [ Update programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #968744
  * German (Sven Joachim).

  [ Update scripts translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Fri, 08 Jan 2021 04:39:40 +0100

dpkg (1.20.5) unstable; urgency=medium

  [ Guillem Jover ]
  * Revert change to prefix the specs file spec string self_spec with +
    instead of *. The prefix is supposed to go in the text itself
    instead of the spec name, which already had it. This change only
    apparently fixed the issue at hand because gcc started parsing it as
    the «[SUFFIX]:» case, completely disabling the PIE handling.
    Thanks to Thorsten Glaser <tg@mirbsd.de>.
  * Perl modules:
    - Dpkg::Source::Package::V1: Explicitly initialize constructor options to
      their implicit values, otherwise other code end up assuming different
      defaults. This is required here too as this class does not call the
      initialization from its parent.
  * Build system:
    - Detect the GNU program variants for make, patch and tar in the CPAN
      distribution to replace in the Dpkg module.
    - Set DEB_BUILD_ARCH to a dummy “amd64” in the CPAN distribution tests
      to not require a dpkg(1) in the system.
  * Test suite:
    - Only print the Dpkg::Path::check_directory_traversal() error on failure.

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Wed, 08 Jul 2020 05:40:39 +0200

dpkg (1.20.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Improve PIE flags support:
    - Prefix the specs file spec string self_spec with + instead of *.
      This way we do not override any previous setting, otherwise when
      passing the -specs options twice (f.ex. to compile and link), only the
      last one will take effect, which can break the build. Closes: #870383
  * Perl modules:
    - Dpkg::Source::Package: Explicitly initialize constructor options to
      their implicit values, otherwise other code end up assuming different
      defaults. Closes: #964017
    - Dpkg::OpenPGP: Use a temporary directory for the GnuPG homedir in
      verify_signature(), to make sure we do not write to the user home
      directory, except for the trustkeys.db file if present.
    - Dpkg::Path: Refactor new check_directory_traversal() function out of
      Dpkg::Source::Package->extract().
    - Dpkg::Path: Do not do partial matches for directory traversal checks,
      expect a trailing slash after the base directory name.
    - Dpkg::Path: Catch uncanonicanizable pathnames with a proper error.
      Closes: #964111
    - Dpkg::Path: Do not consider missing symlink targets a directory
      traversal attempt. Closes: #964234
    - Dpkg::Path: Allow /dev/null for directory traversals.
      Reported by Holger Levsen <holger@layer-acht.org>.
  * Build system:
    - Add Module::Signature as configure recommends for CPAN.
  * Test suite:
    - Use File::Path::make_path() instead of chained mkdir() in Dpkg_Path.t.
    - Add unit tests for Dpkg::Path::check_directory_traversal().

  [ Updated programs translations ]
  * German (Sven Joachim).

 -- Guillem Jover <guillem@debian.org>  Tue, 07 Jul 2020 07:57:48 +0200

dpkg (1.20.3) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::OpenPGP: Pass --no-options to gpg in verify_signature().
      Reported by Bertrand Marc <bmarc@debian.org>. Closes: #963839
    - Dpkg::Build::Info: Clarify by giving context to the
      get_build_env_whitelist() deprecation warning. Closes: #963844
      Reported by Sven Joachim <svenjoac@gmx.de>.
    - Dpkg::Source::Package: Fix check_original_tarball_signature() to make
      import_key() honor require_valid_signature, which should default to
      false. Reported by Mattia Rizzolo <mattia@debian.org>.
    - Dpkg::OpenPGP: Use a temporary directory for the GnuPG homedir in
      import_key(), to make sure we do not write to the user home directory,
      which might be read-only or non-existent. Closes: #963944
      Reported by Mattia Rizzolo <mattia@debian.org>.
  * Code internals:
    - libdpkg: Print a notice if we cannot write to the log file.
  * Build system:
    - Improve error diagnosis for configure version fetching script.
      Prompted by Norbert Preining <norbert@preining.info>.

  [ Updated programs translations ]
  * German (Sven Joachim).

 -- Guillem Jover <guillem@debian.org>  Mon, 29 Jun 2020 12:37:51 +0200

dpkg (1.20.2) unstable; urgency=medium

  * dpkg: Do not include the architecture with --robot --version.
  * update-alternatives: Create alternatives directory (/etc/alternatives)
    if it is missing, to help with installation bootstrapping.
    Reported by Johannes Schauer <josch@debian.org>.
  * update-alternatives: Create the log directory if it is missing.
  * Perl modules:
    - Dpkg::Source::Package: Turn the missing expected tarball signature
      error into a warning for now, as it is causing unintended fallout,
      and does not play nice (yet) with tarballs repackaged by uscan(1).
      Closes: #963821
  * Code internals:
    - update-alternatives: Move log_msg() after make_path() so that we can use
      the latter.
    - update-alternatives: Add new xstrndup() and xdirname() functions.
  * Build system:
    - Set SHELL in the test environment.
    - Do not fail if po4a is not found, and search for it just once.
    - Fix name and section generation for translated man pages. This caused
      pod2man to get an empty --name argument and not output anything,
      resulting in generating empty man pages. Closes: #963794
  * Packaging:
    - Sort debian/dpkg-dev.manpages.
    - Install deb-src-symbols(5) in dpkg-dev package.

 -- Guillem Jover <guillem@debian.org>  Sun, 28 Jun 2020 00:42:11 +0200

dpkg (1.20.1) unstable; urgency=medium

  [ Guillem Jover ]
  * Fix dpkg logging regression introduced in 1.20.0:
    - libdpkg: Use varbuf member .used instead of .size in log_message(),
      to avoid printing garbage.
    - libdpkg: Open the log file as write-only instead of read-only.
    Thanks to Roderich Schupp <roderich.schupp@gmail.com>. Closes: #953684
  * Unify and cleanup Makefile fragment files comments, including information
    about version of introduction.
  * Add new buildopts.mk Makefile fragment to support parsing DEB_BUILD_OPTIONS
    options with arguments, such as “parallel” as DEB_BUILD_OPTION_PARALLEL.
  * dpkg-genchanges: Handle empty Date fields from parsed debian/changelog.
    Based on a patch by Baptiste BEAUPLAT <lyknode@cilg.org>. Closes: #956321
  * dpkg-source: Check that debian/tests/control has the required fields.
    Prompted by Felix Lechner <felix.lechner@lease-up.com>.
  * dpkg-deb, dpkg: Do not accept relative pathnames in DEBIAN/conffiles.
    Reported by Niels Thykier <niels@thykier.net>.
  * dpkg-split: Fix off-by-one check in ar header padding, that was making
    parsing error out on valid archives. Regression introduced in dpkg 1.18.8.
  * libdpkg: Fix error message for ending version character in dependency
    parser:
    - Move the version unterminated case before the catchall.
    - Print the actual wrong character and print what is expected.
  * libdpkg: Do not use econtext->errmsg on out of context abort, as it might
    be uninitialized.
  * update-alternatives: Set the umask to 022 on program start.
    Reported by Paul Wise <pabs@debian.org>.
  * dpkg-parsechangelog: Fix --show-field for multiline fields. We were not
    stripping trailing whitespace, and were not prefixing empty lines with
    a ‘.’, like when printing with the field names.
    Reported by Paul Wise <pabs@debian.org>.
  * dpkg: Add a new --robot option to be used with --version.
  * dpkg, dpkg-query: Document missing options in --help output.
  * Unify ellipsis formatting in programs --help output.
  * Add Protected field support.
  * dpkg-realpath: New program, to be used by dpkg-maintscript-helper, and
    any maintainer script that needs a realpath that can handle pathnames
    relative to the dpkg root directory.
  * dpkg-realpath: Add support for DPKG_ROOT.
    Thanks to Helmut Grohne <helmut@subdivi.de>.
  * dpkg-realpath: Add support for --root and --instdir options.
  * dpkg-maintscript-helper: Add support for DPKG_ROOT:
    - Add DPKG_ROOT support for conffiles.
      Thanks to David Kalnischkies <david@kalnischkies.de>.
    - Add DPKG_ROOT support for symlink to and from directory switches.
      Based on a patch by Bastien ROUCARIÈS <roucaries.bastien@gmail.com>.
    Closes: #832176
  * update-alternatives: Add DPKG_ROOT support, and new --root and --instdir
    options. Closes: #871808
  * Portability:
    - libdpkg: When using uselocale(), include <xlocale.h> for locale_t if
      the header is available. Needed on BSDs.
      Reported by Sirio Balmelli <sirio@b-ad.ch>.
  * Perl modules:
    - Dpkg: Add a LICENSE section to the POD.
    - Dpkg::Source::Package: Add new get_upstream_signing_key() method.
    - Dpkg::Source::Package: Check missing expected tarball signatures.
    - Dpkg::Source::Package::V1: Check version format matching source format.
    - Dpkg::Vendor::Debian: Add debian-nonupload.gpg keyring.
      Thanks to Taowa Munene-Tardif <taowa@debian.org>. Closes: #956055
    - Dpkg::Vendor::Debian: Detect merged-usr-via-symlinks also with absolute
      pathnames. Reported by Adam Borowski <kilobyte@angband.pl>.
    - Dpkg::Build::Info: Avoid whitelist in function name.
    - Dpkg::Shlibs::SymbolFile: Avoid blacklist and whitelist terms.
  * Documentation:
    - man: Fix misused two-fonts macros.
      Thanks to Bjarni Ingi Gislason <bjarniig@rhi.hi.is>. Closes: #955028
    - man: Trim trailing whitespace from output.
      Thanks to Bjarni Ingi Gislason <bjarniig@rhi.hi.is>. Closes: #955030
    - man: Mention that dpkg(1) does not provide all back-end interfaces.
      Prompted by Elana Hashman <ehashman@debian.org>.
    - man: Clarify and fix file formats SYNOPSIS.
    - man: Clarify that deb-control(5) is a subset of deb-src-control(5).
      Closes: #958229
    - man: Unify warning and note admonitions formatting.
    - man: Remove useless commented out macros.
    - man: Fix unbalanced quotes in macro arguments.
    - man: Specify the indentation level for all following .IP macros, not
      just the first one.
    - man: Use .TP macros instead of hand-crafted formatting.
    - man: Fix font markup for some variable and literal strings.
    - dpkg-maintscript-helper: Add -?, --help and --version to --help output.
    - man: Fix apt and aptitude references.
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Mark commands (eval) in bold and quote library names (libgcc).
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Use UTF-8 quotes instead of ancient groff register variables.
    - man: Use literal double quotes instead of groff escape sequences.
    - man: Clarify that we resolve bug reports not bug report numbers.
      Reported by Helge Kreutzmann <debian@helgefjell.de>.
    - man: Clarify POSIX shell eval command usage in dpkg-architecture(1).
    - man: Use item lists instead of verbatim or hand-crafted formatting.
    - man: Do not use verbatim formatting for text that is not an example.
    - man: Markup examples explicitly with .EX/.EE.
    - man: Fix indentation for a note admonition in dpkg-scansources(1).
    - man: Document that a 3.0 (quilt) patch cannot create or modify symlinks.
      Thanks to Johannes Schauer <josch@debian.org>.
    - man: Reword text to reduce length in verbatim code block.
    - man: Add semicolons before verbatim code blocks.
    - man: Update dselect methods provided. Several got removed in 1.20.0.
    - man: The Installed-Size field does not get its value from du(1) since
      1.18.0.
    - man: Fix dpkg-gencontrol -P description to not refer to dpkg-source.
      Reported by Jakub Wilk <jwilk@jwilk.net>.
    - man: Place description of override value column on its own paragraph.
    - man: Surround markup within verbatim blocks with .nf/.fi.
    - man: Balance font markup.
    - man: Do not nest font markup.
    - man: Use .ig/.. macros to disable text instead of commenting it out.
    - man: Do not mark end of sentence period with bold.
    - man: Add a missing comma after man page reference in SEE ALSO section.
    - man: Convert man pages from roff to POD.
    - man: Clarify the dpkg --no-act admonition.
    - man: Avoid whitelist term in dpkg-source man page.
  * Code internals:
    - Use $() in shell or qx() in perl instead of ``.
    - dpkg-split: Switch part number variables from unsigned int to int.
    - scripts: Refactor shell error handling into a shell library
    - Reformat shell code to follow the coding style.
    - update-alternatives: Parametrize option names in output strings.
    - update-alternatives: Move logging function close to output functions.
    - update-alternatives: Move argument parsing functions close to main().
    - update-alternatives: Add general purpose non-failing functions for
      administrative directory access.
    - update-alternatives: Add filesystem abstraction functions.
  * Build system:
    - Handle .git being a plain file when getting the dpkg tree version.
    - Add debian/changelog as a Changes file to the CPAN distribution.
    - Set DPKG_SERIES to 1.20.x when running the functional test suite.
    - When using po4a require at least po4a 0.59. Change the po4a --porefs
      argument from no longer supported “noline,wrap” to “file”, as wrapping
      is the default since po4a 0.58. We require po4a 0.59 as 0.58 had a
      regression in its --srcdir support.
    - Switch to set the po4a addendum in the po4a_paths section instead of
      repeating it for each man page.
    - Use po4a conditional addendum support, and remove empty addenda.
    - Use po4a mode=eof support in addenda.
    - Do not use make prerequisites on suffix rule definitions.
      Closes: #961850
    - Add man page number suffixes to the automake SUFFIXES variable.
    - Update false positive suppressions for cppcheck 2.1.
    - Install specifications and API contracts in docdir.
    - Add support for switching man pages from roff to POD format.
    - Fix shell files substitution for version variable.
  * Packaging:
    - Switch to debhelper compatibility level 13.
    - Remove debian/tmp prefix from manpages debhelper fragment files.
    - Handle missing localized man pages gracefully.
    - Install AUTHORS, THANKS, usertags, README.api and
      README.feature-removal-schedule only in dpkg.deb.
    - Rename debian/usertags to debian/README.bug-usertags.
    - Install specifications to /usr/share/doc/dpkg/ in the dpkg-dev package.
    - Detect merged-usr-via-symlinks also with absolute pathnames in
      bug-script. Reported by Adam Borowski <kilobyte@angband.pl>.
  * Test suite:
    - Rename deb-content test cases to make them more descriptive.
    - Skip autogenerated files from codespell.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Simplified Chinese (Boyuan Yang). Closes: #958437

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sat, 27 Jun 2020 02:41:48 +0200

dpkg (1.20.0) experimental; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Do not generate a backup file for the available database.
    Closes: #343578
  * perl: Switch Getopt::Long from bundling to bundling_values. This means
    the few scripts using Getopt::Long will stop accepting options in the
    form «-ab» for «-a -b», which is not future-proof, as it does not allow
    these options to get new arguments without making them ambiguous.
  * dpkg-buildpackage: Remove transient backwards R³ compatibility code.
  * buildtools.mk: Add support for nostrip in DEB_BUILD_OPTIONS when setting
    the STRIP variable.
  * dpkg-genbuildinfo: Do not include irrelevant packages in the Binary field.
  * dpkg: Do not clear selections for unknown packages. Closes: #927752
  * dpkg-shlibdeps: Add support for new Build-Depends-Packages, to be able
    to specify multiple packages. Closes: #926669
    Based on a patch by Frank Schaefer <kelledin@gmail.com>.
  * perl: Remove support for versioned GnuPG 2 program and packages.
  * libdpkg: Clarify lock contender error message. Print the PID of the lock
    contender, and add a warning explaining that removing the lock file is
    never the correct solution.
  * dpkg-genchanges, dpkg-mergechangelogs: Remove support for ~vola
    versioning, as volatile.debian.org was decommissioned some time ago.
  * dpkg-genchanges, dpkg-mergechangelogs: Match ~deb also as a backport
    marker in versions. Closes: #934980
  * libdpkg, dpkg: Use new versiondescribe_c() for non-localizable call sites,
    such as when writing to a log, which should not be localized.
    Reported by Julien Cristau <jcristau@debian.org>.
  * dpkg-query: Try to use the package synopsis from the available file if
    not installed. Closes: #43573
  * dpkg-gencontrol: Take into account hardlinks when computing the
    Installed-Size substvar. Closes: #923475
    Patch co-authored with Sven Joachim <svenjoac@gmx.de>.
  * dpkg: Fix and clarify behavior for packages marked to be on “hold”. These
    need to be processed for configuration and triggers. Closes: #926472
  * dpkg: Use DPKG_ADMINDIR to set the admindir. Closes: #900071
  * dpkg-source: Remove backwards compatibility code for legacy build-profiles.
  * perl: Give more context on field parsing errors. Closes: #637060
  * dpkg-buildpackage: Add option to sanitize environment. Closes: #843776
  * update-alternatives: Cope with a missing administrative directory.
  * update-alternatives: Create the administrative directory on demand.
  * dpkg-split: Cope with a missing parts/ database directory.
  * dpkg-split: Create the parts/ database directory on demand.
  * libdpkg: Consider msdbrw_needsuperuser equivalent to msdbrw_write, so
    the same checks are performed on normal non --force-not-root operation.
  * libdpkg: Add support for bootstrapping the installation of dpkg:
    Closes: #914515
    - Create the logfile with correct permissions, and remove the code
      setting up the logfile from the dpkg postinst.
    - Allow missing status and available databases, so that they get created
      on write, and remove the code setting them up from the dpkg postinst.
      Closes: #647911
    - Do not change the ownership of the triggers database directory. Either
      we are running as root:root which means the ownership should be correct
      already, or we are not which means we cannot change it anyway.
    - Create the dpkg database directory on demand.
    - Create the updates/ database directory on demand.
    - Create the info/ database directory on demand.
  * dpkg-architecture: Fix handling of exec failing in --command.
    Reported by Helmut Grohne <helmut@subdivi.de>.
  * dpkg-buildpackage: Do not accept equal signs as part of the hook names.
    Reported by Daniel Shahaf <danielsh@apache.org>. Closes: #948291
  * dselect: Mark a string for translation.
  * dselect: Cleanup access methods:
    - Remove harddisk methods, as they were non-functional due to fdisk
      interface changes, and do not make sense anymore as we can expect users
      to mount any such filesystem on their own, to then use a filesystem
      method instead. Prompted by Helmut Grohne <helmut@subdivi.de>.
    - Remove cdrom method superseded by the multi_cd method.
    - Remove nfs methods, as there is nothing special about NFS, and mounting
      these should just be left to the local admin, who can mount any other
      remote filesystem too.
    - Remove multi_mount method, as the multi_cd method can take care of
      mounting the necessary images or devices.
    - Replace changelog with correct copyright in file header.
  * dpkg, dselect: Stop using first-person singular in output messages.
  * libdpkg: Fix memory leak in parsedb context close.
  * buildtools.mk: Add QMAKE variable. Closes: #920878
  * po: Fix translation of --compare-versions. Closes: #951614
    Thanks to Boyuan Yang <byang@debian.org>.
  * Perl modules:
    - Dpkg::Source::Package: Verify original tarball signatures at build time.
    - Dpkg::BuildFlags: Add new unset() method.
      Requested by Daniel Schepler <dschepler@gmail.com>.
    - Dpkg::Source::Package::V2: Emit a special patch header on
      single-debian-patch. Closes: #933152
    - Dpkg::Vendor::Debian: Only scan /usr/local/ directories that exist.
      Closes: #932967
    - Dpkg::Vendor::Debian: Do not set -Werror=implicit-function-declaration
      for C++. Closes: #939969
    - Dpkg::Deps: Check for valid virtual package version relations. Do not
      allow non-equal version relations in virtual provides. Closes: #930317
    - Dpkg: Remove internal lowercase variables $version, $progname,
      $admindir, $dpkglibdir and $pkgdatadir.
    - Dpkg::Changelog: Remove obsolete methods dpkg() and rfc822().
    - Dpkg::Changelog::Entry::Debian: Remove obsolete methods check_header()
      and check_trailer(). Hide variables $regex_header and $regex_trailer.
    - Dpkg::Changelog::Parse: Remove warnings of obsolete options forceplugin
      and libdir. Remove obsolete functions changelog_parse_debian() and
      changelog_parse_plugin().
    - Dpkg::Compression: Hide internal lowercase variables
      $default_compression, $default_compression_level and
      $compression_re_file_ext.
    - Dpkg::Deps::KnownFacts: Remove obsolete check_package() method.
    - Dpkg::Exit: Hide internal lowercase @handlers variable.
    - Dpkg::Gettext: Remove obsolete _g() function.
    - Dpkg::Source::Package: Hide internal lowercase variable
      @tar_ignore_default_pattern. Remove internal lowercase variable alias
      $diff_ignore_default_regexp.
    - Dpkg::Substvars: Remove obsolete no_warn() method.
    - Dpkg::Index: Change default value for unique_tuple_key to 1.
    - Dpkg::Version: Remove deprecation warning from semantic change in
      bool overload.
    - Dpkg::Checksums: Remove obsolete 'program' property warning.
    - Dpkg::Conf: Remove obsolete methods and obsolete croak for method option.
    - Dpkg::Vendor: Remove obsolete 'keyrings' hook.
    - Dpkg::Exit: Unregister all signal handlers once we have executed them.
      Closes: #932841
    - Dpkg::Exit: Register exit handlers also for __DIE__.
    - Dpkg::Source::Package::V3::Native: Do not say v1.0 for 3.0 formats.
    - Dpkg::Dist::Files: On filename parse error say file instead of package.
    - Dpkg::Substvars: Add new vendor:Name and vendor:Id substvars.
    - Dpkg::Source::Package: Detect directory traversals under debian
      directory. Reported by Felix Lechner <felix.lechner@lease-up.com>.
  * Documentation:
    - man: Fix uncommon wording constructs.
    - man: Use a minus sign for a literal string.
    - man: Clarify that the pager is called via «$SHELL -c».
    - dpkg-shlibdeps: Document split_soname() function.
      Prompted by Christopher Crim <christopher.crim@quoininc.com>.
    - Dpkg::Changelog: Document methods provided by subclasses.
      Reported by Felix Lechner <felix.lechner@lease-up.com>.
    - man: Globally adjust left and disable hyphenation.
    - man: Split dselect(1) --color from --colour option items.
    - man: Describe the SONAME formats supported in deb-shlibs(5).
    - man: Move template symbol documentation into new deb-src-symbols(5).
    - Dpkg::Changelog::Parse: Remove $ sigil from option names in POD.
    - Dpkg: Say class instead of object when appropriate.
    - Dpkg::Changelog: Clarify that these classes inherit from some other
      base class, which will contain the missing documentation.
      Prompted by intrigeri <intrigeri@debian.org>.
    - man: Clarify deb-changelog(5) format. Closes: #946780
    - man: Clarify debian/source/include-binaries format in dpkg-source(1).
      Prompted by Felix Lechner <felix.lechner@lease-up.com>.
    - man, doc: Clarify that the postinst "triggered" argument gets the
      trigger-name(s) as a space-separated list in the second argument.
      Prompted by Michael Biebl <biebl@debian.org>.
    - dselect: Update the multicd README file.
    - doc, man: Mark T and I package instances to avoid misreadings.
  * Code internals:
    - Dpkg::Source::Package: Refactor original tarball handling.
    - perl: Use File::Copy instead of spawning mv/cp commands.
    - Dpkg::OpenPGP: Refactor signature verification into a new function.
    - Dpkg::OpenPGP: Make it possible to verify detached signatures.
    - Dpkg::OpenPGP: Add support for importing an OpenPGP key into a keyring.
    - Dpkg::BuildFlags: Remove unused hash keys.
    - libdpkg: Use the variable instead of a type as sizeof() argument.
    - libdpkg: Use the totalwritten variable for a consistency check.
    - dselect: Reduce scope of variable, to avoid it being unused in a branch.
    - dpkg-deb: Fold two adjacent if conditionals into a single one.
    - dpkg: Initialize flagdeppossi in check_conflict().
    - libdpkg: Add new C locale switch over support.
    - libdpkg: Add new versiondescribe_c() to force a C locale.
    - dselect: Make baselist::draw_column_*() col arguments const.
    - libdpkg: Use p instead of name in dpkg_arch_name_is_illegal().
    - dpkg: Remove redundant condition for sourcefile in updateavailable().
    - dpkg, update-alternatives: Make variables static.
    - libdpkg: Add missing symbols to the version map.
    - libdpkg: Fix fiemap memory layout usage that confuses gcc 10 to emit a
      warning.
    - libdpkg: Only use varbuf_printf() in pkg_format_show() when necessary.
      This should speed up «dpkg-query --show» formatting.
    - libdpkg: Fix package format string to be a string literal.
      This suppresses a gcc warning.
    - dpkg: Fix short lived memory leak in --force-help handling.
    - dpkg-split: Fix short lived file descriptor leak in --auto.
    - start-stop-daemon: Explicitly ignore unimportant function return values.
    - start-stop-daemon: Fix memory leak on multiple --chuid arguments.
    - start-stop-daemon: Close the notification socket in the child.
    - libdpkg: Fix memory leaks in zlib and bz2 decompression functions.
    - libdpkg: Add new dir_make_path() and dir_make_path_parent() functions.
    - libdpkg: Add new atomic file flag to create the base path when missing.
    - libdpkg: Fix modstatdb_rw enum comments.
    - libdpkg, dpkg-query: Optimize db-fsys:Files virtual variable loading.
      We load either the entire db-fsys for all packages, possibly optimized
      per platform (such as by using fiemap), or the specific ones for the
      requested packages. This also fixes a problematic cast removing the
      constness of a variable.
    - Dpkg::Dist::Files: Document the two filename pattern formats.
    - update-alternatives: Remove redundant condition in argument parser.
    - update-alternatives: Move error context setup before calling setjmp(),
      so that cppcheck stops being confused.
    - test: Reformat 200_Dpkg_Shlibs.cpp for coding style conformance.
    - dpkg: Make it possible for the compiler to check printf() format
      string arguments on dependency printer.
    - dselect: Reorder branches in packagelist::deselect_one_of so that they
      are not duplicated.
    - dselect: Use nullptr instead of NULL.
    - dselect: Use static_cast<> instead of old-style type qualifier cast.
    - dselect: Do not use unnecessary old-style casts.
    - dselect: Fix variable types to avoid needing old-style casts.
    - libcompat: Disarm libselinux setexecfilecon() declaration for
      libcompat-test.
    - libdpkg: Define new VARBUF_OBJECT macro.
    - libdpkg: Add new ATOMIC_FILE_NORMAL enum value to avoid a cast in C++.
    - libdpkg: Use a new DPKG_NULL macro that works in C and C++.
    - libdpkg: Use a new DPKG_STATIC_CAST macro that works in C and C++.
    - libdpkg: Move printing of errno into dpkg_error_set().
    - libdpkg: Use a varbuf to store the problem messages per parsedb context.
    - libdpkg: Fix Doxygen comments.
  * Build system:
    - Bump minimal Perl version to 5.24.1.
    - Add a serial versioning to the m4 files.
    - Install m4 files into system aclocal directory.
    - Bump minimal gettext version to 0.19.8, to get the m4 files that can
      cross-build for musl-based systems.
    - Enable more compiler warnings.
    - Update Doxygen configuration from version 1.8.16.
  * Packaging:
    - Remove obsolete Breaks satisfied since oldstable.
    - Replace custom rule for 'configure' with call to dh_autoreconf.
      Thanks to Dan Streetman <ddstreet@canonical.com>. Closes: #939516
    - dselect: Remove methods state files on purge.
      Spotted by Sven Joachim <svenjoac@gmx.de>.
    - Switch to debhelper compatibility level 12.
    - Switch from debian/compat to debhelper-commpat in Build-Depends.
    - Bump Standards-Version to 4.5.0 (no changes required).
  * Test suite:
    - Remove perlcritic Documentation::RequirePodLinksIncludeText suppression.
    - Clarify cppcheck va_list_usedBeforeStarted suppression.
    - Skip build directories from codespell check.
    - Update stopwords for codespell 1.16.0.
    - Suppress new bogus cppcheck 1.90 false positives.
    - libdpkg: Remove redundant assignment in t-ehandle unit test.
    - Skip backup files from codespell check.
    - Ignore python-3.8 runtime warnings in codespell.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Portuguese (Miguel Figueiredo). Closes: #935695
  * Simplified Chinese (Mo Zhou). Closes: #942195, #945776

  [ Updated dselect translations ]
  * German (Sven Joachim).

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann). Closes: #931135

 -- Guillem Jover <guillem@debian.org>  Sun, 08 Mar 2020 03:31:40 +0100

dpkg (1.19.7) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Fix off-by-one error in dpkg --abort-error. Closes: #924886
    Thanks to Tom Goulet <tomg@sentex.ca>.
  * dpkg: Set the force defaults before loading the config file, otherwise we
    incorrectly override them. Regression introduced in dpkg 1.19.5.
    Closes: #928671
  * dpkg: Split the trigger dependtry into two, the second of which will be
    the one checking trigger cycles when deferring trigger processing due to
    unsatisfiable dependencies. Closes: #928429
  * dpkg-deb: Validate ar member magic before normalizing any of its fields.
  * dpkg-deb: Honor --nocheck when building packages with newlines in
    filenames. Regression introduced in dpkg 1.18.1. Closes: #929727
  * Documentation:
    - rootless-builds.txt: Expand what the builder means. Mention the
      dpkg-deb option to use to set the owner and group to root. And reword
      the prototyping section to be less confusing with what is currently
      implemented. Closes: #929019
    - README: Clarify when autopoint is needed. Closes: #929601
    - Fix typos in docs and output strings. Warned by codespell.

  [ Updated programs translations ]
  * Catalan (Guillem Jover).

  [ Updated dselect translations ]
  * Catalan (Guillem Jover).

  [ Updated scripts translations ]
  * Catalan (Guillem Jover).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #926665
  * French (Jean-Pierre Giraud). Closes: #929664

 -- Guillem Jover <guillem@debian.org>  Mon, 03 Jun 2019 23:22:35 +0200

dpkg (1.19.6) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Add a new TAR_FORMAT_UNKNOWN enum value.
  * libdpkg: Set tar_entry to zero on tar_entry_destroy(), to avoid double
    free()s and the subsequent crashes.
  * libdpkg: Handle non end-of-tape errors from tar_header_decode().
  * libdpkg: Use ERANGE instead of EINVAL for tar_atol8() out-of-range error.
  * dpkg-gencontrol: Check presence of package build dir before traversing it.
  * Perl modules:
    - Dpkg::Source::Package::V1: Change default build option style to -sa.
      Using -sA by default means the user might lose data on overwrite if
      there is already a directory with the same name laying around.
      Closes: #910737
    - Dpkg::Source::Package: Handle Format field being undefined. On source
      format 1.0, the default is for the debian/source/format file not being
      present, which means we'll start with an empty Format field name.
      Regression introduced in dpkg 1.19.3.
  * Packaging:
    - Update usertags.
    - Install a lintian profile for dpkg based on the debian profile, so that
      we can suppress Debian-specific tags, such as the controversial one on
      vendor-specific patch series files.
    - Add Breaks on lsb-base due to start-stop-daemon exposing breakage in
      the killproc function from /lib/lsb/init-functions. Closes: #923861
  * Test suite:
    - Stop requiring (pseudo-)root in the functional test suite.
    - Export and move TESTDATA definition close to the PATH definition.
    - Quote the 'yes' command to make a comment clearer.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #924776

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #924777
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 25 Mar 2019 15:08:26 +0100

dpkg (1.19.5) unstable; urgency=medium

  [ Guillem Jover ]
  * start-stop-daemon: Make sure that we get a meaningful errno on
    parse_unsigned(), so that the error messages always make sense.
  * start-stop-daemon: Add new fatalv() and fatale() functions and use the
    latter for system errors, so that we are explicit on whether we want to
    use errno for error reporting or not.
  * start-stop-daemon: Always refuse to parse a world-writable pidfile,
    except when that is /dev/null.
  * dpkg: Print the current set of enabled force options on --force-help.
  * dpkg: Parse and set new DPKG_FORCE environment variable for subprocesses.
    Closes: #666147
  * dpkg-statoverride: Add support for --force-* options.
  * dpkg-statoverride: Switch from --force option to new --force-<thing>
    options. Deprecate --force option which will be considered an alias for
    --force-all for now.
  * dpkg, dpkg-statoverride: Add new option --refuse-security-mac to control
    SELinux. See #811037.
  * dpkg: Clarify error on unknown system user/group in statoverride database.
    Closes: #920880
  * dpkg-buildpackage: Clarify the warning/error on short OpenPGP key IDs.
    Closes: #922039
  * dpkg-maintscript-helper: Restrict find for dir-to-symlink move to
    -maxdepth 1. Thanks to Ralf Treinen <treinen@free.fr>. Closes: #922799
  * dpkg-genbuildinfo: Add support for a new Build-Tainted-By field in
    .buildinfo files. Suggested by Alexander E. Patrakov <patrakov@gmail.com>.
  * libdpkg: Clarify field names in error and warning messages.
  * libdpkg: Optimize error handling. Move the error reporting outside the
    involved functions so that we do not need to call gettext if there is no
    error, which has a significant performance cost.
  * libdpkg: Merge nicknames table into fieldinfos, to stop penalizing the
    lookup of non-obsolete fieldnames.
  * libdpkg: Print a more accurate warning for Revision nicknames.
  * libdpkg: Increase the pkg-hash bins size to 65521, to improve hash table
    performance at the cost of a bit more memory usage.
  * libdpkg: Blank packages that are not-installed with unknown selection.
    Closes: #922410
  * libdpkg, dpkg: Print the dpkg database directory on access errors.
    Closes: #883700
  * Perl modules:
    - Dpkg::Vendor::Debian: Add support for merged-usr-via-symlinks tainted
      tag. Suggested by Alexander E. Patrakov <patrakov@gmail.com>.
    - Dpkg::Vendor::Debian: Add support for usr-local-has-* tainted tags.
    - Dpkg::Source::Package: Add a missing use Dpkg::Source::Format.
      Diagnosed by Ian Jackson <ijackson@chiark.greenend.org.uk>.
      Closes: #921031
  * Documentation:
    - start-stop-daemon(1): Document behavior of --pidfile security checks.
      Closes: #921557
    - dpkg(1): Document the unknown selection state. Closes: #922407
  * Code internals:
    - dpkg: Move SELinux fallback label to the SELinux specific code path.
    - dpkg: Simplify maintscript_set_exec_context().
    - dpkg: Move force options support into its own file.
    - dpkg: Do not hardcode the program name in the --force-help output.
    - dpkg: Switch force options from individual variables to bit fields.
    - dpkg: Switch from a char to an enum to track the force options types.
    - dpkg: Switch to set the default force option from the forceinfos array.
    - libdpkg: New benchmark programs and infrastructure.
    - libdpkg: Add new dpkg_error_move() function.
    - libdpkg: Add new dpkg_has_error() function.
    - libdpkg: Move status names from parse errors to arguments.
    - libdpkg: Use va_arg copy instead of the original on a vasprintf() call.
    - libdpkg: Include <string.h> in pager.c.
      Reported by Y <sevener@cock.li>. Closes: #922212
    - libdpkg: Use pkg_set_want() instead of a direct assignment.
  * Build system:
    - Check whether this dist is a release, based only on the version format.
      This will avoid having to do a two staged release to get a proper perl
      distribution tarball.
  * Packaging:
    - autopkgtest: Add file to Depends fields.
    - autopkgtest: Clarify behavior on root/non-root requirement.
    - Bump Standards-Version to 4.3.0 (no changes required).
    - Remove now unused assert usertag description.
    - Remove trailing whitespace from changelog.
    - Remove Origin and Bugs fields from control file.
    - Include a bug-script to report on tainted merged-usr-via-symlinks.
  * Test suite:
    - libdpkg: Fix unit test for file_slurp(). Closes: #920974
      Diagnosed by Frank Schaefer <kelledin@gmail.com>.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #921942
  * German (Sven Joachim).
  * Simplified Chinese (Zhou Mo). Closes: #920972

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #921943
  * French (Jean-Pierre Giraud). Closes: #920905
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sat, 23 Feb 2019 18:00:54 +0100

dpkg (1.19.4) unstable; urgency=medium

  * start-stop-daemon: Do not sanity check the pidfile when it is specified as
    /dev/null, as that implies the caller wants to start the program no matter
    what. Closes: #920242
  * Portability:
    - start-stop-daemon: Only use SO_PASSCRED if defined. Fixes build failure
      at least on GNU/Hurd.
  * Packaging:
    - autopkgtest: Pass --disable-nls and --disable-dselect to configure.
    - autopkgtest: Change Depends to «build-essential, autoconf, pkg-config».

 -- Guillem Jover <guillem@debian.org>  Wed, 23 Jan 2019 13:06:39 +0100

dpkg (1.19.3) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-source: Stop filtering @builddeps@ from Testsuite-Triggers field.
    Closes: #910734
  * dpkg-genchanges: Only reference binary packages being uploaded, which
    means that for a source-only upload, the Binary and Description fields
    should be empty. Closes: #818618
  * dpkg-scanpackages: Do not compute unnecessary checksums when using the
    --hash argument. Based on a patch by Chris Lamb <lamby@debian.org>.
    Closes: #916456
  * dpkg-scanpackages: Emit a warning with the list of repeat packages.
    Prompted by Johannes Schauer <josch@debian.org>.
  * start-stop-daemon: Check whether standalone --pidfile use is secure.
    Prompted by Michael Orlitzky <michael@orlitzky.com>.
  * start-stop-daemon: Print complete verbose lines, instead of partial lines
    with no newlines and a final print with a newline.
  * start-stop-daemon: Add new --notify-await and --notify-timeout options,
    which implement the systemd readiness protocol for services.
    Closes: #910707
  * update-alternatives: Add new --debug option.
  * update-alternatives: Fix removal of obsolete slaves from the linked list.
    Reported by Andreas Beckmann <anbe@debian.org>. Closes: #916799
  * vendor.mk: Fix dpkg_vendor_derives_from macro documentation.
    Thanks to Colin Watson <cjwatson@debian.org>. Closes: #913816
  * vendor.mk: Add support for an improved dpkg_vendor_derives_from macro.
    Version the macros so that both can be used, and default the unversioned
    one to the version 0 macro.
  * dpkg: Mark the package we are giving up on a trigger cycle as "istobe"
    normal, so that the dependency checks know they cannot expect this package
    to be processed anymore. Otherwise we ended up never detecting that we
    were not making progress, as we expected to process this package at a later
    point, when that would never happen anymore. This then was causing asserts
    in the process queue loop. Closes: #901127, #910819
  * dpkg: Reset progress_bytrigproc once we have injected it into the current
    package process queue iteration, so that we do not keep trying to process
    it, which might end up generating artificial trigger cycles, if
    dependencies are not satisfied yet.
  * dpkg: Convert one trigger processing required type into the new try-queued
    one, so that we stop skipping unsatisfiable dependency checks.
  * dpkg: Move trigproc cycle reset inside try-deferred conditional. We should
    only reset the cycle detection in case we are not bailing out from the
    processing with an error, otherwise we could come back to this package and
    detect an artificial trigger cycle.
  * dpkg: Introduce a new dependency try level for trigger processing. This
    completely defers trigger processing until after the dependency cycle
    breaking level, so to avoid generating artificial trigger cycles, when we
    end up trying to process triggers with yet unsatisifiable dependencies.
    Closes: #810724, #854478, #911620
  * dpkg: Fix --help output, to clarify which arguments are optional.
  * libdpkg: Add proper tar error handling. This makes the tar extractor
    track and report back parse errors, so that we can give more descriptive
    messages.
  * libdpkg: Detect unsupported tar entry types to give better error messages.
  * libdpkg: Add new db-fsys:Files and db-fsys:Last-Modified virtual fields.
  * Perl modules:
    - Dpkg::Changelog::Debian: Preserve modelines at EOF. Closes: #916056
      Thanks to Chris Lamb <lamby@debian.org> for initial test cases.
    - Dpkg::File: Make file_slurp() also accept pathnames in addition to
      filehandles.
    - Dpkg::Vendor::Ubuntu: Fix buildflags override after default setting move.
      Based on a patch by Iain Lane <laney@ubuntu.com> and
      Adam Conrad <adconrad@ubuntu.com>. Closes: #915881
    - Dpkg::Shlibs::Objdump: Remove unused Dpkg::IPC import.
    - Dpkg::Shlibs::Objdump: Only select objdump program when going to use it.
    - Dpkg::Source::Package: Do not reinitialize fields member in constructor.
    - Dpkg::Source::Patch: Do not recommend --include-removal when not
      supported. Closes: #913012
    - Dpkg::Source::Package::V3::Bzr: Fix format name in output message.
    - Dpkg::Source::Package: Add a new format option to the new constructor.
      Prompted by James McCoy <jamesan@debian.org>.
    - Dpkg::Source::Package: Improve debian/source/format parsing and
      validation.
    - Dpkg::Source::Format: New public module.
      Prompted by Mattia Rizzolo <mattia@debian.org>.
  * Documentation:
    - dpkg(1): Clarify --remove action. Closes: #914478
    - dpkg-query(1): Clarify --list option behavior when no arguments are
      specified. Closes: #917098
    - deb-control(5): Clarify by adding a reference to deb-src-control(5) and
      removing an invalid comment in the example.
      Prompted by Helmut Grohne <helmut@subdivi.de>.
    - dpkg(1): Clarify databases used by --yet-to-unpack and --predep-package.
      Prompted by Johannes Schauer <josch@debian.org>.
    - Clarify character classes for various formats in man pages, by
      explicitly listing the character ranges within parenthesis.
      Prompted by Ian Jackson <ijackson@chiark.greenend.org.uk>.
    - dpkg-query(1): Document the version introducing the -f option.
    - dpkg-architecture(1): Add reference to the TERMS section in the
      VARIABLES section. Prompted by Axel Beckert <abe@debian.org>.
    - Fix POD for Dpkg::Interface::Storable derived method implementations.
    - Dpkg::Deps::Simple(3): Fix POD signature for new constructor.
  * Code internals:
    - dpkg-maintscript-helper: Use an explicit escape instead of a literal
      backslash.
    - Quote shell variables. Reported by Johannes Schauer <josch@debian.org>.
    - Switch perl code to use the new Dpkg::Source::Format module.
    - dpkg-source: Move source format selection earlier in the build.
    - dpkg-source: Use new format argument for Dpkg::Source::Package->new().
    - dpkg-shlibdeps: Remove unused variable.
    - dpkg-scanpackages: Unroll a single iteration loop.
    - start-stop-daemon: Compare foundany against 0 instead of treating it
      like a boolean.
    - start-stop-daemon: Switch code to use new info() and debug() functions.
    - update-alternatives: Use enums for actions instead of strings.
    - update-alternatives: Switch verbose selection into an enum.
    - dpkg: Negate tortoise_not_in_hare() function name and return value.
    - dpkg: Initialize trigcyclenode's next member once.
    - dpkg: Use common pattern of assigning as an iterator.
    - dpkg: Factor trigproc_new_cyclenode() out from check_trigger_cycle().
    - dpkg: Switch dependtry from an int to an enum.
    - dpkg: Move dependtry description from deferred_configure() to its
      declaration.
    - dpkg: Split trigger processing types into required, try-queued and
      try-deferred.
    - dpkg-query: Rename variable to avoid shadowing a local function.
    - When allocating use the variable instead of the type in sizeof().
    - dselect: Rename variable r to pkgbin.
    - libdpkg, dpkg: Rename r variables to fnn.
    - libdpkg: Rename ret variable to next.
    - libdpkg: Cleanup fsys module symbol names.
    - libdpkg: Rename pkg_db symbols to pkg_hash.
    - libdpkg: Add new warning printer setter function.
      Prompted by Julian Andres Klode <jak@debian.org>.
    - libdpkg: Add new DPKG_ERROR_OBJECT macro.
  * Build system:
    - get-version: Use a format string with printf.
    - run-script: Use $() instead of deprecated ``.
    - run-script: Remove unused PERL_PROFILE variable, PERL5OPT can be used
      instead, and does not require leaving an unquoted variable around.
    - run-script: Add «set -e».
    - Build.PL: Set environment variables only for CPAN tests.
    - Build.PL: Set locale for CPAN tests to C. Fixes CPAN#127314.
    - configure: Split AM_INIT_AUTOMAKE arguments into different lines.
  * Packaging:
    - Bump Standards-Version to 4.2.1 (no changes needed).
    - Switch to debhelper compatibility level 11.
    - Create the log file in postinst only if it does not exist.
      Prompted by Johannes Schauer <josch@debian.org>.
    - Add superficial autopkgtest functional tests.
  * Test suite:
    - Add new shellcheck author test.
    - Add descriptions for the shellcheck exclude codes.
    - Update cppcheck suppressions.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #912023
  * German (Sven Joachim).
  * Italian (Milo Casagrande). Closes: #915610
  * Portuguese (Miguel Figueiredo). Closes: #917813
  * Simplified Chinese (Zhou Mo). Closes: #919040

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #912024
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Tue, 22 Jan 2019 14:26:04 +0100

dpkg (1.19.2) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Fix --force-not-root for chown() and chmod() based syscalls, and
    give a more meaningful error message on chroot(). Closes: #614126
  * dpkg-divert, dpkg-statoverride: Add new --instdir and --root options,
    and make the commands honor the DPKG_ROOT environment variable.
    Closes: #487108
  * libdpkg: Call the pager with «$SHELL -c» to respect POSIX. Closes: #910009
  * libdpkg: Do not spawn a pager if we are going to call «cat».
  * libdpkg: Honor DPKG_PAGER when spawning a pager.
    Suggested by Craig Sanders <cas@taz.net.au>.
  * libdpkg: Set LESS to “-FRSXMQ” if not already set, when spawning a pager.
  * libdpkg: Ignore SIGPIPE when setting up a pager, and then ignore EPIPE
    errors when writing to stdout, otherwise if we quit the pager early, the
    program will exit with an error code.
  * libdpkg: Set stdout to be fully buffered when using a pager.
  * dpkg, dpkg-query: Add new --no-pager option. For dpkg this is also a
    configuration option. Closes: #909754
  * Perl modules:
    - Dpkg::OpenPGP: Ignore Version field in enarmored output.
      Fixes CPAN#127217.
    - Dpkg::OpenPGP: Do not read the gpg user configuration file.
    - Dpkg::Source::Functions: Reimplement is_binary() w/o using diff(1).
    - Dpkg::Source::Package::V2: Split the BinaryFiles module into its own
      file, and give it a more generic name (Dpkg::Source::BinaryFiles).
    - Dpkg::Source::Package::V2: Move binary file detection to BinaryFiles
      module.
  * Documentation:
    - dpkg-buildpackage(1): Clarify --build=source explanation.
    - dsc(5): Clarify what “flattened” means in Testsuite-Triggers.
      Prompted by Mattia Rizzolo <mattia@debian.org>.
    - dsc(5): Add a reference to where the source formats are described.
      Prompted by Manuel A. Fernandez Montecelo <mafm@debian.org>.
    - dpkg-source(1): Improve documentation on vendor-specific series files.
    - deb-control(5): Document Build-Ids field.
      Prompted by Stuart Prescott <stuart@debian.org>.
    - dpkg(1): Clarify which fields are affected by dependency options.
      Prompted by James Clarke <jrtc27@debian.org>.
    - dpkg-query(1): Document the PAGER environment variable usage.
    - Dpkg(1): Add POD documentation about the module hierarchy and API.
  * Code internals:
    - dpkg-split: Use nfstrnsave() instead of nfmalloc() + memcpy().
    - libdpkg: Add new fsys-dir module.
    - libdpkg: Pass the file contents to the pager instead of the filename.
    - libdpkg: Add a pager kill switch, so that it can be forcefully disabled.
  * Build system:
    - Distribute a LICENSE file on CPAN.
    - Do not make the Build.PL script executable.
    - Generalize PACKAGE_CPAN_SIGN by setting PACKAGE_DIST_IS_RELEASE instead.
    - Add a release_status key to the CPAN metadata.
    - Fix typo in CPAN recommends key.
    - Improve test and author CPAN dependencies.
  * Packaging:
    - Break libapt-pkg5.0 instead of apt. Closes: #909959
      Analysis by Sven Joachim <svenjoac@gmx.de>.
  * Test suite:
    - Skip version checks involving «dpkg --compare-versions» if not available.
      This is relevant on CPAN or on non-dpkg-based systems.

  [ Updated programs translations ]
  * Polish (Łukasz Dulny).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 08 Oct 2018 11:43:48 +0200

dpkg (1.19.1) unstable; urgency=medium

  [ Guillem Jover ]
  * Fix logic in dpkg-buildpackage to decide whether to run build targets,
    which broke tons of packages that are violating Debian policy MUSTs.
    Thanks to James Clarke <jrtc27@debian.org>. Closes: #878899
  * Do not try to recompute hashes for the .dsc file when signing binary-only
    builds in dpkg-buildpackage. Reported by Ximin Luo <infinity0@debian.org>.
  * Pass the correct source stanza to the dpkg-buildpackage code parsing the
    Rules-Requires-Root field. This meant the field was being ignored.
  * Run dpkg-source directly from the current working directory in
    dpkg-buildpackage, instead of changing directory back and forth.
  * Setup and check rootcommand in dpkg-buildpackage only if it is going to
    be needed. Reported by Niels Thykier <niels@thykier.net>.
  * Add color support to dpkg-maintscript-helper (a shell script).
  * Fix warning by including <sys/sysmacros.h> for makedev() in libdpkg.
  * Fix directory traversal with dpkg-deb --raw-extract, by guaranteeing
    that the DEBIAN pathname does not exist. Closes: #879982
    Reported by Jakub Wilk <jwilk@jwilk.net>.
  * Add new AS, STRIP, OBJCOPY, OBJDUMP, NM, AR and RANLIB buildtools
    variables to buildtools.mk. Prompted by Helmut Grohne <helmut@subdivi.de>.
  * Restore rejecting negated architectures in Architecture field in
    dpkg-gencontrol and dpkg-genchanges. Regression introduced in dpkg 1.18.5.
  * Fix dpkg-gensymbols to print "error" instead of "warning" when these
    are fatal. Closes: #881488
  * Rename DPKG_GAIN_ROOT_CMD to DEB_GAIN_ROOT_CMD in the R³ support, as
    the variable is expected to be set by any builder, not just dpkg. And
    introduce ephemeral backwards compatibility even though there are no
    known users.
  * Do not set DEB_GAIN_ROOT_CMD in dpkg-buildpackage when the R³ value is
    <implementations-keywords>, following the specification.
  * Specify that DEB_GAIN_ROOT_CMD in R³ should preserve the environment.
    Proposed by Josh Triplett <josh@joshtriplett.org>.
  * Specify new DEB_RULES_REQUIRES_ROOT variable for R³ support.
  * Add new --rules-requires-root option to dpkg-buildpackage.
  * Declare R³ specification as "recommendation, stable" with version 1.0.
  * Export architecture variables by default from architecture.mk, as
    documented in dpkg-architecture(1). Closes: #888964
    Thanks to Jack Bates <wdz7eo@nottheoilrig.com>
  * Increment the line number on dpkg --set-selections on unknown packages.
    Reported by Heinz Repp <heinz.repp@arcor.de>. Closes: #888983
  * Switch a DEBIAN/conffile parsing assert() in dpkg due to empty lines
    into an ohshit(), because this is really a run-time error.
  * Fix assert() in dselect to expect the method lock file descriptor to be
    initialized, instead of non-zero.
  * Switch a fatal() call in start-stop-daemon into the new BUG() macro,
    because it is really an internal error.
  * Switch all assert() calls (except in update-alternatives) into internerr()
    or BUG() calls, to get way better reporting with variable contents and
    descriptions, and to make them always present independent of NDEBUG.
  * Add a new --no-rename option to dpkg-divert. This is the current default
    behavior, but it will make it possible to do a default switch in 1.20.x.
  * Warn when using dpkg-divert --add or --remove w/o --rename or --no-rename.
  * Warn when using dpkg-divert --rename on a file from an Essential package.
  * Use a single “struct filenamenode” definition for the entire code base.
    Closes: #746766
  * Add support for frontend locking. This makes it possible for frontends
    using this new protocol, to safely lock the dpkg database w/o risk of
    race conditions with other dpkg instances or frontends supporting the
    same protocol. Thanks to Julian Andres Klode <jak@debian.org>.
    Closes: #850417, #851984
  * Do not emit perl warnings in dpkg-source --help on source formats w/o
    options.
  * Make dpkg-buildpackage validate OpenPGP signing key IDs length. Error out
    for short key IDs and warn for long key IDs.
  * On the dpkg conffile prompt, print the set of environment variables setup
    for the conffile shell, for easier discoverability.
  * Fix dpkg-buildpackage option --rules-file parsing. It was trying to parse
    it as --rules-target, which due to the ordering was a no-op.
  * Only check for fallback build targets presence on binary builds in
    dpkg-buildpackage.
  * Only check required build dependencies for known targets specified with
    dpkg-buildpackage --rules-target option.
    Reported by Johannes Schauer <josch@debian.org>.
  * Track package status dirtiness in dpkg to only log and report in status-fd
    when it has changed, removing duplication in output. Closes: #365921
  * Use Synopsis instead of Summary for the short Description, to unify the
    nomenclature and to make it more descriptive. Add a new binary:Synopsis
    virtual field to dpkg-query show format.
  * Add new dpkg-buildpackage --no-post-clean option, to be able to explicitly
    select the current default behavior.
  * Dump database package records in alphabetical order. This will give
    reproducible status and available database files, and make it possible
    to output other deb822 formatted data in a deterministic way.
  * Require both standard input and output to be connected to a terminal to
    use a pager.
  * Run dpkg-query --list output through a pager if we are on a terminal,
    instead of truncating it, to avoid data loss. Closes: #898603
  * Fix use after free in dpkg maintainer script handling. Regression
    introduced in dpkg 1.19.0.
  * Flush output for dpkg-query --status, --print-avail and --listfiles at
    the end, instead of after each stanza.
  * Add support for dumping all dpkg-query --status and --print-avail records
    from the database when no arguments are specified. Closes: #616342
  * Add new dpkg-gensymbols -l option to avoid having to abuse LD_LIBRARY_PATH
    for cross-build paths.
  * Check that DPKG_MAINTSCRIPT_PACKAGE is defined in dpkg-maintscript-helper.
    Closes: #907772
  * Switch dpkg-gencontrol and dpkg-genchanges to track automatically
    generated artifacts by using the Auto-Built-Package field from the binary
    package instead of hardcoding package name patterns (such as «-dbgsym$»).
  * Add new --reverse option to dpkg-parsechangelog, to list the changelog
    entries in reverse order.
  * Architecture support:
    - Add support for riscv64 CPU. Closes: #822914
      Thanks to Manuel A. Fernandez Montecelo <mafm@debian.org>
    - Document the purpose and columns in the tupletable file.
  * Portability:
    - Add libcompat md5 module to the libcompat-test library, so that we
      always make sure it builds, even when we use an external implementation.
    - Convert libcompat md5 module to use C99 int types, instead of mapping
      them from the BSD types at configure time.
    - Use MD5_CTX instead of struct MD5Context, as the prevalent more portable
      type on system's <md5.h> headers.
    - Check for ldconfig command in dpkg only on platforms that do have it.
    - Fix file descriptor leak in start-stop-daemon on AIX.
    - libcompat: Add new strchrnul() implementation.
  * Perl modules:
    - Dpkg::Source::Package::V1: Check that $tarname is defined before use.
      Thanks to Christoph Biedl <debian.axhn@manchmal.in-ulm.de>.
      Closes: #879124
    - Dpkg::Vendor::Debian: Use proper %use_feature key. This was causing perl
      errors on paths not accepted for fixdebugpath.
      Reported by Mattia Rizzolo <mattia@debian.org>, on IRC. Closes: #881051
    - Dpkg::Changelog: Print versions for incorrect changelog range warnings.
      Thanks to Paul Wise <pabs@debian.org>.
    - Dpkg::Shlibs::SymbolFile: Check that $state->{seen} exists instead of
      $state being just defined. Fixes regression in dpkg-gensymbols symbols
      output. Thanks to Dmitry Shachnev <mitya57@debian.org>. Closes: #880166
    - Dpkg::Arch: Add new positive options argument to arch validators.
    - Dpkg::Vendor::Debian: Mark hurd-i386 as having gcc builtin PIE.
      Requested by Samuel Thibault <sthibault@debian.org>.
    - Dpkg::Source::Package::V2: Print one building line per existing tarball.
    - Dpkg::Source::Package: Print building lines for upstream tarball
      signatures. Closes: #888787
    - Dpkg::Deps: Turn virtualpkg tracking from an arrayref into a hashref.
    - Dpkg::Vendor::Debian: Mark riscv64 as having gcc builtin PIE.
    - Dpkg::Shlibs::Objdump: Fix ELF program detection, for PIE binaries and
      executable libraries.
    - Dpkg::Version: Fix bool overload behavior back to be an is_valid()
      alias. Emit a specific perl warning until 1.20.x so that users can check
      whether the semantic change has any impact on the code, which can then
      be quiesced. Closes: #895004
    - Dpkg::Changelog::Parse: When detecting the changelog format, read the
      last 4KiB of the file instead of using «tail -n40», which should be
      both faster and more portable, as the default tail(1) is not POSIX
      compliant on all systems (c.f. Solaris).
    - Dpkg::Build::Types: Add new set_build_type_from_targets() function.
    - Dpkg::Shlibs::SymbolFile: Always assign a proper Dpkg::Version to the
      deprecated variable, otherwise the scalar value 0 can get confused
      on scalar context to denote it is *not* deprecated instead of being
      version 0.
    - Dpkg::Shlibs: Disable bool overload Dpkg::Version warnings.
    - Dpkg::Vendor::Debian: Inline _parse_feature_area() into
      _add_build_flags(), for a small speed up and line count reduction.
    - Dpkg::BuildFlags: Move default flags setting into the Dpkg::Vendor
      modules.
    - Dpkg::Gettext: Fix fallback textdomain() to honor its expected interface.
    - Dpkg::Deps: Split subpackages into their own separate modules.
    - Dpkg::Source: Do not change patch permissions if not necessary.
      Closes: #898010
    - Dpkg::Substvars: Reword used/unused warnings to clarify their meaning.
      Closes: #904258
    - Dpkg::Shlibs: Warn when using LD_LIBRARY_PATH with a private library
      directory which is a descendent of the current working directory.
    - Dpkg::Source::Package::V3::Quilt: Print series file used when applying
      patches.
    - Dpkg::OpenPGP: Return the destination path on successful ASCII armor
      conversion.
    - Dpkg::Control::Fields: Do not use & sigil for function calls.
    - Dpkg::Shlibs: Ignore nonexistent directories present in LD_LIBRARY_PATH.
    - Dpkg::Deps::KnownFacts: Satisfy :native with arch:all packages too.
      These are treated as native packages everywhere else in the multi-arch
      design, this was the only exception, which has become a source of
      packaging problems as of late. This was apparently an oversight in
      the original implementation. Closes: #854438
    - Dpkg::Vendor::Debian: Add fixfilepath support to reproducible feature.
    - Dpkg::Dist::Files: Add support for file attributes.
  * Documentation:
    - Update gettext minimal version in README.
    - Add a missing dot on the dpkg-buildflags(1) «lfs» feature paragraph.
      Spotted by Helge Kreutzmann <debian@helgefjell.de>.
    - Document DPKG_COLORS environment variable for all programs using it.
    - Document DPKG_NLS environment variable for all programs using it.
    - Document the Testsuite and Testsuite-Triggers fields in
      deb-src-control(5). Prompted by Mattia Rizzolo <mattia@debian.org>.
    - Update git URLs for move away from alioth.debian.org.
    - Fix set_build_type_from_options() description in Dpkg::Build::Types.
    - Clarify PIE build flag feature semantics. Closes: #900088
    - Clarify dpkg-buildpackage pre and post-clean options and their default
      state.
    - Add --build option equivalents for dpkg-buildpackage short build type
      options in --help output.
    - Fold dpkg-buildpackage --[no-]check-builddeps in --help into both -D
      and -d option descriptions.
    - Mark profiles as a replaceable item in dpkg-buildpackage --help output.
    - Update test suite requirements in README.
    - Document textdomain() and ngettext() replacement functions in
      Dpkg::Gettext POD.
    - Clarify arch-qualified dependency simplification in Dpkg::Deps POD.
    - Improve Dpkg::Deps modules and methods documentation.
    - Fix typo in deb-changes(5). Closes: #902616
    - Clarify awaiting state for interest and activate directives.
      Closes: #904060
    - Fix man page markup. Closes: #900033, #900035, #900040
      Thanks to Bjarni Ingi Gislason <bjarniig@rhi.hi.is>.
    - Fix Doxygen comment for libdpkg dpkg_arch_find() function.
    - Document the dangers of using start-stop-daemon(8) only with --pidfile
      as matching option with the pid file owned by a non-privileged user.
  * Code internals:
    - Do not use stringy eval to define different sub implementations,
      just assign an anonymous sub to the typeglob.
    - Use memccpy() instead of strncpy() to quiesce a gcc-8 warning.
    - Change pkgbin_name_needs_arch() to never arch-qualify packages that
      have an empty or no architecture, which was already handled as part
      of varbuf_add_archqual().
    - libdpkg: Factor out cached arch-qualified package name generation into
      new pkgbin_name_archqual() function.
    - libdpkg: Add new pkg_name() and pkgbin_name() const variants.
    - libdpkg, dselect: Use new pkg_name_const() and pkgbin_name_const().
    - libdpkg: Rename struct pkginfo files member to archives.
    - dpkg: Call ensure_package_clientdata() defensively.
    - dpkg: For read-only state functions, check that clientdata is allocated
      before using it.
    - libdpkg: Move files list information from dpkg clientdata to pkginfo.
    - dpkg: Move ensure_package_clientdata() into its own file.
    - libdpkg: Move db-fsys code from src to lib/dpkg.
    - libdpkg: Rename pkg-db module to pkg-hash.
    - libdpkg: Simplify pkg_files_blank() by using a pointer to pointer to
      track the previous entry.
    - libdpkg: Factor out package files handling into its own module.
    - libdpkg: Switch to a new tiny struct to track file on-disk identity.
      This should reduce the run-time memory used.
    - libdpkg: Reset nfiles in files_db_reset().
    - libdpkg: Split push_cleanup() into push_cleanup_fallback().
    - Switch from strchr() + strlen() to strchrnul().
    - libdpkg: Change dpkg_error to track errno values.
    - libdpkg: Add new varbuf_new() and varbuf_free() functions.
    - libdpkg: Add new file_slurp() function.
    - libdpkg: Switch db-fsys to use the new file_slurp() function.
    - libdpkg: Add new pkg_infodb_reset_dir().
    - libdpkg: Add new m_dup() function.
    - libdpkg: Factor out package stanza printing into its own function.
    - libdpkg: Split pager specific code into its own module.
    - libdpkg: Add pager spawning and reaping support.
    - Use new pager spawning support instead of open-coding it, or piping it
      via a shell invocation, which required metacharacter escaping.
    - dpkg-query: Split enqperpackage() into each different action.
  * Build system:
    - Set distribution tarball format to ustar, instead of default v7 format.
    - Mark PO4A and POD2MAN as precious variables.
    - Automatically replace -Wno- with -W when testing compiler flags,
      instead of passing the positive form manually.
    - Enable clang -Wdocumentation warning if available.
    - Enable gcc-7 -Wregister warning if available.
    - Add CPAN distribution machinery for the perl modules. Closes: #821177
    - Add an autogen script to help people bootstrap the project.
    - Distribute the man.stamp from VPATH.
    - Preserve timestamps when distributing man pages.
    - Add a GitLab CI configuration file.
    - Disable C optimization levels when configuring for code coverage.
  * Packaging:
    - Install update-alternatives policykit-1 file.
    - Add Breaks to libdpkg-perl against pkg-kde-tools (<< 0.15.28~), as
      that package is using private modules with no API guarantees, that
      obviously broke due to recent changes in 1.19.0. Closes: #878919
    - Add Breaks on debhelper << 10.10.1~ to dpkg-dev, so that debhelper users
      wanting to use R³ support do not need a versioned dependency on dpkg-dev.
    - Add Breaks dgit << 3.13~ to libdpkg-perl, as older dgit versions assumed
      that Dpkg::Compression::Process was available, via implicit import
      from Dpkg::Source::Package.
      Reported by Ian Jackson <ijackson@chiark.greenend.org.uk>.
    - Bump Standards-Version to 4.1.1 (no changes needed).
    - Add bzip2 and xz-utils to Build-Depends, required by the functional test
      suite, but shadowed by dpkg-dev from the build system pulling those in.
    - Add versioned libncurses-dev as the first Build-Depends alternative.
      Thanks to Sven Joachim <svenjoac@gmx.de>.
    - Do not pass VERBOSE to test suite, as we are not using any automake
      test driver, so it does not get honored.
    - Rename maintainer-build DEB_BUILD_OPTIONS to new standardized terse.
    - Enable verbose test suite only in non-terse builds.
    - Add a Suggests on sensible-utils to libdpkg-perl.
    - Switch libdpkg-perl again to depend on perl:any, now that debootstrap
      in stable (stretch) supports arch-qualified dependencies.
    - Update libdpkg-perl public module list in package description.
    - Add Breaks on apt (<< 1.7~b) for --status-fd duplicate removals.
  * Test suite:
    - Skip Dpkg::OpenPGP test if gpg is not present.
    - Check POD in all perl scripts.
    - Consider *.PL also to be perl files.
    - Infer automatically the unit test data directory.
    - Infer automatically the unit test temp directory.
    - Add new po author test case (use i18nspector if available).
    - Add new test cases to clarify arch-qualified dependency simplification.
    - Add several TODO tests cases for dependency simplification.
    - Add new cppcheck author test.
    - Add support for new test_get_srcdir() test_get_builddir().
    - Add new unit tests for namevalue, fsys-hash and pkg-hash libdpkg modules.
    - Improve coverage of perl unit tests.
    - Delete fixup lines from i18nspector output instead of emptying them.
    - Add new codespell author test.
    - Add new test that the public libdpkg headers can be compiled with C++.

  [ Josh Triplett ]
  * Perl: Replace all calls to Cwd::cwd with Cwd::getcwd; the former calls
    /bin/pwd, while the latter uses the getcwd() syscall directly.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #881401
  * German (Sven Joachim).
  * Italian (Milo Casagrande). Closes: #883085
  * Polish (Łukasz Dulny).
  * Simplified Chinese (Zhou Mo, Boyuan Yang). Closes: #900547, #890806
  * Spanish (Javier Fernández-Sanguino).
  * Traditional Chinese (Buo-ren Lin). Closes: #905887
  * Turkish (Mert Dirik). Closes: #886252

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #881403
  * German (Helge Kreutzmann).
  * Simplified Chinese (Zhou Mo).

 -- Guillem Jover <guillem@debian.org>  Wed, 26 Sep 2018 15:13:22 +0200

dpkg (1.19.0) unstable; urgency=medium

  [ Guillem Jover ]
  * Remove an unused variable in dpkg-shlibdeps.
    Thanks to Niels Thykier <niels@thykier.net>.
  * Parse start-stop-daemon usernames and groupnames starting with digits in
    -u and -c correctly. Reported by Bodo Eggert <7eggert@online.de>.
  * Cache the result of «dpkg-query --control-path» calls in dpkg-shlibdeps.
    Based on a patch by Niels Thykier <niels@thykier.net>. Closes: #846405
  * Always use the binary version for the .buildinfo filename in
    dpkg-genbuildinfo. Reported by Raphaël Hertzog <hertzog@debian.org>.
    Closes: #869236
  * Fix integer overflow in deb(5) format version parser.
    Closes: #868356
  * Re-enable upstream tar signatures when building source format 1.0.
  * Make dpkg-deb --build sanity check the config maintainer script file type
    and permissions.
  * Add support to dpkg-deb for rootless builds, by setting the owner and
    group for the control.tar entries to root:root, and making it possible to
    do the same for the data.tar entries via the new --root-owner-group option.
    Based on a patch by Niels Thykier <niels@thykier.net>. Closes: #291320
  * Make dpkg-buildpackage error out if --as-root is passed without
    --rules-target.
  * Add support for rootless builds in dpkg-buildpackage by honoring the
    Rules-Requires-Root (R³) field.
  * Add new dpkg-buildflags --query command, which is like --status but in
    deb822 format.
  * Remove long obsolete dselect floppy method.
  * Remove traces of non-US support from dselect methods.
  * Add support for a new Build-Kernel-Version field in .buildinfo files,
    that can be emitted with a new dpkg-genbuildinfo --always-include-kernel
    option. Closes: #873937
  * Make dpkg-genchanges honor substvars in .changes Description field.
    Closes: #856547
  * Add support for source package Description and substvars. This new
    field in the debian/control source stanza will be copied into the .dsc
    file, and will also be used to initialize the new source:Synopsis and
    source:Extended-Description substvars that will be available when
    generating the DEBIAN/control and .changes files. Closes: #555743
  * Add new “future” feature area in dpkg-buildflags:
    - Add new «lfs» feature, to be used instead of the getconf(1) interface
      which cannot support cross-building.
  * Add new buildtools.mk make fragment to support build tools variable
    setup, for both TOOL and TOOL_FOR_BUILD variables. Not included by
    default from default.mk.
  * Make --uniform-compression the new default dpkg-deb behavior. Add support
    for negating the option via --no-uniform-compression.
  * Clarify subprocess error message by shuffling words around.
  * Print the package name on maintainer script errors. Closes: #877521
  * Fix capitalization of Debian in dpkg-deb output messages.
  * Add a policykit file for running update-alternatives via pkexec.
    Propose by Boyuan Yang <073plan@gmail.com>.
  * Perl modules:
    - Switch from Dpkg::Util to List::Util, now that the module in the
      new required Perl contains the needed functions.
    - Add a new "unique_tuple_key" option to Dpkg::Index set_options() to
      set better default "get_key_func" options, which will become the default
      behavior in 1.20.x. Prompted by Johannes Schauer <josch@debian.org>.
    - Mark ppc64 and powerpc as having gcc builtin PIE in Dpkg::Vendor::Debian.
    - Make the Dpkg::Substvars warnings output deterministic.
      Thanks to Chris Lamb <lamby@debian.org>. Closes: #870221
    - Remove unused POSIX module imports.
    - Use Errno module instead of the slow to import POSIX.
    - Remove unused Dpkg::Path from Dpkg::Vendor::Ubuntu.
    - Only load POSIX from Dpkg::Compression::FileHandle if we are going to
      use signal definitions, reducing the load time of many other modules.
    - Only load Dpkg::BuildOptions and Dpkg::Arch from Dpkg::Vendor-specific
      modules if we are going to use them, reducing the load time of many
      other modules.
    - Only load Term::ANSIColor from Dpkg::ErrorHandling if we are going to
      use colors, reducing the load time of many other modules.
    - Move color setup into report_pretty in Dpkg::ErrorHandling.
    - Move printforhelp initialization into usageerr() in Dpkg::ErrorHandling.
    - Avoid many function arguments in Dpkg::Shlibs::SymbolFile parse().
    - Avoid many function arguments in Dselect::Ftp do_connect().
    - Add new Dpkg::Interface::Storable option to disable compression support,
      so that we can load Dpkg::Compression::FileHandle only when enabled.
    - Disable decompression support for Dpkg::Vendor origin files.
    - Move file_lock() function into a new Dpkg::Lock module, to reduce the
      module load chain for several Dpkg modules.
    - Add support for new DPKG_NLS environment variable in Dpkg::Gettext,
      that when set to 0 will disable NLS (i18n) support in the Dpkg modules,
      and reduce the load chain.
    - Disable compression when using the default file in
      Dpkg::Changelog::Parse.
    - Mark all missing CTRL_INDEX_SRC and CTRL_INDEX_PKG fields as allowed
      in Dpkg::Control::FieldsCore.
    - Complete field order for CTRL_PKG_DEB and CTRL_FILE_STATUS types in
      Dpkg::Control::FieldsCore.
    - Switch to use lowercase field names for all internal field name
      handling in Dpkg::Control::FieldsCore, giving a significant speed up.
    - Remove dependency on Dpkg::Checksums from Dpkg::Control::FieldsCore.
    - Do not execute code when importing Dpkg::Control::FieldsCore.
    - Use substr instead of a regex to match the first line characters in
      when parsing control files in Dpkg::Control::HashCore.
    - Merge build flag methods into a single _add_build_flags private method
      in Dpkg::Vendor::Debian.
    - Do not use an intermediate variable in Dpkg::Control::HashCore::Tie
      STORE method.
    - Expect deb822 stanza delimiters more often than OpenPGP Armor Headers
      in Dpkg::Control::HashCore parse method.
    - Optimize trailing space matching on Dpkg::Control::HashCore parse
      method, by trimming it just once at the beginning of the iteration.
    - Optimize trailing space trimming on Dpkg::Control::HashCore parse
      method, by requiring that at least one whitespace is present.
    - Optimize first character matching in Dpkg::Control::HashCore parse
      method, by storing the first character in a variable.
    - Optimize field/value parsing in Dpkg::Control::HashCore parse method,
      by switching from a capturing regex to split() plus a checking regex.
    - Auto-convert binary signatures to OpenPGP ASCII Armor in
      Dpkg::Source::Package when building source packages.
    - Switch Dpkg::Source::Package::V3 modules to use find_command() instead
      of ad-hoc code.
    - Call source format prerequisites Dpkg::Source::Package method if
      present. Addresses: #877688
    - Unify Dpkg::ErrorHandling subprocess errors with the ones from libdpkg.
    - Do not emit a perl warning if gcc or dpkg is not found from Dpkg::Arch,
      the code already handles the commands not being present.
    - Do not unnecessarily require setting the host_arch in Dpkg::Deps.
      Closes: #856396
    - Do not normalize args past a passthrough stop word in Dpkg::Getopt.
      Some commands pass some arguments through to another command, and
      those must not be normalized as that might break their invocation.
      Reported by Helmut Grohne <helmut@subdivi.de>.
  * Documentation:
    - Document currently accepted syntax for changelogs in deb-changelog(5).
      Closes: #858579
    - Mark source:Version substvar in bold in deb-substvars(5).
    - Clarify behavior for dpkg-maintscript-helper. Closes: #857852
    - Use <command-string> instead of <command> for -c argument value in
      dpkg-architecture(1). Reported by Johannes Schauer <josch@debian.org>.
    - Itemize the CTRL_* constants in the Dpkg::Index POD.
    - Update buildinfo information in dpkg-buildpackage man page to match
      the current implementation.
    - Add all source files to POTFILES.in files.
    - Move deb-version man page to section 7.
    - Remove reference to obsolete dpkg-cross(1).
    - Sort control field export markers by tool order in deb-src-control(5).
    - Document Package-Type and Enhances fields in deb-control(5).
    - Write the actual glyphs used to delimit dependency restrictions in
      deb-src-control(5).
    - Move Package-Type description just after the Package field in
      deb-src-control(5).
    - Move udeb-specific fields to the end of the list of fields in
      deb-src-control(5), and mention these are really udeb-specific.
    - Document that dependency fields in binary stanza can have restrictions
      in deb-src-control(5).
    - Clarify that the Testsuite field is comma-separarted.
    - Fix update-alternatives man page section in alternatives/README file
      reference. Closes: #872309
    - Use correct name for archname validator value in dpkg(1) man page.
      Reported by Niels Thykier <niels@thykier.net.
    - Add new deb-src-rules(5) man page.
    - Document that trailing commas are valid in debian/control dependency
      fields, which get stripped when generating output files.
      Prompted by Mattia Rizzolo <mattia@debian.org>.
    - Clarify that sanitize options should not be used for production builds.
    - Remove recommendation to use Pre-Depends for trigger directives from
      deb-triggers(5). Closes: #864882
    - Add new rootless build experimental draft specification.
      Initial proposal by Niels Thykier <niels@thykier.net>, wording fixes
      and spec clarifications by Guillem Jover <guillem@debian.org>.
    - Fix several function signature documentation.
  * Code internals:
    - Switch perl code to use -> operator for function variables.
    - Switch perl code from split() with /\s+/ to ' '.
  * Build system:
    - Require Perl 5.20.2, the version in Debian oldstable (jessie).
    - Use new gcc-7 -Wrestrict and -Wshift-negative-value warnings if
      available.
    - Do not override the default DEPENDENCIES for libdpkg, extend it instead.
    - Install perl man pages in section 3perl.
  * Packaging:
    - Remove preinst maintainer scripts for dselect and dpkg-dev, for an
      ancient /usr/share/doc symlink to directory switch. Closes: #867327
    - Remove now unused libio-string-perl Build-Depends, and versioned
      dpkg-dev as we do not use build profiles any more.
    - Set Rules-Requires-Root field to no.
    - Do not set redundant source compression to xz.
    - Bump Standards-Version to 4.1.0 (no changes needed).
    - Switch to debhelper compatibility level 10.
    - Split alternatives logrotate into its own configuration file to help
      downstreams and derivatives.
    - Remove ancient code recompressing the alternatives database backups
      from xz to gzip in the dpkg daily cron job.
    - Remove Replaces and Breaks for ancient transitions.
    - Remove workaround for ancient gcc lacking stackprotectorstrong support.
    - Remove maintainer script code to handle downgrades to pre-triggers and
      pre-multiarch dpkg versions.
    - Remove alternative logs when purging dpkg (!?).
    - Add support for DPKG_ROOT in dpkg maintainer scripts.
    - Add git and bzr to libdpkg-perl Suggests. Closes: #877688
  * Test suite:
    - Enable perlcritic Documentation::RequirePodSections and
      Miscellanea::ProhibitTies.
    - Disable perlcritic ValuesAndExpressions::ProhibitEscapedCharacter.
    - Add a new all_perl_modules function to Test::Dpkg.
    - Add a new module-version unit test to check that module $VERSION
      matches the newest entry in the CHANGES section.
    - Use Module::Metadata instead of grepping for $VERSION in pod-coverage.
    - Avoid many function arguments in Dpkg_Changelog.t check_options().
    - Add a new unit test for Dpkg::Control::FieldsCore.
    - Switch from IO::String to native open() scalar support.
    - Use UTC0 when setting TZ.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Italian (Pietro Battiston). Closes: #864509
  * Portuguese (Miguel Figueiredo). Closes: #868800
  * Simplified Chinese (Zhou Mo, Boyuan Yang). Closes: #867133, #877929

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #862924
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Tue, 17 Oct 2017 01:51:16 +0200

dpkg (1.18.24) unstable; urgency=medium

  [ Guillem Jover ]
  * Add missing symbols to the libdpkg map file.
  * Fix dpkg-shlibdeps to preserve the Dpkg::Shlibs::find_library() order
    when scanning symbols/shlibs files. This was causing generation of bogus
    dependencies when multiple packages provide the same SONAME on different
    directories. Regression introduced in dpkg 1.18.17. Closes: #860979
  * Make dpkg-maintscript-helper print all unowned files from a directory
    when printing the error message, to ease debugging those problems after
    the fact. Closes: #813454, #860238
    Based on a patch by Bastien ROUCARIÈS <roucaries.bastien@gmail.com>.
  * Add duplicate prevention code for debian/files to dpkg-genbuildinfo, so
    that successive runs with different versions and equivalent build types
    do not generate multiple .buildinfo entries to be uploaded, which is
    similar to what dpkg-gencontrol is doing for .deb files.
  * Fix conffile takeover handling during unpack in dpkg on --root or
    on diversions. Closes: #837051, #858004
  * Fix digest inference for shared conffiles, causing bogus takeover
    unpack errors. Regression introduced in dpkg 1.16.9. Closes: #861217
  * Improve tar entry metadata parsing in dpkg:
    - Do not parse device numbers for non block nor char tar entry objects.
    - Make the existing octal parser more robust, by checking for the
      expected format of leading zeros or spaces, followed by any ASCII
      octal characters (0-7), followed by zero or more space or NULs.
    - Add support for base-256 encoded numeric fields, to support large
      values, for UID/GID, device number, size and even signed timestamps.
      This is necessary not only to be able to store larger values, but to
      cover packages that can already be generated by dpkg-deb, given that
      it uses the system GNU tar when building. Closes: #850834
  * Architecture support:
    - Add support for ARM64 ILP32. Closes: #824742
      Thanks to Wookey <wookey@wookware.org>.
  * Perl modules:
    - Remove obsolete hardening-wrapper support from Dpkg::Vendor::Ubuntu.
      Thanks to Adam Conrad <adconrad@0c3.net>.
    - Bump $Dpkg::Deps::VERSION to match the one documented in CHANGES.
    - Ignore by default debian/files.new and debian/files for all source
      formats in Dpkg::Source::Package, because these are generated files
      with well known pathnames, part of the public interface, and with
      dpkg-genbuildinfo always injecting .buildinfo entries into
      debian/files, this meant this could disrupt previous workflows based
      on not cleaning the source tree.
  * Documentation:
    - Many spelling fixes. Thanks to Josh Soref <jsoref@gmail.com>.
    - Do not include misspellings in changelogs, as that makes detecting them
      more difficult.
  * Build system:
    - Use libexec variable for auxiliary internal programs, and set it to
      /usr/lib on Debian and derivatives.
    - Check that the detected tar is a GNU tar.
    - Check that the detected patch is a GNU patch, so that we get a directory
      traversal resistant patch implementation. This fixes CVE-2017-8283 by
      delegating those checks to patch(1), so that we trap blank-indented
      diff hunks trying to escape from the source tree.
  * Test suite:
    - Add a test case for blank-indented patches which were the cause for
      CVE-2017-8283.
    - Handle files with non-zero sizes in c-tarextract libdpkg test code.

  [ Updated programs translations ]
  * Catalan (Guillem Jover).
  * Czech (Miroslav Kure).

  [ Updated dselect translations ]
  * Catalan (Guillem Jover).

  [ Updated scripts translations ]
  * Catalan (Guillem Jover).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann, David Rabel). Closes: #857449
  * Spanish (Javier Fernández-Sanguino).

 -- Guillem Jover <guillem@debian.org>  Wed, 17 May 2017 13:16:25 +0200

dpkg (1.18.23) unstable; urgency=medium

  [ Guillem Jover ]
  * Handle unmatched arch-qualified virtual packages in dpkg-genbuildinfo,
    instead of letting perl die. Closes: #849944
  * Declare .buildinfo format as stable with version 1.0.
  * Do not depend on cxxabi.h to have declared __cxa_pure_virtual, use
    the same “__cxxabiv1” namespace as specified in the C++ ABI, instead
    of using the “abi” alias intended for use by userland.
    Thanks to Jörg Sonnenberger <joerg@netbsd.org>.
  * Add a comment on any C code switch case that falls through. Fixes new
    gcc-7 warnings.
  * Use snprintf() instead of sprintf() in libdpkg when constructing the ar
    member header, as we might overflow depending on the input data.
  * Portability:
    - Do not redeclare sys_siglist in libcompat when the system does so.
      Thanks to Thomas Klausner <wiz@NetBSD.org>.
    - Rename err variable to ret in start-stop-daemon as the former is a
      function on BSDs.
    - Use 5-argument kvm_getprocs() call form on OpenBSD in start-stop-daemon.
    - Use correct struct kinfo_proc ruid submember name on NetBSD in
      start-stop-daemon.
    - Define _KMEMUSER for NetBSD to get declarations for various
      struct kinfo_proc members in start-stop-daemon.
  * Perl modules:
    - Do not special case EM_SPARC32PLUS for NetBSD in Dpkg::Shlibs::Objdump,
      the code has been fixed in NetBSD as that situation could not happen.
    - Fix read() error handling in Dpkg::Shlibs::Objdump::get_format() to
      gracefully ignore non-ELF files again. Closes: #854536
    - Emit an explicit warning from Dpkg::Shlibs::Objdump::Object::analyze()
      for unknown executable formats instead of relying on objdump doing so.
    - Do not parse bogus ELF binaries in Dpkg::Shlibs::Objdump::get_format().
      Reported by Niels Thykier <niels@thykier.net>.
    - Add ‘.mnt-ignore’ to the default ignore lists in Dpkg::Source::Package,
      as we were already ignoring the ‘_MTN’ pathnames. Closes: #855450
      Thanks to Nicolas Boulenguez <nicolas@debian.org>.
    - Mark kfreebsd-amd64, kfreebsd-i386, sparc and sparc64 architectures as
      having gcc builtin PIE in Dpkg::Vendor::Debian.
    - Switch PIE handling in Dpkg::Vendor::Debian to have no default (!) and
      delegate the setting to gcc or an explicit request by a user. This is
      needed to cope with the general PIE brokenness situation in Debian, and
      the current specific brokenness of a Debian gcc patch mangling the dpkg
      build flags. Closes: #848129, #845550
  * Documentation:
    - Clarify the requirements for deb-conffile(5) pathnames. Closes: #854417
      Proposed by Dieter Adriaenssens <dieter.adriaenssens@gmail.com>.
    - Document dpkg-source --before-build and --after-build in --help output.
    - Document dpkg-buildpackage --ignore-builtin-builddeps in --help output.
  * Build system:
    - Check <sys/proc.h> by also including <sys/param.h>, on several BSD
      systems the header is not self-contained.
    - Handle libmd implementations built into system libc, as found on some
      BSD systems.
    - Do not fail on missing compression libraries or headers on automatic
      detection mode. Regression introduced in dpkg 1.18.14.
  * Test suite:
    - Use the detected perl interpreter instead of a random one from PATH.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #856325

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaer). Closes: #856326

 -- Guillem Jover <guillem@debian.org>  Mon, 06 Mar 2017 05:41:11 +0100

dpkg (1.18.22) unstable; urgency=medium

  [ Guillem Jover ]
  * Turn status file parser errors on bogus field blank lines into warnings,
    otherwise the system cannot be easily recovered from. Regression
    introduced in dpkg 1.16.1. Reported by Jay Freeman <saurik@saurik.com>.
  * Perl modules:
    - Mask ARM ABI bits in the ELF processor flags in Dpkg::Shlibs::Objdump.
      These are too unreliable to be used for exact matching. Closes: #853793

  [ Updated programs translations ]
  * Turkish (Mert Dirik). Closes: #853202

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Wed, 01 Feb 2017 05:48:58 +0100

dpkg (1.18.21) unstable; urgency=medium

  [ Guillem Jover ]
  * Revert "Generate Testsuite-Restrictions fields from the test restrictions
    in dpkg-source into .dsc files". This change is contentious and should
    have been discussed more widely. Given that this has been live only for
    a couple of days, the impact should be minimal, but still something to
    take into account once and if this gets reintroduced. Closes: #852820
  * Perl modules:
    - Map alternative or old ELF machine types to canonical ones. We need
      those to match on the encoded ABI, otherwise dpkg-shlibdeps will not
      be able to find the objects.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sun, 29 Jan 2017 20:29:58 +0100

dpkg (1.18.20) unstable; urgency=medium

  [ Guillem Jover ]
  * Add a new --no-sign option to dpkg-buildpackage, to make it possible to
    disable all signing in a future-proof way.
  * Make dpkg-buildpackage --unsigned-changes not sign .buildinfo either.
    This breaks the expectations of users and tools, because there was no
    way previously to request no signing at all. Closes: #852822
  * Perl modules:
    - Mask the machine bits for SH and MIPS in the ELF processor flags in
      Dpkg::Shlibs::Objdump. These do not define the ABI, and make the
      objects not match when they should, when looking for shared libraries
      from dpkg-shlibdeps.
    - Encode the ELF ABI as a big-endian byte stream, so that decoding for
      output gives meaningful results.
    - Disable the NFS-unsafe warning on Linux, as using flock() on NFS has
      been safe for some time now. Addresses: #677865 (on Linux)
  * Documentation:
    - Document the Built-For-Profile field in deb-changes(5).

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sat, 28 Jan 2017 06:32:53 +0100

dpkg (1.18.19) unstable; urgency=medium

  [ Guillem Jover ]
  * Stop emitting Built-For-Profiles from dpkg-gencontrol. The information
    is already provided in .buildinfo and .changes files, and including it
    in the binary packages makes them unreproducible even when the profile
    used would not alter its contents. Closes: #831524
  * Do not allow empty epochs and revisions in versions. When there's at
    least one colon or one dash, we should expect epoch and revision numbers.
  * Always set SOURCE_DATE_EPOCH in dpkg-buildpackage and dpkg-source. Use
    the current date if the changelog does not have one. Closes: #849081
  * Refactor update-alternatives pathname existence check into a new function.
  * Avoid useless repeated lstat()s in update-alternatives.
  * Only check for debian/tests/control file once in dpkg-source.
  * Generate Testsuite-Restrictions fields from the test restrictions in
    dpkg-source into .dsc files. Closes: #847926
    Based on a patch by Iain Lane <laney@debian.org>.
  * Improve the ELF ABI mismatch detector in dpkg-shlibdeps, by parsing the
    ELF header ourselves. While still not perfect (things like linux-i386 and
    hurd-i386 will still match), it will filter lots of previously matching
    objects that should have been ignored, and will work even when objdump
    does not know about the specific object details. Closes: #849913
  * Add initial support for DEB_BUILD_OPTIONS to dpkg-genbuildinfo. This will
    make it possible to enable or disable specific features that should be
    recorded in the .buildinfo file. For now only “all” and “path” are
    supported. Closes: #848705
  * Add again the architecture from the filename to .changes files for any
    artifact with one. This reverts the change introduced in dpkg 1.18.11.
  * Fold the filtering and checksumming of files to distribute in a .changes
    file in dpkg-genchanges into the initial loop. This way we do not include
    architectures for artifacts we are not going to distribute, and do not
    unnecessarily recompute the checksums for artifacts like the sources.
  * Do not compute the architecture list twice in dpkg-genchanges.
  * Include .buildinfo files also for source-only uploads in dpkg-genchanges.
    Closes: #846164
  * Fix check for expected number of binary artifacts in dpkg-genchanges, to
    only take into account the artifacts that we are distributing.
  * Fix parsing of Pre-Depends and Depends in dpkg-genbuildinfo, so that
    the code parses both and not just the first to appear in the stanza.
    Based on a patch by Johannes Schauer <josch@debian.org>.
  * Add support for signed .buildinfo files to dpkg-buildpackage. Add new
    -ui and --unsigned-buildinfo options. Closes: #843925
  * Portability:
    - On GNU/Hurd try to use the new process executable name attribute from
      libps, to properly match on start-stop-daemon --exec.
  * Perl modules:
    - Fix Debian architecture wildcard parsing so that matching four-tuple
      matchings work. Missed in dpkg 1.18.11.
      Reported by Julian Andres Klode <jak@debian.org>.
    - Add new import tags for Dpkg::Arch.
    - Abort on EOF in patch name prompt in Dpkg::Source::Package::V2,
      instead of getting into an infinite loop. Closes: #851441
    - Call anonymous subs via -> operator instead of casting with &, and fix
      bogus POD documentation to match the code.
    - Add new Auto-Built-Package field to Dpkg::Control::Fields.
    - Add a new debug() reporting function, and switch code to use it.
    - Add new Dpkg::BuildOption parse_features() method refactored from
      Dpkg::Vendor::Debian.
  * Documentation:
    - Cleanup software requirements in README.
    - Move control member file references from dpkg(1) to deb(5).
    - Fix typos in docs and code comments.
    - Document Auto-Built-Package field in deb-control(5).
  * Build system:
    - Disable disk pre-allocation by default, but let the builder re-enable
      it via a new configure option. This has been causing major performance
      issues on "modern" filesystems.
  * Packaging:
    - Add debsig-verify to dpkg Suggests. The code optionally supports this
      specific signed .deb verification program.
      Prompted by Stuart Prescott <stuart@debian.org>.
  * Test suite:
    - Generate and check all currently possible architecture wildcards.
    - Correctly iterate over all default and passed .dsc template substvars.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #851889
  * German (Sven Joachim).

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaer). Closes: #851891
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Fri, 27 Jan 2017 05:43:36 +0100

dpkg (1.18.18) unstable; urgency=medium

  [ Guillem Jover ]
  * Documentation:
    - Document DPKG_DATADIR in an ENVIRONMENT section in dpkg-architecture(1).
    - Add a rationale for the purpose of Testsuite-Triggers in dsc(5).
      Prompted by Mattia Rizzolo <mattia@debian.org>.
  * Packaging:
    - Revert the perl to perl:any dependency change in libdpkg-perl, as that
      breaks debootstrap in stable (jessie), testing (stretch) and unstable,
      which do not support arch-qualified dependencies. We'll have to live
      with the Multi-Arch hinter being unhappy for now.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Tue, 20 Dec 2016 13:53:12 +0100

dpkg (1.18.17) unstable; urgency=medium

  [ Guillem Jover ]
  * Handle empty versions on validation in dpkg-maintscript-helper as they
    are optional. Regression introduced in dpkg 1.18.16. Closes: #848422
  * Validate versions too in dpkg-maintscript-helper symlink_to_dir and
    dir_to_symlink commands.
  * Improve logic to identify packages owning a library in dpkg-shlibdeps,
    by handling the same library appearing more than once on the filesystem
    Thanks to Raphaël Hertzog <hertzog@debian.org>. Closes: #843073
  * Documentation:
    - Clarify that dpkg-buildpackage does not run «dpkg-source --before-build»
      when using the -T option. Closes: #649531
    - Document that dpkg sets DPKG_ADMINDIR on maintainer script environment.
  * Packaging:
    - Do not let dh_perl insert a dependency for libdpkg-perl, because it
      emits perl instead of perl:any. Instead hardcode a perl:any dependency
      to comply with the perl policy and make the Multi-Arch hinter happy.

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 19 Dec 2016 02:43:10 +0100

dpkg (1.18.16) unstable; urgency=medium

  [ Guillem Jover ]
  * Add support for specifying multiple targets on «dpkg-buildpackage -T»
    which will be run successively. Closes: #671074
  * Reject empty upstream versions in C and perl code. These are not permitted
    by deb-version(5), but the code was letting those through.
  * Use lzma_cputhreads() instead of sysconf(_SC_NPROCESSORS_ONLN) as the
    former is way more portable.
  * Automatically decrease xz encoder threads to try to not exceed available
    memory limits. This should alleviate the insane requirements of memory
    needed on 32-bit architectures with many cores, which results in more
    than the userspace addressable memory, when using settings such as
    -z9 and/or -Sextreme in dpkg-deb. Closes: #846564
  * Add new dpkg --validate-<thing> commands to validate the syntax of
    various <thing>s, where the current list is «pkgname», «trigname»,
    «archname» and «version».
  * Use the new dpkg --validate-version command in dpkg-maintscript-helper,
    instead of abusing the --compare-versions command to perform version
    validation. Closes: #844701
  * Allow readlink(2) to return a size smaller than stat(2) in dpkg. Some
    bogus filesystems do not return the actual symlink size in st_size,
    which contradicts POSIX. But allowing the case where the returned size
    is smaller than the one used to allocate memory is harmless, although
    suspect. Let it through, but still print a warning so that users can
    install stuff but are reminded they need to get a fixed filesystem in
    place. This has affected at least ecryptfs in the past and now
    file-based encryption support in ext4 on Android N.
  * Add new dpkg-query virtual field source:Upstream-Version. Closes: #844348
  * Perl modules:
    - Whitelist DPKG_GENSYMBOLS_CHECK_LEVEL, DPKG_ROOT, DPKG_ADMINDIR and
      DPKG_DATADIR environment variables in Dpkg::Build::Info.
  * Documentation:
    - State the current working directory used when running dpkg-buildpackage
      hooks.
    - Add a new ENVIRONMENT section to dpkg-gensymbols(1) and document
      DPKG_GENSYMBOLS_CHECK_LEVEL there.
    - Fix bogus description of --force-confmiss in dpkg(1). Regression
      introduced in 1.16.4. Reported by Sven Joachim <svenjoac@gmx.de>.
      Closes: #846395
    - Update dpkg-parsechangelog parser options. The options specific to
      the changelog parser program did not get updated when the parser got
      switched to be a perl module. Missed in dpkg 1.18.8. Closes: #848189
  * Build system:
    - Enable compression libs also in automatic check mode in configure.
    - Honor DPKG_DATADIR again in the installed Dpkg modules. This was an
      explicit public interface, documented in the man page.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #848378
  * Simplified Chinese (Zhou Mo). Closes: #844955

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).
  * Swedish (Martin Bagge). Closes: #847220

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #848379
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sat, 17 Dec 2016 00:25:53 +0100

dpkg (1.18.15) unstable; urgency=medium

  [ Guillem Jover ]
  * Improve PIE flags support:
    - Do not enable PIE when linking static programs. glibc-based systems
      do not support this combination and produce very bogus output.
      Proposed by Szabolcs Nagy <nsz@port70.net>. Closes: #843714
  * On source builds add 'source' to the Architecture field in the
    .buildinfo file in dpkg-genbuildinfo.
  * Add new Build-Date field to .buildinfo files.
  * Generate deterministic .buildinfo filenames in dpkg-genbuildinfo,
    following the same pattern as used for .changes files.
  * Bump .buildinfo Format to version 0.2.
  * Change dpkg-buildpackage -j and -J on “auto” mode to fallback to serial
    execution when we cannot infer the number of online processors on
    unsupported or exotic systems. This should be a safer mode of operation.
    Proposed by Simon McVittie <smcv@debian.org>.
  * Only preallocate disk size in dpkg for unpacked files bigger than 16 KiB.
    Closes: #824636
  * Perl modules:
    - Validate architecture arguments in Dpkg::Deps deps_parse().
      Prompted by Johannes Schauer <josch@debian.org>.
  * Documentation:
    - Escape dashes in field names in dpkg-buildinfo(1).
  * Test suite:
    - Mark partially documented POD modules as TAP TODO.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Wed, 16 Nov 2016 03:28:05 +0100

dpkg (1.18.14) unstable; urgency=medium

  [ Guillem Jover ]
  * Improve PIE flags support:
    - Rename the spec name cc1_options to self_spec.
      Suggested by James Clarke <jrtc27@jrtc27.com>
    - Do not set PIE options if they have been negated, and do not reset
      them if they have been requested.
    Closes: #843791, #843826
  * Fix use after free error in dpkg. It was trying to print messages that
    had already been freed as part of the database memory pool, causing in
    some cases segfaults when reporting the error summary at the end.
    Regression introduced in dpkg 1.18.11. Closes: #843874
  * Change default color behavior to auto.
  * Perl modules:
    - Fix confusing date parse error message in Dpkg::Changelog::Entry::Debian
      when the date contains “May”. Closes: #843829
      Thanks to Nishanth Aravamudan <nish.aravamudan@canonical.com>.
    - New module Dpkg::Build::Info module refactored from dpkg-genbuildinfo.
      Requested by Johannes Schauer <josch@debian.org>.
  * Documentation:
    - Improve the DEB_BUILD_OPTIONS description in dpkg-buildpackage(1).
      And mention the parallel option there.
    - Explicitly mention in dpkg-buildpackage(1) that setting the number
      of parallel jobs to 1, restores the serial behavior.
      Prompted by Thorsten Glaser <t.glaser@tarent.de>.
  * Packaging:
    - List public Dpkg::Control::Tests module in libdpkg-perl description.
  * Test suite:
    - Do not fail tests on missing fakeroot, just skip them.
  * Build system:
    - Fix inversion logic in libmd configure check when requested explicitly.
    - Do not consider the compressor libraries available in configure if the
      headers are not usable.
    - Fix DPKG_BUILD_RELEASE_DATE to require DPKG_PROG_PERL, as it uses perl.
    - Change DPKG_BUILD_RELEASE_DATE to use perl instead of date(1) to
      format the timestamp, as the former is more portable.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Fri, 11 Nov 2016 02:26:08 +0100

dpkg (1.18.13) unstable; urgency=medium

  * Improve PIE flags support:
    - Retroactively document in the changelog that PIE is enabled by default
      on all supported architectures regardless of gcc doing so itself on a
      subset of them.
    - When emitting PIE flags on architectures where gcc does not inject
      those itself, do it via a specs file too, so that maintainers can
      use them unconditionally regardless of the object being compiled
      or linked.
    - When injecting -no-pie for linking via the gcc specs file also
      inject -fno-PIE.
    - Update the documentation.
  * Perl modules:
    - Do not try to load non-files in Dpkg::Dist::Files load_dir method.
      Fixes test failures on non-Linux architectures. Closes: #843436
  * Packaging:
    - Add missing Breaks on old libdpkg-perl to dpkg. Closes: #843429
      Thanks to Sven Joachim <svenjoac@gmx.de>.
    - Ship deb-src-files(5) man page in dpkg-dev.
  * Build system:
    - Use deterministic dates for generated man pages. Closes: #843469
      Thanks to Reiner Herrmann <reiner@reiner-h.de>.

 -- Guillem Jover <guillem@debian.org>  Mon, 07 Nov 2016 03:28:42 +0100

dpkg (1.18.12) unstable; urgency=medium

  * Build system:
    - Set umask to 0022 for functional test suite.
  * Documentation:
    - Rename FILE FORMATS section to FILES in dpkg-source(1).
    - Use "dpkg suite" as the manual item in man pages .TH macro.
    - Use %VERSION% in dpkg-statoverride(1) source item in man page .TH macro.
    - Document environment variables used by source format modules in
      dpkg-source(1).

 -- Guillem Jover <guillem@debian.org>  Sun, 06 Nov 2016 05:36:20 +0100

dpkg (1.18.11) unstable; urgency=medium

  [ Guillem Jover ]
  * Make dpkg-maintscript-helper conffile commands more robust. Check that
    conffile pathname arguments are absolute paths and verify version number
    to be valid. Thanks to David Kalnischkies <david@kalnischkies.de>.
  * Add support to dpkg-scanpackages for scanning a single binary file.
    Thanks to Javier Serrano Polo <javier@jasp.net>. Closes: #833964
  * Obsolete dpkg-deb bzip2 and lzma compression methods by emitting errors.
  * Remove obsolete dpkg-deb --old and --new options.
  * Remove obsolete dpkg --print-installation-architecture option.
  * Fix dpkg error messages when parsing md5sum files to include the package
    name affected.
  * Do not emit epochs for unambiguous versions in deb-split package header.
    Regression introduced in dpkg 1.18.0.
  * Make the deb-split(5) generation in dpkg-split reproducible, by using the
    timestamp from SOURCE_DATE_EPOCH.
  * Generate reproducible file modes for the .deb control member contents.
    Closes: #787980
  * Switch from non-freeing malloc to m_malloc on statdb slurping.
  * Switch from non-freeing malloc to m_malloc for invoke hooks.
  * Always reset the package in-core database when shutting down the package
    database journal.
  * Do not crash if we pass a NULL cip argument to setaction() in libdpkg.
  * Shutdown the package database journal in dpkg --get-selections.
  * Fix (deactivated) dpkg --command-fd to initialize and reset the files
    database on each action.
  * Implement source stanza substvars prefixed with S: in dpkg-gencontrol.
    These auto-generated variables map each source stanza field into an
    output substvar prefixed with “S:”.
  * Make dpkg-source generate reproducible source packages when run
    standalone, by honoring SOURCE_DATE_EPOCH.
  * Fix several short-lived memory leaks in update-alternatives.
    Reported by Helmut Grohne <helmut@subdivi.de>.
  * Only set the error context message in libdpkg if it has been formatted
    correctly.
  * Return error in error_context_errmsg_format() only if the error message
    gets truncated. In case we have to use the emergency buffer because the
    previous vasprintf() call failed, we should only return an error code if
    the vsnprintf() call on the emergency buffer truncates the output.
  * Fix free() on uninitialized pointer in error_context_errmsg_format() in
    libdpkg. Regression introduced in dpkg 1.18.7. Closes: #842004
  * Move C++ support code into its own file.
  * Add replacement new and delete array operators to C++ support code.
  * Implement local abi::__cxa_pure_virtual. When using g++ if we provide our
    version of this function we can avoid the dependency on either libstdc++
    or libsup++.
  * Include missing <new> for new and delete operator declarations.
  * Do not log nor print duplicate dpkg removal action. We print
    “Removing <package> (<version>)” lines and log remove action twice
    when purging a package from frontends, because they usually first call
    --remove and then --purge sequentially. When purging a package which is
    already in config-files (i.e. it has been removed before), do not print
    nor log the remove action.
  * Remove default «.» from @INC before loading perl modules in perl code.
    Fixes CVE-2016-1238.
  * Give more information on --set-selections warnings. Closes: #842230
  * Add new DEB_*_ARCH_ABI and DEB_*_ARCH_LIBC variables to dpkg-architecture
    and architecture.mk Makefile fragment.
  * Do substvar instantiation just once in dpkg-gencontrol.
  * Fix dpkg-gencontrol to not update the files list file (debian/files)
    when printing to STDOUT (via -O).
  * Do not add architectures to .changes Architecture field for artifacts
    that are not a .deb or .udeb in dpkg-genchanges.
  * Add support for .buildinfo files:
    - Add new dpkg-genbuildinfo command.
    - Hook it into the dpkg-buildpackage machinery.
    Based on a patch by Jérémy Bobbio <lunar@debian.org>. Closes: #138409
  * Enable dpkg-buildpackage -Jauto by default. Closes: #842845
  * Fix dpkg to not fail when removing non-existent backup files on read-only
    filesystems. Closes: #838877
  * Enable PIE on all supported architectures and handle PIE enabled by
    default in gcc. On architectures where gcc enables them by default,
    stop setting -fPIE and -pie, and set -fno-PIE and -no-pie when disabling
    «pie» via gcc specs files, so that we do not emit them on situations
    where it would be inappropriate. Closes: #835149
    Based on a patch by Bálint Réczey <balint@balintreczey.hu>.
  * Architecture support:
    - Add support for AIX operating system.
    - Add a version pseudo-field to the arch tables.
    - Internally represent Debian architectures as quadruplets.
  * Portability:
    - Cast off_t variables to intmax_t when printing them with "%jd".
    - Add missing <string.h> include in libdpkg.
    - Cast strlen() return value to ssize_t to match write() return type.
    - Use underscore-prefixed system preprocessor symbols instead of namespace
      polluting ones (such as “linux”, “OPENBSD” or “hpux”).
    - Handle _POSIX_PRIORITY_SCHEDULING being defined to -1 or 0 in
      start-stop-daemon. This affects Mac OS X.
    - On FreeBSD return STATUS_UNKNOWN instead of false in start-stop-daemon
      do_procinit().
    - Port start-stop-daemon process handling to Mac OS X.
      Based on a patch by Mo McRoberts <mo@nevali.net>.
    - Port start-stop-daemon process handling to AIX.
    - Fix lookup by name on update-alternatives --config. The code was wrong
      and not working at least on Mac OS X, making the test suite to fail.
    - Only use gzip --rsyncable in Dpkg::Compression on Debian and hopefully
      derivatives, by using perl's $Config{cf_by} variable to key on. The
      Debian-specific --rsyncable option should have never been accepted for
      use in dpkg to begin with.
    - Use our own dpkg_ar_hdr struct instead of relying on the system
      ar_hdr struct, as the ar format is not standardized and does vary
      across systems, for example on AIX.
    - Add <sys/sysmacros.h> on AIX for major() and minor().
    - Add missing <errno.h> in libcompat.
    - Include libcompat getopt module when we need getopt_long.
    - Disable gettext support in libcompat getopt module. We do not carry
      translations for this module, and it makes it pull libintl for programs
      that might not use it otherwise.
  * Perl modules:
    - Obsolete Source-Version substvar in Dpkg::Substvars by emitting errors.
    - Rework keyring hooks in Dpkg::Vendor. Deprecate the keyrings hook, and
      add package-keyrings, archive-keyrings and archive-keyrings-historic
      hooks. Prompted by Johannes Schauer <josch@debian.org>.
    - Make the Dpkg::Substavars parse() method return the number of substvars
      parsed.
    - Add new set_field_substvars() method to Dpkg::Substvars.
    - Fix reproducible source package support in Dpkg::Source::Archive, by
      sorting the tar contents with --sort=name.
    - Prefix private Dpkg::Source::Package::* functions with _.
    - Defer filehandle closures in Dpkg::IPC::spawn() to avoid double-close.
      Closes: #839905, #840293
    - Always map the build type to the shortest string form in
      Dpkg::Build::Type::get_build_options_from_type().
    - Change Dpkg::Compression::FileHandle to inherit directly from IO::File
      instead of FileHandle.
    - Add new Dpkg::PROGTAR variable to store GNU tar command name.
    - Add new Dpkg::PROGMAKE variable to store GNU make command name.
    - Add new CTRL_FILE_BUILDINFO type to Dpkg::Control.
    - Add new .buildinfo fields to Dpkg::Control::Fields.
    - Add new builtin-system-build-paths Dpkg::Vendor hook.
    - Cope gracefully with changelogs missing a timestamp trailer.
      Based on a patch by Ian Jackson <ijackson@chiark.greenend.org.uk>.
      Regression introduced in dpkg 1.18.8. Closes: #843248
  * Packaging:
    - Add liblocale-gettext-perl to libdpkg-perl Recommends.
    - Wrap and document dependency relationships.
    - Remove obsolete dependency relationships, since Debian oldstable.
    - Remove update-alternatives, dpkg-divert and dpkg-statoverride
      compatibility symlinks, again.
    - Use perl:Depends via dh_perl instead of a hardcoded perl in Depends.
    - Add perl:Depends to dpkg-dev Depends.
    - Remove unused dh_strip from binary_indep target.
    - Remove ancient upgrade code from maintainer scripts (before 1.15.x).
    - Stop compressing the dpkg.deb package with gzip.
    - Move dpkg to be the first binary package stanza in debian/control, as
      debhelper assigns special meaning by considering it the main package.
    - Set MAKEFLAGS to -jN from parallel=N in DEB_BUILD_OPTIONS.
  * Documentation:
    - Update custom changelog parser API support status in README.api.
    - Fix typos in docs and man pages. Thanks to Jakub Wilk <jwilk@debian.org>
      Closes: #834584
    - Fix formatting in SOURCE_DATE_EPOCH description in dpkg-deb(1).
    - Improve dpkg-deb --build arguments documentation in dpkg-deb(1).
      Prompted by Johannes Schauer <josch@debian.org>.
    - Document the .changes filename that dpkg-buildpackage generates in
      dpkg-buildpackage(1). Prompted by Johannes Schauer <josch@debian.org>.
    - Add basic maintainer script man pages: deb-postinst(5), deb-postrm(5),
      deb-preinst(5) and deb-prerm(5).
    - Add new deb-src-files(5) man page.
      Prompted by Johannes Schauer <josch@debian.org>.
    - Add man page references to other binary control files in dpkg(1).
    - Add version when "new" substvars were introduced in deb-substvars(5).
    - Switch deb-triggers(5) types into a proper list.
    - Itemize --log format entries in dpkg(1).
    - Turn the update-alternatives(1) --query example item into a sub-section.
    - Turn the Multi-Arch values into a list in deb-control(5).
    - Improve user-defined field export marker documentation in
      deb-src-control(5); clarify that X can be followed by zero or more
      (instead of one or more) letters and turn the items into a proper list.
    - Generate the man pages at build time. This makes it possible to process
      them and update several variable strings such as system and package
      pathnames, the release date and the dpkg suite version. And makes it
      possible to use UTF-8 in the source and convert to the more conservative
      groff escape sequences on the output.
    - Switch from groff escape sequences to UTF-8 in man pages sources.
    - Disable hyphenation in man pages globally, because it performs very
      poorly on many technical terms.
    - Append the German man pages addendum at the end of the translation,
      instead of assuming that every page has the SEE ALSO section.
    - Explicitly mention that Dpkg::Checksums::add_from_file() is used to
      verify digests too. Prompted by Johannes Schauer <josch@debian.org>.
    - Document the behavior for consecutive calls to Dpkg perl module parse()
      methods. Prompted by Johannes Schauer <josch@debian.org>.
    - Document obsolete functions in Dpkg::Conf.
  * Test suite:
    - Make test main function a TEST_ENTRY macro. This avoids confusing
      coverage programs, as the file that actually contains the main function
      is the test itself.
    - Rename test suite commands to be prefixed with «c-» instead of «t-».
    - Add new dpkg-source functional tests.
    - Add new dpkg-buildpackage functional tests.
    - Add an initial functional test suite for dpkg-deb and dpkg-split.
    - Skip the involved tests if IO::String is missing.
    - Add new unit test for libdpkg error handling.
    - Delete MAKEFLAGS environment variable when testing make invocations.
    - Pass -q to grep command to suppress matched output in pod-coverage.t.
    - Ignore POD coverage for partially private modules.
  * Build system:
    - Add support for profiling perl modules.
    - Clean up compiler and linker automatic flag usage in configure.
    - Fix the __progname check to avoid the optimizer discarding the symbol.
    - Fix M4sh/Autoconf coding style. Add a new section to coding-style.txt
      describing M4sh/Autoconf.
    - Disable C++ exceptions for dselect.
    - Fix typo in SELinux library detection code, only affecting static
      mode (not used in Debian). Regression introduced in dpkg 1.18.8.
    - Change --with-* option logic to default to check.
    - Disable -Wtautological-constant-out-of-range-compare (for clang).
    - Check the availability of -W<warning> variant instead of -Wno-<warning>.
      As at least gcc and clang do not warn on -Wno-* warning flags, only
      when some unrelated warning needs to be emitted.
    - Bump po4a version to 0.43 (we are using --porefs wrap option).
    - Add support for running the test suite in parallel.
    - Specify exec argument for TAP::Harness to gracefully handle non-perl
      executables with older versions of the module.
    - Require libselinux 2.0.99 for baseline API, remove static linking
      support, use pkg-config unconditionally, and perform refinement checks
      only if available.
    - Check for the required minimal perl version.
    - Use builddir instead of CURDIR in man Makefile.am.
    - Use cp with -R instead of -r (the former is more portable and not
      marked as deprecated by POSIX).
    - Print an actual newline instead of a literal \n in lcov output.
    - Do not honor DPKG_DATADIR on the installed Dpkg module.
    - Pass --as-needed to the linker for dselect to avoid libstdc++ dependency.
      Which makes of dselect the only front-end not pulling the C++ run-time.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #841117
  * German (Sven Joachim).

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #842187
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sun, 06 Nov 2016 03:09:02 +0100

dpkg (1.18.10) unstable; urgency=medium

  [ Guillem Jover ]
  * Fix a short-lived memory leak in dpkg archive argument parsing.
  * When activating file triggers on conffile purge, use the conffile name
    instead of the real pathname it might refer to. This fixes a segfault
    when using --instdir, or when the conffile has been moved around and
    replaced with a symlink to the target.
    Regression introduced in dpkg 1.18.8. Closes: #830267
  * Perl modules:
    - Disable fixdebugpath feature on unsafe characters in the path.
    - Generate reproducible source tarballs by using the new GNU tar
      --clamp-mtime option in Dpkg::Source::Archive, to make sure no file
      in source packages has an mtime later than the changelog entry time.
    - Enable fixdebugpath build flag feature by default.
      Thanks to Mattia Rizzolo <mattia@debian.org>. Closes: #832179
    - Rename various private methods and functions with an underscore prefix
      and unified names.
    - Refactor perl modules directory list into a new function in Test::Dpkg.
  * Test suite:
    - Add new POD coverage author test for public perl modules.
  * Documentation:
    - Document Testsuite-Triggers in dsc(5).
    - Fix deb-changes(5) description to talk about .changes instead of .dsc.
      Reported by HW42 <hw42@ipsumj.de>.
    - Use debian/control as the SYNOPSIS in deb-src-control(5).
    - Add new deb-conffiles(5) man page.
    - Add references to deb-control(5) and deb-triggers(5) in dpkg(1).
    - Fix typos for repeated “the” word.
      Prompted by Valentin Samir <valentin.samir@crans.org> in #830989.
    - Fix misspelled -fdebug-prefix-map flag in dpkg-buildflags(1).
      Reported by Mattia Rizzolo <mattia@debian.org>.
    - Remove mention of source format 1.0 supporting building with upstream
      tarball signatures from dpkg-source(1), as this was disabled in 1.18.8.
    - Document all public methods in Dpkg::Changelog::Entry::Debian.
    - Escape dashes in deb-changes(5) and dsc(5) man pages.
    - Fix typos in dpkg-shlibdeps(1). Closes: #832434
      Thanks to Carsten Leonhardt <leo@debian.org>.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Turkish (Mert Dirik). Closes: #832070

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sun, 31 Jul 2016 12:57:02 +0200

dpkg (1.18.9) unstable; urgency=medium

  * Require Dpkg::Control::Info in dpkg-buildpackage.
    Initially reported by Helmut Grohne <helmut@subdivi.de>.
    Regression introduced in dpkg 1.18.8. Closes: #829542
  * Documentation:
    - Fix user configuration filename in dpkg-buildpackage(1).
      Thanks to Sven Joachim <svenjoac@gmx.de>. Closes: #829546

 -- Guillem Jover <guillem@debian.org>  Mon, 04 Jul 2016 09:23:13 +0200

dpkg (1.18.8) unstable; urgency=medium

  [ Guillem Jover ]
  * Do not disable PIE buildflags on */kFreeBSD anymore. Closes: #823877
    Thanks to Steven Chamberlain <steven@pyro.eu.org>.
  * Add new long options in dpkg-buildpackage for any short option that is
    a useful configurable candidate.
  * Add configuration file support to dpkg-buildpackage, as buildpackage.conf
    under either the dpkg system or user configuration directories.
    Closes: #539692, #765494
  * Check that debian/tests/control is a regular file before parsing it.
  * Generate Testsuite-Triggers field from test dependencies in dpkg-source
    into .dsc files. Based on a patch by Martin Pitt <martin.pitt@ubuntu.com>.
    Closes: #779559
  * Add new dpkg-source --no-overwrite-dir extraction option. Closes: #826334
  * Fix number of entries computation returned by sysctl() on */kFreeBSD in
    start-stop-daemon.
  * Set return buffer length for sysctl(2) calls on */kFreeBSD in
    start-stop-daemon.
  * Abstract ar archive handling behind a new struct dpkg_ar and functions.
  * On dpkg --force-chrootless only set changedir to instdir if defined.
    Thanks to Niall Walsh <niallwalsh@celtux.org>. Closes: #824542
  * Set primary group to 0 in dpkg when running as root.
    Reported by Stuart Prescott <stuart@debian.org>.
  * Activate file triggers for conffiles on purge, which has never happened
    before. Before dpkg 1.17.0, conffiles were triggered on removal, which
    was obviously wrong. Reported by Helmut Grohne <helmut@subdivi.de>.
  * Fix strtol() errno check when parsing the COLUMNS envvar in dpkg-query.
    Thanks to Sven Joachim <svenjoac@gmx.de>. Closes: #827265
  * Use new GNU tar --clamp-mtime option in dpkg-deb to make sure no file in
    binary packages has an mtime later than the given time. Closes: #759886
  * Use the same timestamp for the ar container as for tarball mtime clamping
    in dpkg-deb.
  * Set ar timestamp and tar mtime clamping to SOURCE_DATE_EPOCH if defined
    in dpkg-deb. Based on a patch by Jérémy Bobbio <lunar@debian.org>.
  * Preset build timestamp to latest changelog entry in dpkg-buildpackage,
    by setting SOURCE_DATE_EPOCH environment variable if it is not already
    defined. Based on a patch by Jérémy Bobbio <lunar@debian.org>.
    Closes: #759999
  * Do not use the debian/rules build target fallback when building both
    architecture independent and dependent packages in dpkg-buildpackage.
  * Use architecture «all» as part of the .changes filename when building
    architecture independent binaries and no architecture dependent binaries.
    Closes: #826161
  * Do not emit warnings from dpkg-genchanges for automatic debug symbol
    packages that are not found in debian/control.
  * Export SOURCE_DATE_EPOCH from pkg-info.mk makefile snippet.
    Closes: #824572
  * Architecture support:
    - Add TILE-Gx support to cputable. Closes: #823167
      Thanks to Helmut Grohne <helmut@subdivi.de>.
  * Perl modules:
    - Use warnings::warnif() instead of carp() for deprecated warnings.
    - Add new format_range() method and deprecate dpkg() and rfc822() methods
      in Dpkg::Changelog.
    - Replace changelog program parsers with perl modules.
    - Add a getter for the Time::Piece object in Dpkg::Changelog.
    - Add new Timestamp field to Dpkg::Changelog output, which ends up on
      dpkg-parsechangelog's output.
    - Validate source version in set_version_substvars()'s Dpkg::Substvars
      method.
    - Revert "Dpkg::Conf: Switch implementation to be hash based", as this
      change broke backwards compatibility in multiple ways. The format_argv
      option was set by default, the order was not preserved, which was
      important for dpkg.cfg files, and duplicate option names stopped being
      supported. Add regression tests to avoid similar changes in the future.
      Closes: #824938
    - Add support for system and user config loading in Dpkg::Conf.
    - Add support for autopkgtest control files, with new CTRL_TESTS control
      type, new recognized fields to Dpkg::Control::Fields, and new modules
      Dpkg::Control::Tests and Dpkg::Control::Tests::Entry. Also update
      Dpkg::Index to support these.
    - Fix Dpkg::Deps so that architecture qualifiers only imply one another
      if they are the same. Closes: #745366, #827628
    - Add support for new environment variable DEB_BUILD_PATH to be able to
      control the path in the fixdebugpath feature in Dpkg::Vendor::Debian.
    - Preserve order when prepending shared library paths in Dpkg::Shlibs.
      This fixes the order of paths passed via dpkg-shlibdeps -l option.
      Closes: #823805
    - Check whether dependency restrictions are implied in Dpkg::Deps::Simple.
      Thanks to Ben Hutchings <ben@decadent.org.uk>. Closes: #827633
    - Disable upstream tar signature when building format 1.0 source packages
      in Dpkg::Source::Package::V1, as the current stable dpkg series do not
      support extracting them.
    - Preset Last-Update field in patch header template with current time in
      Dpkg::Source::Package::V2. Thanks to Daniel Shahaf <danielsh@apache.org>.
      Closes: #828146
  * Packaging:
    - Disable libmd usage in Debian and derivatives for now.
  * Build system:
    - Stop allowing to set deprecated bzip2 compressor as dpkg-deb default.
    - Use libmd automatically if available.
    - Uniformize library build options, from --with-zlib to --with-libz,
      --with-bz2 to --with-libbz2 and --with-selinux to --with-libselinux.
  * Test suite:
    - Bump perlcritic ValuesAndExpressions::RequireNumberSeparators minimum
      to 99999.
    - Add new pod-spell unit test.
    - Refactor common unit test checks for needed things into Test::Dpkg.
    - Accept perl's Lancaster Consensus AUTHOR_TESTING variable.
    - Add new minimum perl version unit test.
    - Add new synopsis unit test.
    - Add unit tests for dependency simplification with build profiles.
  * Documentation:
    - Improve dpkg-buildpackage(1) on environment expectations.
    - Clarify the format of the db:Status-Abbrev virtual field in
      dpkg-query(1). Closes: #824515
    - Document the tar entry size limitation for deb(5) format.
    - Document interaction between PIE and libraries in dpkg-buildflags(1).
      Based on text by Christian Seiler <christian@iwakd.de>.
    - Merge ENVIRONMENT sections in dpkg-buildflags(1).
    - Document various long options in dpkg-source --help output.
    - Move dpkg-source -q option from “Build options” to “General options”
      section in --help output.
    - Clarify shared library search order in dpkg-shlibdeps(1).
    - Remove most remaining AUTHOR sections from man a POD, as they are
      strongly discouraged, for being redundant, tending to get out-of-sync,
      and their format being inconsistent. In addition most got already
      removed in the past for the man pages.
    - Mark perlcritic as an optional author test dependency in the README.
    - Fix example code in Dpkg::Compression::FileHandle SYNOPSIS.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Simplified Chinese (Zhou Mo). Closes: #824873

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Sun, 03 Jul 2016 19:01:56 +0200

dpkg (1.18.7) unstable; urgency=medium

  [ Guillem Jover ]
  * Add new dpkg-source --require-strong-checksums option and change default.
    There is no point in erroring out on this condition when signature issues
    are only warnings, because we cannot guarantee we have functional keys
    for old signatures. Regression introduced in dpkg 1.18.5. Closes: #823428
  * Stop using several fixed sized buffers for program reporting, which in
    many cases could cause confusing truncation of long messages. Use heap
    allocated formatted strings instead:
    - In start-stop-daemon to report what to stop.
    - In dselect to print main and access methods menu entries.
    - In libdpkg command-line option parsing errors.
    - In libdpkg warning, notice and info reporting.
    - In libdpkg ohshit, ohshitv, ohshite and internerr. But in this case
      fallback to a fixed-size emergency buffer in case of allocation or
      formatting error, so that we can at least print something, even if
      truncated.
    Prompted by Manuel A. Fernandez Montecelo <mafm@debian.org>.
  * Colorize all fatal-error printing codepaths in libdpkg.
  * Architecture support:
    - Bump the GNU triplet cpu from i386 to i686 to match toolchain changes.
      Thanks to Ben Hutchings <ben@decadent.org.uk>. Closes: #823619
    - Clarify column descriptions in architecture table files.
  * Perl modules:
    - Relax dependency restrictions parsing to allow again sloppy spaces
      around versions, architectures and profile restrictions.
      Regression introduced in 1.18.5. Closes: #823431
    - Add new require_strong_checksums option to Dpkg::Source::Package.
    - Add new tests_dep option to Dpkg::Deps deps_parse() to allow the
      otherwise invalid ‘@’ character in dependencies. To be used when
      parsing the debian/tests/control file.
  * Documentation:
    - Shorten example symbol names in dpkg-gensymbols to avoid a mandb
      warning due to unwrappable lines in translations.

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 09 May 2016 03:19:52 +0200

dpkg (1.18.6) unstable; urgency=medium

  [ Guillem Jover ]
  * Fix file queue tail assignment on file queue pop during unpack. This
    could mess up the file queue in some circumstances and leave behind
    files in the filesystem as «pathname».dpkg-new after configuration
    and without traces of the files in the dpkg database. Closes: #823288
  * Use m_strdup() instead of strdup() in dpkg recursive installation code.
  * Fix off-by-one array allocation in dpkg recursive installation code that
    can cause segfaults.
  * Rename sysctl() “name” variable to “mib”, to avoid a clash with the
    call site function argument with the same name in start-stop-daemon.
    This fixes a build failure on */kFreeBSD systems.
  * Initialize number of entries on initial process scan in start-stop-daemon
    on */kFreeBSD.
  * Packaging:
    - Bump Standards-Version to 3.9.8 (no changes needed).

  [ Updated programs translations ]
  * German (Sven Joachim).

 -- Guillem Jover <guillem@debian.org>  Tue, 03 May 2016 20:17:05 +0200

dpkg (1.18.5) unstable; urgency=medium

  [ Guillem Jover ]
  * Print correct integer parse error for short-only command-line options.
    This affects «dpkg-deb -z». Closes: #809174
  * Do not abort when traversing symlinks to directories in dpkg-scanpackages
    and dpkg-scansources. Closes: #809219
  * Implement delete operator with size argument in dselect, required by the
    C++14 spec when the size-less delete operator is defined.
  * Use EACCES instead of EWOULDBLOCK for fcntl(2) F_SETLK in dselect.
  * Print the archive filename when dpkg cannot access it.
  * Check that all passed archive filenames to dpkg exist before queuing them.
    Closes: #809963
  * Use ohshit() instead of internerr() for unhandled dpkg-split exit codes.
    (i.e. do not abort). Closes: #812679
  * Detect non-regular file archive arguments earlier in dpkg.
  * Switch URLs in docs, code comments and packaging, from http:// or git://
    to https:// if the latter is available (round three). This includes the
    dpkg git repository, copyright format URL and examples in man pages among
    others.
  * Clarify where to find the GPL-2 license in debian/copyright.
  * Do not enable stack-protector on nios2 in Debian and derivatives (it is
    not supported by gcc yet).
  * Check first for build type to short-circuit boolean expressions in
    dpkg-genchanges.
  * Add source format backend-specific --help options support to dpkg-source.
  * Add MIPS R6 architectures to arch tables. Closes: #807340
    Thanks to YunQiang Su <wzssyqa@gmail.com>.
  * Fix memory leak when unpacking conffiles.
  * Use fixed string matching for pathnames in dpkg-maintscript-helper.
    Thanks to Carsten Hey <carsten@debian.org>.
  * Quote shell variables in dpkg-maintscript-helper.
    Thanks to Carsten Hey <carsten@debian.org>.
  * Anchor pathnames in sed and grep regexes in dpkg-maintscript-helper.
    Thanks to Carsten Hey <carsten@debian.org>.
  * Allow broken versions starting with a dash in dpkg-maintscript-helper.
    Thanks to Carsten Hey <carsten@debian.org>.
  * Add a new treewalk module in libdpkg, with the nice properties of avoiding
    duplicate stat(2) calls, not calling find(1), and sorting the output w/o
    stalling on the entire input being slurped and sorted.
    - Use it to build the .deb data member in dpkg-deb.
    - Use it to build the .deb control member in dpkg-deb.
    Closes: #719845
    - Use it with dpkg --recursive option.
  * Unify start-stop-daemon --help output with the rest of the tools.
  * Search for debsig-verify in PATH instead of using an absolute path.
  * Do not error out when failing to open the SE label db on permissive mode.
    Closes: #811037
  * Rewrite the trigger deferred file parser from flex to manual. The format
    is very simple, and a simple hand-written parser is smaller and avoids a
    build dependency.
  * Be more strict when parsing the COLUMNS environment variable in dpkg-query.
  * Make the Architecture field mandatory on package builds.
  * Use new Dpkg::Arch functions to validate and parse architectures when
    building source packages. Closes: #784808
  * Do safe matching of directories containing conffiles in
    dpkg-maintscript-helper, instead of using a variable pathname as a regex
    with grep, which is susceptible to metacharacters acting as part of the
    regex. Proposed by Carsten Hey <carsten@debian.org>.
  * Decouple local keyword declaration from command assignment in
    dpkg-maintscript-helper, which masks the command return value when
    using «set -e».
  * Make dpkg pass <new-version> to maintscript actions that cannot get it
    otherwise. These actions are now:
    - <new-postrm> failed-upgrade <old-version> <new-version>
    - <new-postrm> abort-install <old-version> <new-version>
    - <new-postrm> abort-upgrade <old-version> <new-version>
    - <new-preinst> install <old-version> <new-version>
    - <new-preinst> upgrade <old-version> <new-version>
    - <new-prerm> failed-upgrade <old-version> <new-version>
    Prompted by Andrey Utkin <andrey.krieger.utkin@gmail.com>.
  * Promote a print to a warning for missing control files in dpkg-deb.
  * Use info() instead of print in dpkg-buildpackage and dpkg-genchanges.
  * Add very basic color support to all dpkg namespaced programs, enabled by
    setting the environment variable DPKG_COLORS to “auto”, “always” or
    “never”, the latter being the default.
  * Add support for a new --build option to define build type by a
    comma-separated list of components (“source”, “any”, “all”, “binary” or
    “full”) in dpkg-genchanges and dpkg-buildpackage.
  * Add new -I option to dpkg-shlibdeps to ignore package build directories.
    Closes: #821025
  * Add new -O option to dpkg-genchanges.
  * Make dpkg export variable DPKG_ROOT in maintainer scripts. Closes: #804624
    Thanks to Helmut Grohne <helmut@subdivi.de>.
  * Add new --force-script-chrootless option to dpkg.
    Thanks to Helmut Grohne <helmut@subdivi.de>.
  * Portability:
    - Move DPKG_ADMINDIR environment variable name out from update-alternatives
      code, to make life easier for non-dpkg-based systems.
    - Move alternatives temporary extension out from update-alternatives code,
      to make life easier for non-dpkg-based systems.
    - Switch start-stop-daemon on */kFreeBSD to use the low-level sysctl(3)
      interface instead of libkvm-dev.
  * Perl modules:
    - Add new CTRL_REPO_RELEASE control block type to Dpkg::Control.
    - Add new CTRL_COPYRIGHT_HEADER, CTRL_COPYRIGHT_FILES and
      CTRL_COPYRIGHT_LICENSE control block types to Dpkg::Control.
    - Make patching a file multiple times fatal for the first quilt patch in
      Dpkg::Source. Reported by Apollon Oikonomopoulos <apoikos@debian.org>.
      Closes: #810720
    - Only warn once when a diff patches a file multiple times in
      Dpkg::Source::Patch, and fix the warning message to make it clear that
      the diff might be patching the file more than once, not just twice.
    - Check existence of search criteria in Dpkg::Index when checking with a
      regex or a string match. Closes: #780906
      Base on a patch by Daniel Dehennin <daniel.dehennin@baby-gnu.org>.
    - Add new functions to validate and parse architecture names in Dpkg::Arch.
    - Make the dependency parser more strict in Dpkg::Deps. Closes: #784806
    - Add strong digest marking support to Dpkg::Checksums.
    - Error out on source packages without any strong digests in
      Dpkg::Source::Package, used by dpkg-source --extract, which can still
      be disabled with --no-check.
    - Switch Dpkg::Conf implementation to be hash based, add two new accessors
      and a new option to the filter method to use the old behavior.
    - Do not parse entry multiple times in Dpkg::Changelog::Entry::Debian.
      Add new parse_header() and parse_trailer() methods, and deprecate
      check_header() and check_trailer() ones.
    - Use “GnuPG” instead of “gpg” in error messages to refer to the software
      in Dpkg::Source::Package.
    - Handle undef versions in Dpkg::Changelog from empty versions in
      changelog entry header lines.
    - Allow detached upstream orig tarball signatures when extracting
      version 1.0 non-native source packages.
    - Include upstream orig tarball signatures in source packages.
      See #759478.
    - Add fixdebugpath to reproducible feature in Dpkg::Vendor::Debian.
      Thanks to Daniel Kahn Gillmor <dkg@fifthhorseman.net>. Closes: #819194
  * Build system:
    - Fix building development documentation.
    - Remove unused UA_LIBS variable.
    - Split libps and libkvm detection into their own macros and variables.
    - Make it possible to build without system libmd.
    - Add a configuration summary to configure output.
    - Make git log invocation immune to local configuration.
    - Do not require passing the perl interpreter to run-script.
    - Quote dirname argument in run-script, to handle spaces in pathname.
      Reported by Carsten Hey <carsten@debian.org>.
    - Use a single po4a opt argument instead of the same per language.
  * Packaging:
    - Enable all hardening flags, starting with gcc-5 there is no performance
      loss anymore when enabling PIE on i386.
  * Test suite:
    - Add a unit test to compile perl code with warnings.
    - Add a unit test for the trigger deferred parser.
  * Documentation:
    - Say value instead of option in deb-control(5).
    - Mark debian changelog format in bold in dpkg-parsechangelog(1).
    - Add references to man pages describing file formats.
    - Document missing Install-Size, Built-For-Profiles and Build-Profiles
      fields in man pages.
    - Add new dsc(5), deb-changelog(5) and deb-changes(5) man pages.
    - Remove Debian specific policy references.
    - Remove superfluous SEE ALSO references from dpkg-source(1).
    - Fix --remove and --purge summary formatting in dpkg(1).
    - Move --audit description just after --verify in dpkg(1).
    - Mark Maintainer field as bold in deb-src-control(5).
    - Fix reference to --record-avail instead of nonexistent --avail.
    - Add missing quotes in man pages.
    - Document Source field version in deb-control(5).
    - Add new deb822(5) man page.
    - Document and improve C/C++ programs exit codes in man pages.
    - Clarify dpkg --path-exclude/--path-include pathname filter behavior.
      Closes: #811267
    - Clarify that packages are only automatically forgotten by dpkg if they
      contain no user data, such as package selections. Closes: #813179
    - Fix documentation for package flags in dpkg(1).
    - Clarify that deb-symbols(5) documents the binary format subset, and
      the template symbol files are described in dpkg-gensymbols(1).
      Closes: #795163
    - Update field requirements of control file formats to match dpkg reality.
    - Document the format of the origins filename in deb-origin(5).
    - Add list of flags set by bug feature area to dpkg-buildflags(1).
    - Switch output encoding of man pages to UTF-8.
    - Move SEE ALSO section to the end of Dpkg::Changelog::Debian.
    - Clarify that i386 does not suffer performance loss due to PIE anymore
      since gcc >= 5 in dpkg-buildflags(1).
    - Document in deb822(5) that deb-origin(5) also supports comments.
    - Clarify which characters constitute the deb822(5) control files syntax
      by using Unicode code points and their printable characters.
      Based on a patch by Ben Finney <ben@benfinney.id.au>.
    - Remove wrong mention that deb-control(5) support comments.
    - Make explicit that deb-control(5) documents the binary control file.
    - Add missing value for Standards-Version field in dsc(5).
      Reported by Helge Kreutzmann <debian@helgefjell.de>.

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #822797
  * German (Sven Joachim).
  * Japanese (Takuma Yamada). Closes: #819939
  * Portuguese (Miguel Figueiredo).
  * Simplified Chinese (Zhou Mo). Closes: #809517
  * Vietnamese (Trần Ngọc Quân).

  [ Updated dselect translations ]
  * Japanese (Takuma Yamada). Closes: #819940

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ New man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #822798

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 02 May 2016 04:14:57 +0200

dpkg (1.18.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Switch dpkg-scansources and dpkg-scanpackages to use File::Find instead
    of find(1), as the former is more portable with more consistent behavior,
    and always canonicalizes the pathnames. Closes: #800649
  * Initialize Config-Version also for packages previously in triggers-pending
    state, otherwise we end up not passing the previously configured version
    to «postinst configure», which might consider this a first install instead
    of an upgrade. Closes: #801156
  * Fix memory leaks in «dpkg --verify» and dpkg infodb format upgrade logic.
  * Merge all update-alternatives action handling into a single if-else-if
    block, to unify the code an allow a future switch into a shared library.
  * Perform any necessary cleanups on normal exit from dpkg-divert --add and
    --remove commands.
  * Make dpkg-architecture warning on non-matching GNU system type compiler
    agnostic.
  * Add ‘.gitreview’ to the default dpkg-source ignore lists.
  * Add support for DPKG_MAINTSCRIPT_DEBUG environment variable to dpkg.
  * Fix dpkg-checkbuilddeps exit code to be 1 instead of a random error value
    on unsatisfied dependencies. Regression introduced in dpkg 1.18.3.
  * Fix an off-by-one write access in dpkg-deb when parsing the old format
    .deb control member size. Thanks to Hanno Böck <hanno@hboeck.de>.
    Fixes CVE-2015-0860.
  * Fix an off-by-one read access in dpkg-deb when parsing ar member names.
    Thanks to Hanno Böck <hanno@hboeck.de>.
  * Add experimental multi-threaded xz compression support in libdpkg, which
    requires xz >= 5.2.0.
  * Fix physical file offset comparison in dpkg. Closes: #808912
    Thanks to Yuri Gribov <tetra2005@gmail.com>.
  * Fix usage of dpkg-architecture -s after other action options.
    Reported by Niels Thykier <niels@thykier.net>.
  * Add NIOS2 support to cputable. Thanks to Marek Vasut <marex@denx.de>.
  * On Debian and derivatives enable timeless build flag feature by default.
    Thanks to Paul Wise <pabs@debian.org>. Closes: #805872
  * Perl modules:
    - Add support for Build-Essential field. Closes: #806315
  * Test suite:
    - Improve perl code test coverage.
  * Build system:
    - Set PERL5LIB globally for the test suite to the local modules directory,
      to avoid using the system modules. Regression introduced in dpkg 1.17.8.
      Reported by Jérémy Bobbio <lunar@debian.org>. Closes: #801329
    - Use absolute buildir pathnames in PATH variable for the test suite.
    - Descend into scripts directory when cleaning up code coverage files.
    - Add new configure option --disable-devel-docs to select the kind of docs
      to generate, default for now is development documentation.
    - Try to use AM_GNU_GETTEXT_REQUIRE_VERSION to benefit from the latest
      installed gettext version, while guaranteeing a minimal required version.
  * Packaging:
    - Add missing Build-Depends for restriction formula support.
  * Documentation:
    - Move description for “target architecture” from the dpkg-architecture(1)
      ‘-A’ option to the TERMS section. Closes: #799046
    - Clarify that the md5sum check on «dpkg --verify» is performed on the
      file contents, and failures denote changed content. Closes: #760248
    - Document that dpkg-buildpackage -nc -S implies -d.
    - Clarify role of Build-Depends in deb-src-control(5).
      Prompted by Johannes Schauer <j.schauer@email.de>.
    - Document supported feature areas.
    - Clarify in dpkg-query(1) when binary:Package gets arch-qualified.
      Closes: #801958
    - Add a subsection separating external from internal environment variables
      in dpkg(1).

  [ Updated programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #800513
  * Japanese (Kenshi Muto). Closes: #799432
  * Turkish (Mert Dirik). Closes: #799875

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann, Julian R). Closes: #807156

 -- Guillem Jover <guillem@debian.org>  Fri, 25 Dec 2015 13:20:26 +0100

dpkg (1.18.3) unstable; urgency=medium

  [ Guillem Jover ]
  * Fix short-lived memory leaks in start-stop-daemon. As a side effect now
    a missing group after ‘:’ on --chuid is a fatal error.
  * Print the master and slave links in «update-alternatives --display».
  * Print the current best alternative in the head instead of the trail
    in «update-alternatives --display», with a two space indentation.
  * Reimplement «update-alternatives --all» as a fully built-in command
    instead of executing itself with --config per subtask.
  * Reimplement «update-alternatives --set-selections» as a fully built-in
    command instead of executing itself with --set or --auto per subtask.
  * Add kfreebsd-armhf support to ostable and triplettable. Closes: #796283
    Thanks to Steven Chamberlain <steven@pyro.eu.org>.
  * Fix «dpkg --verify» with --root.
  * Fix an off-by-one write access in dpkg-deb when parsing the .deb magic.
    Reported by Jacek Wielemborek <d33tah@gmail.com>. Closes: #798324
  * Split overlong perl regexes into multiline extended regexes.
  * Switch dselect multicd method license from GPL2 to GPL2+, with consent
    from all its authors.
  * Fix inadvertent license change for lib/dpkg/utils.c from GPL2 to GPL2+.
  * Fix segfault when using «dpkg --no-act» with a synthetic --admindir.
    Reported by David Kalnischkies <david@kalnischkies.de>.
  * Perl modules:
    - Only warn on invalid week days instead of aborting in
      Dpkg::Changelog::Entry::Debian. Regression introduced in dpkg 1.18.2.
      Reported by Jakub Wilk <jwilk@debian.org>.
    - Do not warn when removing an empty subdirectory on source package
      extraction in Dpkg::Source::Package::V2. Closes: #796671
    - Do not abort on parse errors from Time::Piece->strptime() for the
      changelog trailer date, just queue them so that the caller can decide
      if they should be warnings or actual errors. Closes: #795936
    - Validate the changelog trailer date, and catch and warn or error on
      bogus month names, such as unknown or unabbreviated ones.
  * Test suite:
    - Get the reference build flags from dpkg-buildflags.pl, instead of
      hardcoding them, which might not match depending on the architecture.
      Closes: #794694
    - Delete any environment variable starting with DEB_ in mk.t that might
      affect the test results.
  * Build system:
    - Add a new --with-devlibdir configure option for the C libdpkg library.
  * Packaging:
    - Remove unneeded --sourcedir options from dh_install calls.
    - Use the new --with-devlibdir configure option to only switch libdpkg-dev
      files to the multi-arch directory. Closes: #794977
  * Documentation:
    - Fix typos for --predep-package option name. Closes: #794688
    - Add missing dashes to package-list in deb-src-control(5).
    - Mark each individual required field as such, instead of using segregated
      sections.

  [ Updated programs translations ]
  * Catalan (Jordi Mallach).
  * French (Sébastien Poher). Closes: #798371
  * German (Sven Joachim).
  * Vietnamese (Trần Ngọc Quân).

  [ Updated dselect translations ]
  * French (Sébastien Poher). Closes: #798370

  [ Updated scripts translations ]
  * French (Sébastien Poher). Closes: #798369
  * German (Helge Kreutzmann).

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Mon, 21 Sep 2015 07:11:42 +0200

dpkg (1.18.2) unstable; urgency=low

  [ Guillem Jover ]
  * Fix plural form translations for single plural languages. Closes: #790025
  * Add new dpkg-buildpackage -J option, which is a safe version of -j.
  * Fix dpkg-gencontrol to add correct binary filename to debian/files,
    even when overriding the Package field value with the -D option.
    Reported by Niels Thykier <niels@thykier.net>.
  * Move the implicit build-essential:native Build-Depends from
    dpkg-checkbuilddeps to a new vendor hook, as it is Debian-specific.
  * Add support for ignoring built-in build dependencies and conflicts
    with the new «dpkg-buildpackage --ignore-builtin-builddeps» and
    «dpkg-checkbuilddeps -I» options. Closes: #480638, #571671
  * When sys_siglist is defined in the system, try to use NSIG as we cannot
    compute the array size with sizeof(). If NSIG is missing fallback to 32
    items. Prompted by Igor Pashev <pashev.igor@gmail.com>.
  * Use string_to_security_class() instead of a literal SECCLASS value in
    the setexecfilecon() libcompat function, as <selinux/flask.h> is now
    deprecated.
  * Switch libdpkg xz compressor to use CRC64 for integrity checks, to match
    the default on the command-line tool, which should provide slightly better
    detection against damaged data, at a negligible speed difference.
  * Only use the SHELL environment variable for interactive shells.
    Closes: #788819
  * Move tar option --no-recursion before -T in dpkg-deb. With tar > 1.28 the
    --no-recursion option is now positional, and needs to be passed before
    the -T option, otherwise the tarball will end up with duplicated entries.
    Thanks to Richard Purdie <richard.purdie@linuxfoundation.org>.
  * Add an extra level of escaping for double $(evals) in architecture.mk
    and buildflags.mk, so that the variables are computed lazily again.
    Regression introduced in dpkg 1.16.2. Closes: #793330
  * Add binary packages Essential information to Package-List field in the
    .dsc file, as optional essential=yes entries. This allows precomputing
    the pseudo-essential set before starting an architecture bootstrap.
  * Perl modules:
    - Remove non-functional timezone name support from
      Dpkg::Changelog::Entry::Debian.
    - Use Time::Piece (part of the perl core distribution) instead of
      Date::Parse in Dpkg::Changelog::Entry::Debian. This reduces the build
      and run-time dependencies, and helps architecture bootstrapping.
    - Simplify distribution splitting in Dpkg::Changelog::Entry::Debian.
    - Add new function changelog_parse_plugin() in Dpkg::Changelog::Parse.
    - Add new function changelog_parse_debian() in Dpkg::Changelog::Parse, and
      use it in changelog_parse() instead of the external plugin parser when
      the input format is “debian”. This significantly speeds up the parsing.
    - Remove trailing space before handling blank line dot-separator in
      Dpkg::Control::HashCore. Regression introduced in dpkg 1.18.0.
